export declare const colorDecisionAndCorrespondingOptions: readonly [{
    readonly colorDecisionName: "--background-default-grey";
    readonly themePath: readonly ["background", "default", "grey", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "grey";
        readonly usage: "default";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-1000-50";
        readonly themePath: readonly ["grey", "_1000_50", "default"];
        readonly color: {
            readonly light: "#ffffff";
            readonly dark: "#161616";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 1000;
                };
                readonly dark: {
                    readonly value: 50;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-default-grey-hover";
    readonly themePath: readonly ["background", "default", "grey", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "grey";
        readonly usage: "default";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-1000-50-hover";
        readonly themePath: readonly ["grey", "_1000_50", "hover"];
        readonly color: {
            readonly light: "#f6f6f6";
            readonly dark: "#343434";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 1000;
                };
                readonly dark: {
                    readonly value: 50;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-default-grey-active";
    readonly themePath: readonly ["background", "default", "grey", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "grey";
        readonly usage: "default";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-1000-50-active";
        readonly themePath: readonly ["grey", "_1000_50", "active"];
        readonly color: {
            readonly light: "#ededed";
            readonly dark: "#474747";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 1000;
                };
                readonly dark: {
                    readonly value: 50;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-grey";
    readonly themePath: readonly ["background", "alt", "grey", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "grey";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-975-75";
        readonly themePath: readonly ["grey", "_975_75", "default"];
        readonly color: {
            readonly light: "#f6f6f6";
            readonly dark: "#1e1e1e";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-grey-hover";
    readonly themePath: readonly ["background", "alt", "grey", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "grey";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-975-75-hover";
        readonly themePath: readonly ["grey", "_975_75", "hover"];
        readonly color: {
            readonly light: "#dfdfdf";
            readonly dark: "#3f3f3f";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-grey-active";
    readonly themePath: readonly ["background", "alt", "grey", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "grey";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-975-75-active";
        readonly themePath: readonly ["grey", "_975_75", "active"];
        readonly color: {
            readonly light: "#cfcfcf";
            readonly dark: "#525252";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-blue-france";
    readonly themePath: readonly ["background", "alt", "blueFrance", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "blueFrance";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-france-975-75";
        readonly themePath: readonly ["blueFrance", "_975_75", "default"];
        readonly color: {
            readonly light: "#f5f5fe";
            readonly dark: "#1b1b35";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueFrance";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-blue-france-hover";
    readonly themePath: readonly ["background", "alt", "blueFrance", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "blueFrance";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-france-975-75-hover";
        readonly themePath: readonly ["blueFrance", "_975_75", "hover"];
        readonly color: {
            readonly light: "#dcdcfc";
            readonly dark: "#3a3a68";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueFrance";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-blue-france-active";
    readonly themePath: readonly ["background", "alt", "blueFrance", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "blueFrance";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-france-975-75-active";
        readonly themePath: readonly ["blueFrance", "_975_75", "active"];
        readonly color: {
            readonly light: "#cbcbfa";
            readonly dark: "#4d4d83";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueFrance";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-red-marianne";
    readonly themePath: readonly ["background", "alt", "redMarianne", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "redMarianne";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--red-marianne-975-75";
        readonly themePath: readonly ["redMarianne", "_975_75", "default"];
        readonly color: {
            readonly light: "#fef4f4";
            readonly dark: "#2b1919";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "redMarianne";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-red-marianne-hover";
    readonly themePath: readonly ["background", "alt", "redMarianne", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "redMarianne";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--red-marianne-975-75-hover";
        readonly themePath: readonly ["redMarianne", "_975_75", "hover"];
        readonly color: {
            readonly light: "#fcd7d7";
            readonly dark: "#573737";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "redMarianne";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-red-marianne-active";
    readonly themePath: readonly ["background", "alt", "redMarianne", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "redMarianne";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--red-marianne-975-75-active";
        readonly themePath: readonly ["redMarianne", "_975_75", "active"];
        readonly color: {
            readonly light: "#fac4c4";
            readonly dark: "#704848";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "redMarianne";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-green-tilleul-verveine";
    readonly themePath: readonly ["background", "alt", "greenTilleulVerveine", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "greenTilleulVerveine";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-tilleul-verveine-975-75";
        readonly themePath: readonly ["greenTilleulVerveine", "_975_75", "default"];
        readonly color: {
            readonly light: "#fef7da";
            readonly dark: "#201e14";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenTilleulVerveine";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-green-tilleul-verveine-hover";
    readonly themePath: readonly ["background", "alt", "greenTilleulVerveine", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "greenTilleulVerveine";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-tilleul-verveine-975-75-hover";
        readonly themePath: readonly ["greenTilleulVerveine", "_975_75", "hover"];
        readonly color: {
            readonly light: "#fce552";
            readonly dark: "#433f2e";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenTilleulVerveine";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-green-tilleul-verveine-active";
    readonly themePath: readonly ["background", "alt", "greenTilleulVerveine", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "greenTilleulVerveine";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-tilleul-verveine-975-75-active";
        readonly themePath: readonly ["greenTilleulVerveine", "_975_75", "active"];
        readonly color: {
            readonly light: "#ebd54c";
            readonly dark: "#57533d";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenTilleulVerveine";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-green-bourgeon";
    readonly themePath: readonly ["background", "alt", "greenBourgeon", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "greenBourgeon";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-bourgeon-975-75";
        readonly themePath: readonly ["greenBourgeon", "_975_75", "default"];
        readonly color: {
            readonly light: "#e6feda";
            readonly dark: "#182014";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenBourgeon";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-green-bourgeon-hover";
    readonly themePath: readonly ["background", "alt", "greenBourgeon", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "greenBourgeon";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-bourgeon-975-75-hover";
        readonly themePath: readonly ["greenBourgeon", "_975_75", "hover"];
        readonly color: {
            readonly light: "#a7fc62";
            readonly dark: "#35432e";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenBourgeon";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-green-bourgeon-active";
    readonly themePath: readonly ["background", "alt", "greenBourgeon", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "greenBourgeon";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-bourgeon-975-75-active";
        readonly themePath: readonly ["greenBourgeon", "_975_75", "active"];
        readonly color: {
            readonly light: "#98ed4d";
            readonly dark: "#46573d";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenBourgeon";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-green-emeraude";
    readonly themePath: readonly ["background", "alt", "greenEmeraude", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "greenEmeraude";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-emeraude-975-75";
        readonly themePath: readonly ["greenEmeraude", "_975_75", "default"];
        readonly color: {
            readonly light: "#e3fdeb";
            readonly dark: "#142018";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenEmeraude";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-green-emeraude-hover";
    readonly themePath: readonly ["background", "alt", "greenEmeraude", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "greenEmeraude";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-emeraude-975-75-hover";
        readonly themePath: readonly ["greenEmeraude", "_975_75", "hover"];
        readonly color: {
            readonly light: "#94f9b9";
            readonly dark: "#2e4335";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenEmeraude";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-green-emeraude-active";
    readonly themePath: readonly ["background", "alt", "greenEmeraude", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "greenEmeraude";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-emeraude-975-75-active";
        readonly themePath: readonly ["greenEmeraude", "_975_75", "active"];
        readonly color: {
            readonly light: "#6df1a3";
            readonly dark: "#3d5846";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenEmeraude";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-green-menthe";
    readonly themePath: readonly ["background", "alt", "greenMenthe", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "greenMenthe";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-menthe-975-75";
        readonly themePath: readonly ["greenMenthe", "_975_75", "default"];
        readonly color: {
            readonly light: "#dffdf7";
            readonly dark: "#15201e";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenMenthe";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-green-menthe-hover";
    readonly themePath: readonly ["background", "alt", "greenMenthe", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "greenMenthe";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-menthe-975-75-hover";
        readonly themePath: readonly ["greenMenthe", "_975_75", "hover"];
        readonly color: {
            readonly light: "#84f9e7";
            readonly dark: "#30433f";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenMenthe";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-green-menthe-active";
    readonly themePath: readonly ["background", "alt", "greenMenthe", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "greenMenthe";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-menthe-975-75-active";
        readonly themePath: readonly ["greenMenthe", "_975_75", "active"];
        readonly color: {
            readonly light: "#70ebd8";
            readonly dark: "#3f5753";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenMenthe";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-green-archipel";
    readonly themePath: readonly ["background", "alt", "greenArchipel", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "greenArchipel";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-archipel-975-75";
        readonly themePath: readonly ["greenArchipel", "_975_75", "default"];
        readonly color: {
            readonly light: "#e5fbfd";
            readonly dark: "#152021";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenArchipel";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-green-archipel-hover";
    readonly themePath: readonly ["background", "alt", "greenArchipel", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "greenArchipel";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-archipel-975-75-hover";
        readonly themePath: readonly ["greenArchipel", "_975_75", "hover"];
        readonly color: {
            readonly light: "#99f2f8";
            readonly dark: "#2f4345";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenArchipel";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-green-archipel-active";
    readonly themePath: readonly ["background", "alt", "greenArchipel", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "greenArchipel";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-archipel-975-75-active";
        readonly themePath: readonly ["greenArchipel", "_975_75", "active"];
        readonly color: {
            readonly light: "#73e9f0";
            readonly dark: "#3f5759";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenArchipel";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-blue-ecume";
    readonly themePath: readonly ["background", "alt", "blueEcume", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "blueEcume";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-ecume-975-75";
        readonly themePath: readonly ["blueEcume", "_975_75", "default"];
        readonly color: {
            readonly light: "#f4f6fe";
            readonly dark: "#171d2f";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueEcume";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-blue-ecume-hover";
    readonly themePath: readonly ["background", "alt", "blueEcume", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "blueEcume";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-ecume-975-75-hover";
        readonly themePath: readonly ["blueEcume", "_975_75", "hover"];
        readonly color: {
            readonly light: "#d7dffb";
            readonly dark: "#333e5e";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueEcume";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-blue-ecume-active";
    readonly themePath: readonly ["background", "alt", "blueEcume", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "blueEcume";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-ecume-975-75-active";
        readonly themePath: readonly ["blueEcume", "_975_75", "active"];
        readonly color: {
            readonly light: "#c3cffa";
            readonly dark: "#445179";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueEcume";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-blue-cumulus";
    readonly themePath: readonly ["background", "alt", "blueCumulus", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "blueCumulus";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-cumulus-975-75";
        readonly themePath: readonly ["blueCumulus", "_975_75", "default"];
        readonly color: {
            readonly light: "#f3f6fe";
            readonly dark: "#171e2b";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueCumulus";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-blue-cumulus-hover";
    readonly themePath: readonly ["background", "alt", "blueCumulus", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "blueCumulus";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-cumulus-975-75-hover";
        readonly themePath: readonly ["blueCumulus", "_975_75", "hover"];
        readonly color: {
            readonly light: "#d3dffc";
            readonly dark: "#333f56";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueCumulus";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-blue-cumulus-active";
    readonly themePath: readonly ["background", "alt", "blueCumulus", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "blueCumulus";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-cumulus-975-75-active";
        readonly themePath: readonly ["blueCumulus", "_975_75", "active"];
        readonly color: {
            readonly light: "#bed0fa";
            readonly dark: "#43536f";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueCumulus";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-purple-glycine";
    readonly themePath: readonly ["background", "alt", "purpleGlycine", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "purpleGlycine";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--purple-glycine-975-75";
        readonly themePath: readonly ["purpleGlycine", "_975_75", "default"];
        readonly color: {
            readonly light: "#fef3fd";
            readonly dark: "#251a24";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "purpleGlycine";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-purple-glycine-hover";
    readonly themePath: readonly ["background", "alt", "purpleGlycine", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "purpleGlycine";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--purple-glycine-975-75-hover";
        readonly themePath: readonly ["purpleGlycine", "_975_75", "hover"];
        readonly color: {
            readonly light: "#fcd4f8";
            readonly dark: "#4c394a";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "purpleGlycine";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-purple-glycine-active";
    readonly themePath: readonly ["background", "alt", "purpleGlycine", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "purpleGlycine";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--purple-glycine-975-75-active";
        readonly themePath: readonly ["purpleGlycine", "_975_75", "active"];
        readonly color: {
            readonly light: "#fabff5";
            readonly dark: "#634a60";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "purpleGlycine";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-pink-macaron";
    readonly themePath: readonly ["background", "alt", "pinkMacaron", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "pinkMacaron";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-macaron-975-75";
        readonly themePath: readonly ["pinkMacaron", "_975_75", "default"];
        readonly color: {
            readonly light: "#fef4f2";
            readonly dark: "#261b19";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "pinkMacaron";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-pink-macaron-hover";
    readonly themePath: readonly ["background", "alt", "pinkMacaron", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "pinkMacaron";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-macaron-975-75-hover";
        readonly themePath: readonly ["pinkMacaron", "_975_75", "hover"];
        readonly color: {
            readonly light: "#fcd8d0";
            readonly dark: "#4e3a37";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "pinkMacaron";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-pink-macaron-active";
    readonly themePath: readonly ["background", "alt", "pinkMacaron", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "pinkMacaron";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-macaron-975-75-active";
        readonly themePath: readonly ["pinkMacaron", "_975_75", "active"];
        readonly color: {
            readonly light: "#fac5b8";
            readonly dark: "#654c48";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "pinkMacaron";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-pink-tuile";
    readonly themePath: readonly ["background", "alt", "pinkTuile", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "pinkTuile";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-tuile-975-75";
        readonly themePath: readonly ["pinkTuile", "_975_75", "default"];
        readonly color: {
            readonly light: "#fef4f3";
            readonly dark: "#281b19";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "pinkTuile";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-pink-tuile-hover";
    readonly themePath: readonly ["background", "alt", "pinkTuile", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "pinkTuile";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-tuile-975-75-hover";
        readonly themePath: readonly ["pinkTuile", "_975_75", "hover"];
        readonly color: {
            readonly light: "#fcd7d3";
            readonly dark: "#513a37";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "pinkTuile";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-pink-tuile-active";
    readonly themePath: readonly ["background", "alt", "pinkTuile", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "pinkTuile";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-tuile-975-75-active";
        readonly themePath: readonly ["pinkTuile", "_975_75", "active"];
        readonly color: {
            readonly light: "#fac4be";
            readonly dark: "#694c48";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "pinkTuile";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-yellow-tournesol";
    readonly themePath: readonly ["background", "alt", "yellowTournesol", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "yellowTournesol";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-tournesol-975-75";
        readonly themePath: readonly ["yellowTournesol", "_975_75", "default"];
        readonly color: {
            readonly light: "#fef6e3";
            readonly dark: "#221d11";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "yellowTournesol";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-yellow-tournesol-hover";
    readonly themePath: readonly ["background", "alt", "yellowTournesol", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "yellowTournesol";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-tournesol-975-75-hover";
        readonly themePath: readonly ["yellowTournesol", "_975_75", "hover"];
        readonly color: {
            readonly light: "#fce086";
            readonly dark: "#473e29";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "yellowTournesol";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-yellow-tournesol-active";
    readonly themePath: readonly ["background", "alt", "yellowTournesol", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "yellowTournesol";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-tournesol-975-75-active";
        readonly themePath: readonly ["yellowTournesol", "_975_75", "active"];
        readonly color: {
            readonly light: "#f5d24b";
            readonly dark: "#5c5136";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "yellowTournesol";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-yellow-moutarde";
    readonly themePath: readonly ["background", "alt", "yellowMoutarde", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "yellowMoutarde";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-moutarde-975-75";
        readonly themePath: readonly ["yellowMoutarde", "_975_75", "default"];
        readonly color: {
            readonly light: "#fef5e8";
            readonly dark: "#231d14";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "yellowMoutarde";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-yellow-moutarde-hover";
    readonly themePath: readonly ["background", "alt", "yellowMoutarde", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "yellowMoutarde";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-moutarde-975-75-hover";
        readonly themePath: readonly ["yellowMoutarde", "_975_75", "hover"];
        readonly color: {
            readonly light: "#fcdca3";
            readonly dark: "#483e2e";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "yellowMoutarde";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-yellow-moutarde-active";
    readonly themePath: readonly ["background", "alt", "yellowMoutarde", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "yellowMoutarde";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-moutarde-975-75-active";
        readonly themePath: readonly ["yellowMoutarde", "_975_75", "active"];
        readonly color: {
            readonly light: "#fbcd64";
            readonly dark: "#5e513d";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "yellowMoutarde";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-orange-terre-battue";
    readonly themePath: readonly ["background", "alt", "orangeTerreBattue", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "orangeTerreBattue";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--orange-terre-battue-975-75";
        readonly themePath: readonly ["orangeTerreBattue", "_975_75", "default"];
        readonly color: {
            readonly light: "#fef4f2";
            readonly dark: "#281a16";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "orangeTerreBattue";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-orange-terre-battue-hover";
    readonly themePath: readonly ["background", "alt", "orangeTerreBattue", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "orangeTerreBattue";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--orange-terre-battue-975-75-hover";
        readonly themePath: readonly ["orangeTerreBattue", "_975_75", "hover"];
        readonly color: {
            readonly light: "#fcd8d0";
            readonly dark: "#513932";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "orangeTerreBattue";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-orange-terre-battue-active";
    readonly themePath: readonly ["background", "alt", "orangeTerreBattue", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "orangeTerreBattue";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--orange-terre-battue-975-75-active";
        readonly themePath: readonly ["orangeTerreBattue", "_975_75", "active"];
        readonly color: {
            readonly light: "#fac5b8";
            readonly dark: "#6a4b42";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "orangeTerreBattue";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-brown-cafe-creme";
    readonly themePath: readonly ["background", "alt", "brownCafeCreme", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "brownCafeCreme";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-cafe-creme-975-75";
        readonly themePath: readonly ["brownCafeCreme", "_975_75", "default"];
        readonly color: {
            readonly light: "#fbf6ed";
            readonly dark: "#211d16";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownCafeCreme";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-brown-cafe-creme-hover";
    readonly themePath: readonly ["background", "alt", "brownCafeCreme", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "brownCafeCreme";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-cafe-creme-975-75-hover";
        readonly themePath: readonly ["brownCafeCreme", "_975_75", "hover"];
        readonly color: {
            readonly light: "#f2deb6";
            readonly dark: "#453e31";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownCafeCreme";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-brown-cafe-creme-active";
    readonly themePath: readonly ["background", "alt", "brownCafeCreme", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "brownCafeCreme";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-cafe-creme-975-75-active";
        readonly themePath: readonly ["brownCafeCreme", "_975_75", "active"];
        readonly color: {
            readonly light: "#eacf91";
            readonly dark: "#5a5141";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownCafeCreme";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-brown-caramel";
    readonly themePath: readonly ["background", "alt", "brownCaramel", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "brownCaramel";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-caramel-975-75";
        readonly themePath: readonly ["brownCaramel", "_975_75", "default"];
        readonly color: {
            readonly light: "#fbf5f2";
            readonly dark: "#251c16";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownCaramel";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-brown-caramel-hover";
    readonly themePath: readonly ["background", "alt", "brownCaramel", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "brownCaramel";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-caramel-975-75-hover";
        readonly themePath: readonly ["brownCaramel", "_975_75", "hover"];
        readonly color: {
            readonly light: "#f1dbcf";
            readonly dark: "#4c3c31";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownCaramel";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-brown-caramel-active";
    readonly themePath: readonly ["background", "alt", "brownCaramel", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "brownCaramel";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-caramel-975-75-active";
        readonly themePath: readonly ["brownCaramel", "_975_75", "active"];
        readonly color: {
            readonly light: "#ecc9b5";
            readonly dark: "#624e41";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownCaramel";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-brown-opera";
    readonly themePath: readonly ["background", "alt", "brownOpera", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "brownOpera";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-opera-975-75";
        readonly themePath: readonly ["brownOpera", "_975_75", "default"];
        readonly color: {
            readonly light: "#fbf5f2";
            readonly dark: "#241c17";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownOpera";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-brown-opera-hover";
    readonly themePath: readonly ["background", "alt", "brownOpera", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "brownOpera";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-opera-975-75-hover";
        readonly themePath: readonly ["brownOpera", "_975_75", "hover"];
        readonly color: {
            readonly light: "#f1dbcf";
            readonly dark: "#4a3c33";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownOpera";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-brown-opera-active";
    readonly themePath: readonly ["background", "alt", "brownOpera", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "brownOpera";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-opera-975-75-active";
        readonly themePath: readonly ["brownOpera", "_975_75", "active"];
        readonly color: {
            readonly light: "#ecc9b5";
            readonly dark: "#604f44";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownOpera";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-beige-gris-galet";
    readonly themePath: readonly ["background", "alt", "beigeGrisGalet", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "beigeGrisGalet";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--beige-gris-galet-975-75";
        readonly themePath: readonly ["beigeGrisGalet", "_975_75", "default"];
        readonly color: {
            readonly light: "#f9f6f2";
            readonly dark: "#211d19";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "beigeGrisGalet";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-beige-gris-galet-hover";
    readonly themePath: readonly ["background", "alt", "beigeGrisGalet", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "beigeGrisGalet";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--beige-gris-galet-975-75-hover";
        readonly themePath: readonly ["beigeGrisGalet", "_975_75", "hover"];
        readonly color: {
            readonly light: "#eadecd";
            readonly dark: "#453e37";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "beigeGrisGalet";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-beige-gris-galet-active";
    readonly themePath: readonly ["background", "alt", "beigeGrisGalet", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "beigeGrisGalet";
        readonly usage: "alt";
    };
    readonly colorOption: {
        readonly colorOptionName: "--beige-gris-galet-975-75-active";
        readonly themePath: readonly ["beigeGrisGalet", "_975_75", "active"];
        readonly color: {
            readonly light: "#e1ceb1";
            readonly dark: "#595148";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "beigeGrisGalet";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-grey";
    readonly themePath: readonly ["background", "contrast", "grey", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "grey";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-950-100";
        readonly themePath: readonly ["grey", "_950_100", "default"];
        readonly color: {
            readonly light: "#eeeeee";
            readonly dark: "#242424";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-grey-hover";
    readonly themePath: readonly ["background", "contrast", "grey", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "grey";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-950-100-hover";
        readonly themePath: readonly ["grey", "_950_100", "hover"];
        readonly color: {
            readonly light: "#d2d2d2";
            readonly dark: "#474747";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-grey-active";
    readonly themePath: readonly ["background", "contrast", "grey", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "grey";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-950-100-active";
        readonly themePath: readonly ["grey", "_950_100", "active"];
        readonly color: {
            readonly light: "#c1c1c1";
            readonly dark: "#5b5b5b";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-blue-france";
    readonly themePath: readonly ["background", "contrast", "blueFrance", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "blueFrance";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-france-950-100";
        readonly themePath: readonly ["blueFrance", "_950_100", "default"];
        readonly color: {
            readonly light: "#ececfe";
            readonly dark: "#21213f";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueFrance";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-blue-france-hover";
    readonly themePath: readonly ["background", "contrast", "blueFrance", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "blueFrance";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-france-950-100-hover";
        readonly themePath: readonly ["blueFrance", "_950_100", "hover"];
        readonly color: {
            readonly light: "#cecefc";
            readonly dark: "#424275";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueFrance";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-blue-france-active";
    readonly themePath: readonly ["background", "contrast", "blueFrance", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "blueFrance";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-france-950-100-active";
        readonly themePath: readonly ["blueFrance", "_950_100", "active"];
        readonly color: {
            readonly light: "#bbbbfc";
            readonly dark: "#56568c";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueFrance";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-red-marianne";
    readonly themePath: readonly ["background", "contrast", "redMarianne", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "redMarianne";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--red-marianne-950-100";
        readonly themePath: readonly ["redMarianne", "_950_100", "default"];
        readonly color: {
            readonly light: "#fee9e9";
            readonly dark: "#331f1f";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "redMarianne";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-red-marianne-hover";
    readonly themePath: readonly ["background", "contrast", "redMarianne", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "redMarianne";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--red-marianne-950-100-hover";
        readonly themePath: readonly ["redMarianne", "_950_100", "hover"];
        readonly color: {
            readonly light: "#fdc5c5";
            readonly dark: "#613f3f";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "redMarianne";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-red-marianne-active";
    readonly themePath: readonly ["background", "contrast", "redMarianne", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "redMarianne";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--red-marianne-950-100-active";
        readonly themePath: readonly ["redMarianne", "_950_100", "active"];
        readonly color: {
            readonly light: "#fcafaf";
            readonly dark: "#7b5151";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "redMarianne";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-green-tilleul-verveine";
    readonly themePath: readonly ["background", "contrast", "greenTilleulVerveine", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "greenTilleulVerveine";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-tilleul-verveine-950-100";
        readonly themePath: readonly ["greenTilleulVerveine", "_950_100", "default"];
        readonly color: {
            readonly light: "#fceeac";
            readonly dark: "#272419";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenTilleulVerveine";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-green-tilleul-verveine-hover";
    readonly themePath: readonly ["background", "contrast", "greenTilleulVerveine", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "greenTilleulVerveine";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-tilleul-verveine-950-100-hover";
        readonly themePath: readonly ["greenTilleulVerveine", "_950_100", "hover"];
        readonly color: {
            readonly light: "#e8d45c";
            readonly dark: "#4c4734";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenTilleulVerveine";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-green-tilleul-verveine-active";
    readonly themePath: readonly ["background", "contrast", "greenTilleulVerveine", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "greenTilleulVerveine";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-tilleul-verveine-950-100-active";
        readonly themePath: readonly ["greenTilleulVerveine", "_950_100", "active"];
        readonly color: {
            readonly light: "#d4c254";
            readonly dark: "#615b44";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenTilleulVerveine";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-green-bourgeon";
    readonly themePath: readonly ["background", "contrast", "greenBourgeon", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "greenBourgeon";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-bourgeon-950-100";
        readonly themePath: readonly ["greenBourgeon", "_950_100", "default"];
        readonly color: {
            readonly light: "#c9fcac";
            readonly dark: "#1e2719";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenBourgeon";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-green-bourgeon-hover";
    readonly themePath: readonly ["background", "contrast", "greenBourgeon", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "greenBourgeon";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-bourgeon-950-100-hover";
        readonly themePath: readonly ["greenBourgeon", "_950_100", "hover"];
        readonly color: {
            readonly light: "#9ae95d";
            readonly dark: "#3d4c34";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenBourgeon";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-green-bourgeon-active";
    readonly themePath: readonly ["background", "contrast", "greenBourgeon", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "greenBourgeon";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-bourgeon-950-100-active";
        readonly themePath: readonly ["greenBourgeon", "_950_100", "active"];
        readonly color: {
            readonly light: "#8dd555";
            readonly dark: "#4e6144";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenBourgeon";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-green-emeraude";
    readonly themePath: readonly ["background", "contrast", "greenEmeraude", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "greenEmeraude";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-emeraude-950-100";
        readonly themePath: readonly ["greenEmeraude", "_950_100", "default"];
        readonly color: {
            readonly light: "#c3fad5";
            readonly dark: "#19271e";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenEmeraude";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-green-emeraude-hover";
    readonly themePath: readonly ["background", "contrast", "greenEmeraude", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "greenEmeraude";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-emeraude-950-100-hover";
        readonly themePath: readonly ["greenEmeraude", "_950_100", "hover"];
        readonly color: {
            readonly light: "#77eda5";
            readonly dark: "#344c3d";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenEmeraude";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-green-emeraude-active";
    readonly themePath: readonly ["background", "contrast", "greenEmeraude", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "greenEmeraude";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-emeraude-950-100-active";
        readonly themePath: readonly ["greenEmeraude", "_950_100", "active"];
        readonly color: {
            readonly light: "#6dd897";
            readonly dark: "#44624f";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenEmeraude";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-green-menthe";
    readonly themePath: readonly ["background", "contrast", "greenMenthe", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "greenMenthe";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-menthe-950-100";
        readonly themePath: readonly ["greenMenthe", "_950_100", "default"];
        readonly color: {
            readonly light: "#bafaee";
            readonly dark: "#1a2624";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenMenthe";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-green-menthe-hover";
    readonly themePath: readonly ["background", "contrast", "greenMenthe", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "greenMenthe";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-menthe-950-100-hover";
        readonly themePath: readonly ["greenMenthe", "_950_100", "hover"];
        readonly color: {
            readonly light: "#79e7d5";
            readonly dark: "#364b47";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenMenthe";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-green-menthe-active";
    readonly themePath: readonly ["background", "contrast", "greenMenthe", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "greenMenthe";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-menthe-950-100-active";
        readonly themePath: readonly ["greenMenthe", "_950_100", "active"];
        readonly color: {
            readonly light: "#6fd3c3";
            readonly dark: "#46605b";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenMenthe";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-green-archipel";
    readonly themePath: readonly ["background", "contrast", "greenArchipel", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "greenArchipel";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-archipel-950-100";
        readonly themePath: readonly ["greenArchipel", "_950_100", "default"];
        readonly color: {
            readonly light: "#c7f6fc";
            readonly dark: "#1a2628";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenArchipel";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-green-archipel-hover";
    readonly themePath: readonly ["background", "contrast", "greenArchipel", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "greenArchipel";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-archipel-950-100-hover";
        readonly themePath: readonly ["greenArchipel", "_950_100", "hover"];
        readonly color: {
            readonly light: "#64ecf8";
            readonly dark: "#364a4e";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenArchipel";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-green-archipel-active";
    readonly themePath: readonly ["background", "contrast", "greenArchipel", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "greenArchipel";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-archipel-950-100-active";
        readonly themePath: readonly ["greenArchipel", "_950_100", "active"];
        readonly color: {
            readonly light: "#5bd8e3";
            readonly dark: "#465f63";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenArchipel";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-blue-ecume";
    readonly themePath: readonly ["background", "contrast", "blueEcume", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "blueEcume";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-ecume-950-100";
        readonly themePath: readonly ["blueEcume", "_950_100", "default"];
        readonly color: {
            readonly light: "#e9edfe";
            readonly dark: "#1d2437";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueEcume";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-blue-ecume-hover";
    readonly themePath: readonly ["background", "contrast", "blueEcume", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "blueEcume";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-ecume-950-100-hover";
        readonly themePath: readonly ["blueEcume", "_950_100", "hover"];
        readonly color: {
            readonly light: "#c5d0fc";
            readonly dark: "#3b4767";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueEcume";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-blue-ecume-active";
    readonly themePath: readonly ["background", "contrast", "blueEcume", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "blueEcume";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-ecume-950-100-active";
        readonly themePath: readonly ["blueEcume", "_950_100", "active"];
        readonly color: {
            readonly light: "#adbffc";
            readonly dark: "#4c5b83";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueEcume";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-blue-cumulus";
    readonly themePath: readonly ["background", "contrast", "blueCumulus", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "blueCumulus";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-cumulus-950-100";
        readonly themePath: readonly ["blueCumulus", "_950_100", "default"];
        readonly color: {
            readonly light: "#e6eefe";
            readonly dark: "#1c2433";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueCumulus";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-blue-cumulus-hover";
    readonly themePath: readonly ["background", "contrast", "blueCumulus", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "blueCumulus";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-cumulus-950-100-hover";
        readonly themePath: readonly ["blueCumulus", "_950_100", "hover"];
        readonly color: {
            readonly light: "#bcd3fc";
            readonly dark: "#3a4761";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueCumulus";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-blue-cumulus-active";
    readonly themePath: readonly ["background", "contrast", "blueCumulus", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "blueCumulus";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-cumulus-950-100-active";
        readonly themePath: readonly ["blueCumulus", "_950_100", "active"];
        readonly color: {
            readonly light: "#9fc3fc";
            readonly dark: "#4a5b7b";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueCumulus";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-purple-glycine";
    readonly themePath: readonly ["background", "contrast", "purpleGlycine", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "purpleGlycine";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--purple-glycine-950-100";
        readonly themePath: readonly ["purpleGlycine", "_950_100", "default"];
        readonly color: {
            readonly light: "#fee7fc";
            readonly dark: "#2c202b";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "purpleGlycine";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-purple-glycine-hover";
    readonly themePath: readonly ["background", "contrast", "purpleGlycine", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "purpleGlycine";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--purple-glycine-950-100-hover";
        readonly themePath: readonly ["purpleGlycine", "_950_100", "hover"];
        readonly color: {
            readonly light: "#fdc0f8";
            readonly dark: "#554053";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "purpleGlycine";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-purple-glycine-active";
    readonly themePath: readonly ["background", "contrast", "purpleGlycine", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "purpleGlycine";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--purple-glycine-950-100-active";
        readonly themePath: readonly ["purpleGlycine", "_950_100", "active"];
        readonly color: {
            readonly light: "#fca8f6";
            readonly dark: "#6c536a";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "purpleGlycine";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-pink-macaron";
    readonly themePath: readonly ["background", "contrast", "pinkMacaron", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "pinkMacaron";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-macaron-950-100";
        readonly themePath: readonly ["pinkMacaron", "_950_100", "default"];
        readonly color: {
            readonly light: "#fee9e6";
            readonly dark: "#2e211f";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "pinkMacaron";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-pink-macaron-hover";
    readonly themePath: readonly ["background", "contrast", "pinkMacaron", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "pinkMacaron";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-macaron-950-100-hover";
        readonly themePath: readonly ["pinkMacaron", "_950_100", "hover"];
        readonly color: {
            readonly light: "#fdc6bd";
            readonly dark: "#58423f";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "pinkMacaron";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-pink-macaron-active";
    readonly themePath: readonly ["background", "contrast", "pinkMacaron", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "pinkMacaron";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-macaron-950-100-active";
        readonly themePath: readonly ["pinkMacaron", "_950_100", "active"];
        readonly color: {
            readonly light: "#fcb0a2";
            readonly dark: "#705551";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "pinkMacaron";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-pink-tuile";
    readonly themePath: readonly ["background", "contrast", "pinkTuile", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "pinkTuile";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-tuile-950-100";
        readonly themePath: readonly ["pinkTuile", "_950_100", "default"];
        readonly color: {
            readonly light: "#fee9e7";
            readonly dark: "#2f211f";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "pinkTuile";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-pink-tuile-hover";
    readonly themePath: readonly ["background", "contrast", "pinkTuile", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "pinkTuile";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-tuile-950-100-hover";
        readonly themePath: readonly ["pinkTuile", "_950_100", "hover"];
        readonly color: {
            readonly light: "#fdc6c0";
            readonly dark: "#5a423e";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "pinkTuile";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-pink-tuile-active";
    readonly themePath: readonly ["background", "contrast", "pinkTuile", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "pinkTuile";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-tuile-950-100-active";
        readonly themePath: readonly ["pinkTuile", "_950_100", "active"];
        readonly color: {
            readonly light: "#fcb0a7";
            readonly dark: "#725550";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "pinkTuile";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-yellow-tournesol";
    readonly themePath: readonly ["background", "contrast", "yellowTournesol", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "yellowTournesol";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-tournesol-950-100";
        readonly themePath: readonly ["yellowTournesol", "_950_100", "default"];
        readonly color: {
            readonly light: "#feecc2";
            readonly dark: "#292416";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "yellowTournesol";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-yellow-tournesol-hover";
    readonly themePath: readonly ["background", "contrast", "yellowTournesol", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "yellowTournesol";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-tournesol-950-100-hover";
        readonly themePath: readonly ["yellowTournesol", "_950_100", "hover"];
        readonly color: {
            readonly light: "#fbd335";
            readonly dark: "#4f472f";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "yellowTournesol";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-yellow-tournesol-active";
    readonly themePath: readonly ["background", "contrast", "yellowTournesol", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "yellowTournesol";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-tournesol-950-100-active";
        readonly themePath: readonly ["yellowTournesol", "_950_100", "active"];
        readonly color: {
            readonly light: "#e6c130";
            readonly dark: "#655b3d";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "yellowTournesol";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-yellow-moutarde";
    readonly themePath: readonly ["background", "contrast", "yellowMoutarde", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "yellowMoutarde";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-moutarde-950-100";
        readonly themePath: readonly ["yellowMoutarde", "_950_100", "default"];
        readonly color: {
            readonly light: "#feebd0";
            readonly dark: "#2a2319";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "yellowMoutarde";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-yellow-moutarde-hover";
    readonly themePath: readonly ["background", "contrast", "yellowMoutarde", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "yellowMoutarde";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-moutarde-950-100-hover";
        readonly themePath: readonly ["yellowMoutarde", "_950_100", "hover"];
        readonly color: {
            readonly light: "#fdcd6d";
            readonly dark: "#514534";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "yellowMoutarde";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-yellow-moutarde-active";
    readonly themePath: readonly ["background", "contrast", "yellowMoutarde", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "yellowMoutarde";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-moutarde-950-100-active";
        readonly themePath: readonly ["yellowMoutarde", "_950_100", "active"];
        readonly color: {
            readonly light: "#f4be30";
            readonly dark: "#685944";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "yellowMoutarde";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-orange-terre-battue";
    readonly themePath: readonly ["background", "contrast", "orangeTerreBattue", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "orangeTerreBattue";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--orange-terre-battue-950-100";
        readonly themePath: readonly ["orangeTerreBattue", "_950_100", "default"];
        readonly color: {
            readonly light: "#fee9e5";
            readonly dark: "#31201c";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "orangeTerreBattue";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-orange-terre-battue-hover";
    readonly themePath: readonly ["background", "contrast", "orangeTerreBattue", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "orangeTerreBattue";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--orange-terre-battue-950-100-hover";
        readonly themePath: readonly ["orangeTerreBattue", "_950_100", "hover"];
        readonly color: {
            readonly light: "#fdc6ba";
            readonly dark: "#5d403a";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "orangeTerreBattue";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-orange-terre-battue-active";
    readonly themePath: readonly ["background", "contrast", "orangeTerreBattue", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "orangeTerreBattue";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--orange-terre-battue-950-100-active";
        readonly themePath: readonly ["orangeTerreBattue", "_950_100", "active"];
        readonly color: {
            readonly light: "#fcb09e";
            readonly dark: "#77534a";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "orangeTerreBattue";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-brown-cafe-creme";
    readonly themePath: readonly ["background", "contrast", "brownCafeCreme", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "brownCafeCreme";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-cafe-creme-950-100";
        readonly themePath: readonly ["brownCafeCreme", "_950_100", "default"];
        readonly color: {
            readonly light: "#f7ecdb";
            readonly dark: "#28241c";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownCafeCreme";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-brown-cafe-creme-hover";
    readonly themePath: readonly ["background", "contrast", "brownCafeCreme", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "brownCafeCreme";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-cafe-creme-950-100-hover";
        readonly themePath: readonly ["brownCafeCreme", "_950_100", "hover"];
        readonly color: {
            readonly light: "#edce94";
            readonly dark: "#4e4739";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownCafeCreme";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-brown-cafe-creme-active";
    readonly themePath: readonly ["background", "contrast", "brownCafeCreme", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "brownCafeCreme";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-cafe-creme-950-100-active";
        readonly themePath: readonly ["brownCafeCreme", "_950_100", "active"];
        readonly color: {
            readonly light: "#dabd84";
            readonly dark: "#635b4a";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownCafeCreme";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-brown-caramel";
    readonly themePath: readonly ["background", "contrast", "brownCaramel", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "brownCaramel";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-caramel-950-100";
        readonly themePath: readonly ["brownCaramel", "_950_100", "default"];
        readonly color: {
            readonly light: "#f7ebe5";
            readonly dark: "#2c221c";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownCaramel";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-brown-caramel-hover";
    readonly themePath: readonly ["background", "contrast", "brownCaramel", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "brownCaramel";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-caramel-950-100-hover";
        readonly themePath: readonly ["brownCaramel", "_950_100", "hover"];
        readonly color: {
            readonly light: "#eccbb9";
            readonly dark: "#554439";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownCaramel";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-brown-caramel-active";
    readonly themePath: readonly ["background", "contrast", "brownCaramel", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "brownCaramel";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-caramel-950-100-active";
        readonly themePath: readonly ["brownCaramel", "_950_100", "active"];
        readonly color: {
            readonly light: "#e6b79a";
            readonly dark: "#6c574a";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownCaramel";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-brown-opera";
    readonly themePath: readonly ["background", "contrast", "brownOpera", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "brownOpera";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-opera-950-100";
        readonly themePath: readonly ["brownOpera", "_950_100", "default"];
        readonly color: {
            readonly light: "#f7ece4";
            readonly dark: "#2b221c";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownOpera";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-brown-opera-hover";
    readonly themePath: readonly ["background", "contrast", "brownOpera", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "brownOpera";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-opera-950-100-hover";
        readonly themePath: readonly ["brownOpera", "_950_100", "hover"];
        readonly color: {
            readonly light: "#eccdb3";
            readonly dark: "#53443a";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownOpera";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-brown-opera-active";
    readonly themePath: readonly ["background", "contrast", "brownOpera", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "brownOpera";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-opera-950-100-active";
        readonly themePath: readonly ["brownOpera", "_950_100", "active"];
        readonly color: {
            readonly light: "#e6ba90";
            readonly dark: "#6a574a";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownOpera";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-beige-gris-galet";
    readonly themePath: readonly ["background", "contrast", "beigeGrisGalet", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "beigeGrisGalet";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--beige-gris-galet-950-100";
        readonly themePath: readonly ["beigeGrisGalet", "_950_100", "default"];
        readonly color: {
            readonly light: "#f3ede5";
            readonly dark: "#28231f";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "beigeGrisGalet";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-beige-gris-galet-hover";
    readonly themePath: readonly ["background", "contrast", "beigeGrisGalet", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "beigeGrisGalet";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--beige-gris-galet-950-100-hover";
        readonly themePath: readonly ["beigeGrisGalet", "_950_100", "hover"];
        readonly color: {
            readonly light: "#e1d0b5";
            readonly dark: "#4e453f";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "beigeGrisGalet";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-beige-gris-galet-active";
    readonly themePath: readonly ["background", "contrast", "beigeGrisGalet", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "beigeGrisGalet";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--beige-gris-galet-950-100-active";
        readonly themePath: readonly ["beigeGrisGalet", "_950_100", "active"];
        readonly color: {
            readonly light: "#d1bea2";
            readonly dark: "#635950";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "beigeGrisGalet";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-info";
    readonly themePath: readonly ["background", "contrast", "info", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "info";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--info-950-100";
        readonly themePath: readonly ["info", "_950_100", "default"];
        readonly color: {
            readonly light: "#e8edff";
            readonly dark: "#1d2437";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "info";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-info-hover";
    readonly themePath: readonly ["background", "contrast", "info", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "info";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--info-950-100-hover";
        readonly themePath: readonly ["info", "_950_100", "hover"];
        readonly color: {
            readonly light: "#c2d1ff";
            readonly dark: "#3b4767";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "info";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-info-active";
    readonly themePath: readonly ["background", "contrast", "info", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "info";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--info-950-100-active";
        readonly themePath: readonly ["info", "_950_100", "active"];
        readonly color: {
            readonly light: "#a9bfff";
            readonly dark: "#4c5b83";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "info";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-success";
    readonly themePath: readonly ["background", "contrast", "success", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "success";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--success-950-100";
        readonly themePath: readonly ["success", "_950_100", "default"];
        readonly color: {
            readonly light: "#b8fec9";
            readonly dark: "#19271d";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "success";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-success-hover";
    readonly themePath: readonly ["background", "contrast", "success", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "success";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--success-950-100-hover";
        readonly themePath: readonly ["success", "_950_100", "hover"];
        readonly color: {
            readonly light: "#46fd89";
            readonly dark: "#344c3b";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "success";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-success-active";
    readonly themePath: readonly ["background", "contrast", "success", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "success";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--success-950-100-active";
        readonly themePath: readonly ["success", "_950_100", "active"];
        readonly color: {
            readonly light: "#34eb7b";
            readonly dark: "#44624d";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "success";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-warning";
    readonly themePath: readonly ["background", "contrast", "warning", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "warning";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--warning-950-100";
        readonly themePath: readonly ["warning", "_950_100", "default"];
        readonly color: {
            readonly light: "#ffe9e6";
            readonly dark: "#361e19";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "warning";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-warning-hover";
    readonly themePath: readonly ["background", "contrast", "warning", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "warning";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--warning-950-100-hover";
        readonly themePath: readonly ["warning", "_950_100", "hover"];
        readonly color: {
            readonly light: "#ffc6bd";
            readonly dark: "#663d35";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "warning";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-warning-active";
    readonly themePath: readonly ["background", "contrast", "warning", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "warning";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--warning-950-100-active";
        readonly themePath: readonly ["warning", "_950_100", "active"];
        readonly color: {
            readonly light: "#ffb0a2";
            readonly dark: "#824f44";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "warning";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-error";
    readonly themePath: readonly ["background", "contrast", "error", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "error";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--error-950-100";
        readonly themePath: readonly ["error", "_950_100", "default"];
        readonly color: {
            readonly light: "#ffe9e9";
            readonly dark: "#391c1c";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "error";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-error-hover";
    readonly themePath: readonly ["background", "contrast", "error", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "error";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--error-950-100-hover";
        readonly themePath: readonly ["error", "_950_100", "hover"];
        readonly color: {
            readonly light: "#ffc5c5";
            readonly dark: "#6c3a3a";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "error";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-error-active";
    readonly themePath: readonly ["background", "contrast", "error", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "error";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--error-950-100-active";
        readonly themePath: readonly ["error", "_950_100", "active"];
        readonly color: {
            readonly light: "#ffafaf";
            readonly dark: "#894b4b";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "error";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-flat-grey";
    readonly themePath: readonly ["background", "flat", "grey", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "grey";
        readonly usage: "flat";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-200-850";
        readonly themePath: readonly ["grey", "_200_850", "default"];
        readonly color: {
            readonly light: "#3a3a3a";
            readonly dark: "#cecece";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 200;
                };
                readonly dark: {
                    readonly value: 850;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-flat-blue-france";
    readonly themePath: readonly ["background", "flat", "blueFrance", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "blueFrance";
        readonly usage: "flat";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-france-sun-113-625";
        readonly themePath: readonly ["blueFrance", "sun113_625", "default"];
        readonly color: {
            readonly light: "#000091";
            readonly dark: "#8585f6";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueFrance";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 113;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-flat-red-marianne";
    readonly themePath: readonly ["background", "flat", "redMarianne", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "redMarianne";
        readonly usage: "flat";
    };
    readonly colorOption: {
        readonly colorOptionName: "--red-marianne-425-625";
        readonly themePath: readonly ["redMarianne", "_425_625", "default"];
        readonly color: {
            readonly light: "#c9191e";
            readonly dark: "#f95c5e";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "redMarianne";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-flat-green-tilleul-verveine";
    readonly themePath: readonly ["background", "flat", "greenTilleulVerveine", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "greenTilleulVerveine";
        readonly usage: "flat";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-tilleul-verveine-sun-418-moon-817";
        readonly themePath: readonly ["greenTilleulVerveine", "sun418moon817", "default"];
        readonly color: {
            readonly light: "#66673d";
            readonly dark: "#d8c634";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenTilleulVerveine";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 418;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 817;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-flat-green-bourgeon";
    readonly themePath: readonly ["background", "flat", "greenBourgeon", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "greenBourgeon";
        readonly usage: "flat";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-bourgeon-sun-425-moon-759";
        readonly themePath: readonly ["greenBourgeon", "sun425moon759", "default"];
        readonly color: {
            readonly light: "#447049";
            readonly dark: "#99c221";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenBourgeon";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 759;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-flat-green-emeraude";
    readonly themePath: readonly ["background", "flat", "greenEmeraude", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "greenEmeraude";
        readonly usage: "flat";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-emeraude-sun-425-moon-753";
        readonly themePath: readonly ["greenEmeraude", "sun425moon753", "default"];
        readonly color: {
            readonly light: "#297254";
            readonly dark: "#34cb6a";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenEmeraude";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 753;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-flat-green-menthe";
    readonly themePath: readonly ["background", "flat", "greenMenthe", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "greenMenthe";
        readonly usage: "flat";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-menthe-sun-373-moon-652";
        readonly themePath: readonly ["greenMenthe", "sun373moon652", "default"];
        readonly color: {
            readonly light: "#37635f";
            readonly dark: "#21ab8e";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenMenthe";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 373;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 652;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-flat-green-archipel";
    readonly themePath: readonly ["background", "flat", "greenArchipel", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "greenArchipel";
        readonly usage: "flat";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-archipel-sun-391-moon-716";
        readonly themePath: readonly ["greenArchipel", "sun391moon716", "default"];
        readonly color: {
            readonly light: "#006a6f";
            readonly dark: "#34bab5";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenArchipel";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 391;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 716;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-flat-blue-ecume";
    readonly themePath: readonly ["background", "flat", "blueEcume", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "blueEcume";
        readonly usage: "flat";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-ecume-sun-247-moon-675";
        readonly themePath: readonly ["blueEcume", "sun247moon675", "default"];
        readonly color: {
            readonly light: "#2f4077";
            readonly dark: "#869ece";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueEcume";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 247;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 675;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-flat-blue-cumulus";
    readonly themePath: readonly ["background", "flat", "blueCumulus", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "blueCumulus";
        readonly usage: "flat";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-cumulus-sun-368-moon-732";
        readonly themePath: readonly ["blueCumulus", "sun368moon732", "default"];
        readonly color: {
            readonly light: "#3558a2";
            readonly dark: "#7ab1e8";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueCumulus";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 368;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 732;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-flat-purple-glycine";
    readonly themePath: readonly ["background", "flat", "purpleGlycine", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "purpleGlycine";
        readonly usage: "flat";
    };
    readonly colorOption: {
        readonly colorOptionName: "--purple-glycine-sun-319-moon-630";
        readonly themePath: readonly ["purpleGlycine", "sun319moon630", "default"];
        readonly color: {
            readonly light: "#6e445a";
            readonly dark: "#ce70cc";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "purpleGlycine";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 319;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 630;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-flat-pink-macaron";
    readonly themePath: readonly ["background", "flat", "pinkMacaron", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "pinkMacaron";
        readonly usage: "flat";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-macaron-sun-406-moon-833";
        readonly themePath: readonly ["pinkMacaron", "sun406moon833", "default"];
        readonly color: {
            readonly light: "#8d533e";
            readonly dark: "#ffb7ae";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "pinkMacaron";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 406;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 833;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-flat-pink-tuile";
    readonly themePath: readonly ["background", "flat", "pinkTuile", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "pinkTuile";
        readonly usage: "flat";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-tuile-sun-425-moon-750";
        readonly themePath: readonly ["pinkTuile", "sun425moon750", "default"];
        readonly color: {
            readonly light: "#a94645";
            readonly dark: "#ff9575";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "pinkTuile";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 750;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-flat-yellow-tournesol";
    readonly themePath: readonly ["background", "flat", "yellowTournesol", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "yellowTournesol";
        readonly usage: "flat";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-tournesol-sun-407-moon-922";
        readonly themePath: readonly ["yellowTournesol", "sun407moon922", "default"];
        readonly color: {
            readonly light: "#716043";
            readonly dark: "#ffe552";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "yellowTournesol";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 407;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 922;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-flat-yellow-moutarde";
    readonly themePath: readonly ["background", "flat", "yellowMoutarde", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "yellowMoutarde";
        readonly usage: "flat";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-moutarde-sun-348-moon-860";
        readonly themePath: readonly ["yellowMoutarde", "sun348moon860", "default"];
        readonly color: {
            readonly light: "#695240";
            readonly dark: "#ffca00";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "yellowMoutarde";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 348;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 860;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-flat-orange-terre-battue";
    readonly themePath: readonly ["background", "flat", "orangeTerreBattue", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "orangeTerreBattue";
        readonly usage: "flat";
    };
    readonly colorOption: {
        readonly colorOptionName: "--orange-terre-battue-sun-370-moon-672";
        readonly themePath: readonly ["orangeTerreBattue", "sun370moon672", "default"];
        readonly color: {
            readonly light: "#755348";
            readonly dark: "#ff732c";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "orangeTerreBattue";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 370;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 672;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-flat-brown-cafe-creme";
    readonly themePath: readonly ["background", "flat", "brownCafeCreme", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "brownCafeCreme";
        readonly usage: "flat";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-cafe-creme-sun-383-moon-885";
        readonly themePath: readonly ["brownCafeCreme", "sun383moon885", "default"];
        readonly color: {
            readonly light: "#685c48";
            readonly dark: "#ecd7a2";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownCafeCreme";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 383;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 885;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-flat-brown-caramel";
    readonly themePath: readonly ["background", "flat", "brownCaramel", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "brownCaramel";
        readonly usage: "flat";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-caramel-sun-425-moon-901";
        readonly themePath: readonly ["brownCaramel", "sun425moon901", "default"];
        readonly color: {
            readonly light: "#845d48";
            readonly dark: "#fbd8ab";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownCaramel";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 901;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-flat-brown-opera";
    readonly themePath: readonly ["background", "flat", "brownOpera", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "brownOpera";
        readonly usage: "flat";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-opera-sun-395-moon-820";
        readonly themePath: readonly ["brownOpera", "sun395moon820", "default"];
        readonly color: {
            readonly light: "#745b47";
            readonly dark: "#e6be92";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownOpera";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 395;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 820;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-flat-beige-gris-galet";
    readonly themePath: readonly ["background", "flat", "beigeGrisGalet", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "beigeGrisGalet";
        readonly usage: "flat";
    };
    readonly colorOption: {
        readonly colorOptionName: "--beige-gris-galet-sun-407-moon-821";
        readonly themePath: readonly ["beigeGrisGalet", "sun407moon821", "default"];
        readonly color: {
            readonly light: "#6a6156";
            readonly dark: "#d0c3b7";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "beigeGrisGalet";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 407;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 821;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-flat-info";
    readonly themePath: readonly ["background", "flat", "info", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "info";
        readonly usage: "flat";
    };
    readonly colorOption: {
        readonly colorOptionName: "--info-425-625";
        readonly themePath: readonly ["info", "_425_625", "default"];
        readonly color: {
            readonly light: "#0063cb";
            readonly dark: "#518fff";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "info";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-flat-success";
    readonly themePath: readonly ["background", "flat", "success", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "success";
        readonly usage: "flat";
    };
    readonly colorOption: {
        readonly colorOptionName: "--success-425-625";
        readonly themePath: readonly ["success", "_425_625", "default"];
        readonly color: {
            readonly light: "#18753c";
            readonly dark: "#27a658";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "success";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-flat-warning";
    readonly themePath: readonly ["background", "flat", "warning", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "warning";
        readonly usage: "flat";
    };
    readonly colorOption: {
        readonly colorOptionName: "--warning-425-625";
        readonly themePath: readonly ["warning", "_425_625", "default"];
        readonly color: {
            readonly light: "#b34000";
            readonly dark: "#fc5d00";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "warning";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-flat-error";
    readonly themePath: readonly ["background", "flat", "error", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "error";
        readonly usage: "flat";
    };
    readonly colorOption: {
        readonly colorOptionName: "--error-425-625";
        readonly themePath: readonly ["error", "_425_625", "default"];
        readonly color: {
            readonly light: "#ce0500";
            readonly dark: "#ff5655";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "error";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-grey";
    readonly themePath: readonly ["background", "actionHigh", "grey", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly context: "background";
        readonly colorName: "grey";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-200-850";
        readonly themePath: readonly ["grey", "_200_850", "default"];
        readonly color: {
            readonly light: "#3a3a3a";
            readonly dark: "#cecece";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 200;
                };
                readonly dark: {
                    readonly value: 850;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-grey-hover";
    readonly themePath: readonly ["background", "actionHigh", "grey", "hover"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "grey";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-200-850-hover";
        readonly themePath: readonly ["grey", "_200_850", "hover"];
        readonly color: {
            readonly light: "#616161";
            readonly dark: "#a8a8a8";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 200;
                };
                readonly dark: {
                    readonly value: 850;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-grey-active";
    readonly themePath: readonly ["background", "actionHigh", "grey", "active"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "grey";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-200-850-active";
        readonly themePath: readonly ["grey", "_200_850", "active"];
        readonly color: {
            readonly light: "#777777";
            readonly dark: "#939393";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 200;
                };
                readonly dark: {
                    readonly value: 850;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-blue-france";
    readonly themePath: readonly ["background", "actionHigh", "blueFrance", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly context: "background";
        readonly colorName: "blueFrance";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-france-sun-113-625";
        readonly themePath: readonly ["blueFrance", "sun113_625", "default"];
        readonly color: {
            readonly light: "#000091";
            readonly dark: "#8585f6";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueFrance";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 113;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-blue-france-hover";
    readonly themePath: readonly ["background", "actionHigh", "blueFrance", "hover"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "blueFrance";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-france-sun-113-625-hover";
        readonly themePath: readonly ["blueFrance", "sun113_625", "hover"];
        readonly color: {
            readonly light: "#1212ff";
            readonly dark: "#b1b1f9";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueFrance";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 113;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-blue-france-active";
    readonly themePath: readonly ["background", "actionHigh", "blueFrance", "active"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "blueFrance";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-france-sun-113-625-active";
        readonly themePath: readonly ["blueFrance", "sun113_625", "active"];
        readonly color: {
            readonly light: "#2323ff";
            readonly dark: "#c6c6fb";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueFrance";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 113;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-red-marianne";
    readonly themePath: readonly ["background", "actionHigh", "redMarianne", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly context: "background";
        readonly colorName: "redMarianne";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--red-marianne-425-625";
        readonly themePath: readonly ["redMarianne", "_425_625", "default"];
        readonly color: {
            readonly light: "#c9191e";
            readonly dark: "#f95c5e";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "redMarianne";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-red-marianne-hover";
    readonly themePath: readonly ["background", "actionHigh", "redMarianne", "hover"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "redMarianne";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--red-marianne-425-625-hover";
        readonly themePath: readonly ["redMarianne", "_425_625", "hover"];
        readonly color: {
            readonly light: "#f93f42";
            readonly dark: "#fa9293";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "redMarianne";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-red-marianne-active";
    readonly themePath: readonly ["background", "actionHigh", "redMarianne", "active"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "redMarianne";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--red-marianne-425-625-active";
        readonly themePath: readonly ["redMarianne", "_425_625", "active"];
        readonly color: {
            readonly light: "#f95a5c";
            readonly dark: "#fbabac";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "redMarianne";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-green-tilleul-verveine";
    readonly themePath: readonly ["background", "actionHigh", "greenTilleulVerveine", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly context: "background";
        readonly colorName: "greenTilleulVerveine";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-tilleul-verveine-sun-418-moon-817";
        readonly themePath: readonly ["greenTilleulVerveine", "sun418moon817", "default"];
        readonly color: {
            readonly light: "#66673d";
            readonly dark: "#d8c634";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenTilleulVerveine";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 418;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 817;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-green-tilleul-verveine-hover";
    readonly themePath: readonly ["background", "actionHigh", "greenTilleulVerveine", "hover"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "greenTilleulVerveine";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-tilleul-verveine-sun-418-moon-817-hover";
        readonly themePath: readonly ["greenTilleulVerveine", "sun418moon817", "hover"];
        readonly color: {
            readonly light: "#929359";
            readonly dark: "#fee943";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenTilleulVerveine";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 418;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 817;
                    readonly variant: "moon";
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-green-tilleul-verveine-active";
    readonly themePath: readonly ["background", "actionHigh", "greenTilleulVerveine", "active"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "greenTilleulVerveine";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-tilleul-verveine-sun-418-moon-817-active";
        readonly themePath: readonly ["greenTilleulVerveine", "sun418moon817", "active"];
        readonly color: {
            readonly light: "#a7a967";
            readonly dark: "#fef1ab";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenTilleulVerveine";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 418;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 817;
                    readonly variant: "moon";
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-green-bourgeon";
    readonly themePath: readonly ["background", "actionHigh", "greenBourgeon", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly context: "background";
        readonly colorName: "greenBourgeon";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-bourgeon-sun-425-moon-759";
        readonly themePath: readonly ["greenBourgeon", "sun425moon759", "default"];
        readonly color: {
            readonly light: "#447049";
            readonly dark: "#99c221";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenBourgeon";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 759;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-green-bourgeon-hover";
    readonly themePath: readonly ["background", "actionHigh", "greenBourgeon", "hover"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "greenBourgeon";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-bourgeon-sun-425-moon-759-hover";
        readonly themePath: readonly ["greenBourgeon", "sun425moon759", "hover"];
        readonly color: {
            readonly light: "#639f6a";
            readonly dark: "#baec2a";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenBourgeon";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 759;
                    readonly variant: "moon";
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-green-bourgeon-active";
    readonly themePath: readonly ["background", "actionHigh", "greenBourgeon", "active"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "greenBourgeon";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-bourgeon-sun-425-moon-759-active";
        readonly themePath: readonly ["greenBourgeon", "sun425moon759", "active"];
        readonly color: {
            readonly light: "#72b77a";
            readonly dark: "#c9fd2e";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenBourgeon";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 759;
                    readonly variant: "moon";
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-green-emeraude";
    readonly themePath: readonly ["background", "actionHigh", "greenEmeraude", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly context: "background";
        readonly colorName: "greenEmeraude";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-emeraude-sun-425-moon-753";
        readonly themePath: readonly ["greenEmeraude", "sun425moon753", "default"];
        readonly color: {
            readonly light: "#297254";
            readonly dark: "#34cb6a";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenEmeraude";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 753;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-green-emeraude-hover";
    readonly themePath: readonly ["background", "actionHigh", "greenEmeraude", "hover"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "greenEmeraude";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-emeraude-sun-425-moon-753-hover";
        readonly themePath: readonly ["greenEmeraude", "sun425moon753", "hover"];
        readonly color: {
            readonly light: "#3ea47a";
            readonly dark: "#42fb84";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenEmeraude";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 753;
                    readonly variant: "moon";
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-green-emeraude-active";
    readonly themePath: readonly ["background", "actionHigh", "greenEmeraude", "active"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "greenEmeraude";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-emeraude-sun-425-moon-753-active";
        readonly themePath: readonly ["greenEmeraude", "sun425moon753", "active"];
        readonly color: {
            readonly light: "#49bc8d";
            readonly dark: "#80fda3";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenEmeraude";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 753;
                    readonly variant: "moon";
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-green-menthe";
    readonly themePath: readonly ["background", "actionHigh", "greenMenthe", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly context: "background";
        readonly colorName: "greenMenthe";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-menthe-sun-373-moon-652";
        readonly themePath: readonly ["greenMenthe", "sun373moon652", "default"];
        readonly color: {
            readonly light: "#37635f";
            readonly dark: "#21ab8e";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenMenthe";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 373;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 652;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-green-menthe-hover";
    readonly themePath: readonly ["background", "actionHigh", "greenMenthe", "hover"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "greenMenthe";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-menthe-sun-373-moon-652-hover";
        readonly themePath: readonly ["greenMenthe", "sun373moon652", "hover"];
        readonly color: {
            readonly light: "#53918c";
            readonly dark: "#2eddb8";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenMenthe";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 373;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 652;
                    readonly variant: "moon";
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-green-menthe-active";
    readonly themePath: readonly ["background", "actionHigh", "greenMenthe", "active"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "greenMenthe";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-menthe-sun-373-moon-652-active";
        readonly themePath: readonly ["greenMenthe", "sun373moon652", "active"];
        readonly color: {
            readonly light: "#62a9a2";
            readonly dark: "#34f4cc";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenMenthe";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 373;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 652;
                    readonly variant: "moon";
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-green-archipel";
    readonly themePath: readonly ["background", "actionHigh", "greenArchipel", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly context: "background";
        readonly colorName: "greenArchipel";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-archipel-sun-391-moon-716";
        readonly themePath: readonly ["greenArchipel", "sun391moon716", "default"];
        readonly color: {
            readonly light: "#006a6f";
            readonly dark: "#34bab5";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenArchipel";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 391;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 716;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-green-archipel-hover";
    readonly themePath: readonly ["background", "actionHigh", "greenArchipel", "hover"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "greenArchipel";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-archipel-sun-391-moon-716-hover";
        readonly themePath: readonly ["greenArchipel", "sun391moon716", "hover"];
        readonly color: {
            readonly light: "#009fa7";
            readonly dark: "#43e9e2";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenArchipel";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 391;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 716;
                    readonly variant: "moon";
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-green-archipel-active";
    readonly themePath: readonly ["background", "actionHigh", "greenArchipel", "active"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "greenArchipel";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-archipel-sun-391-moon-716-active";
        readonly themePath: readonly ["greenArchipel", "sun391moon716", "active"];
        readonly color: {
            readonly light: "#00bbc3";
            readonly dark: "#4cfdf6";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenArchipel";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 391;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 716;
                    readonly variant: "moon";
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-blue-ecume";
    readonly themePath: readonly ["background", "actionHigh", "blueEcume", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly context: "background";
        readonly colorName: "blueEcume";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-ecume-sun-247-moon-675";
        readonly themePath: readonly ["blueEcume", "sun247moon675", "default"];
        readonly color: {
            readonly light: "#2f4077";
            readonly dark: "#869ece";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueEcume";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 247;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 675;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-blue-ecume-hover";
    readonly themePath: readonly ["background", "actionHigh", "blueEcume", "hover"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "blueEcume";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-ecume-sun-247-moon-675-hover";
        readonly themePath: readonly ["blueEcume", "sun247moon675", "hover"];
        readonly color: {
            readonly light: "#4e68bb";
            readonly dark: "#b8c5e2";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueEcume";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 247;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 675;
                    readonly variant: "moon";
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-blue-ecume-active";
    readonly themePath: readonly ["background", "actionHigh", "blueEcume", "active"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "blueEcume";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-ecume-sun-247-moon-675-active";
        readonly themePath: readonly ["blueEcume", "sun247moon675", "active"];
        readonly color: {
            readonly light: "#667dcf";
            readonly dark: "#ced6ea";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueEcume";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 247;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 675;
                    readonly variant: "moon";
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-blue-cumulus";
    readonly themePath: readonly ["background", "actionHigh", "blueCumulus", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly context: "background";
        readonly colorName: "blueCumulus";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-cumulus-sun-368-moon-732";
        readonly themePath: readonly ["blueCumulus", "sun368moon732", "default"];
        readonly color: {
            readonly light: "#3558a2";
            readonly dark: "#7ab1e8";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueCumulus";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 368;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 732;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-blue-cumulus-hover";
    readonly themePath: readonly ["background", "actionHigh", "blueCumulus", "hover"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "blueCumulus";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-cumulus-sun-368-moon-732-hover";
        readonly themePath: readonly ["blueCumulus", "sun368moon732", "hover"];
        readonly color: {
            readonly light: "#5982e0";
            readonly dark: "#bad2f2";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueCumulus";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 368;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 732;
                    readonly variant: "moon";
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-blue-cumulus-active";
    readonly themePath: readonly ["background", "actionHigh", "blueCumulus", "active"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "blueCumulus";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-cumulus-sun-368-moon-732-active";
        readonly themePath: readonly ["blueCumulus", "sun368moon732", "active"];
        readonly color: {
            readonly light: "#7996e6";
            readonly dark: "#d2e2f6";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueCumulus";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 368;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 732;
                    readonly variant: "moon";
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-purple-glycine";
    readonly themePath: readonly ["background", "actionHigh", "purpleGlycine", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly context: "background";
        readonly colorName: "purpleGlycine";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--purple-glycine-sun-319-moon-630";
        readonly themePath: readonly ["purpleGlycine", "sun319moon630", "default"];
        readonly color: {
            readonly light: "#6e445a";
            readonly dark: "#ce70cc";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "purpleGlycine";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 319;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 630;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-purple-glycine-hover";
    readonly themePath: readonly ["background", "actionHigh", "purpleGlycine", "hover"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "purpleGlycine";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--purple-glycine-sun-319-moon-630-hover";
        readonly themePath: readonly ["purpleGlycine", "sun319moon630", "hover"];
        readonly color: {
            readonly light: "#a66989";
            readonly dark: "#dfa4dd";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "purpleGlycine";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 319;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 630;
                    readonly variant: "moon";
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-purple-glycine-active";
    readonly themePath: readonly ["background", "actionHigh", "purpleGlycine", "active"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "purpleGlycine";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--purple-glycine-sun-319-moon-630-active";
        readonly themePath: readonly ["purpleGlycine", "sun319moon630", "active"];
        readonly color: {
            readonly light: "#bb7f9e";
            readonly dark: "#e7bbe6";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "purpleGlycine";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 319;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 630;
                    readonly variant: "moon";
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-pink-macaron";
    readonly themePath: readonly ["background", "actionHigh", "pinkMacaron", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly context: "background";
        readonly colorName: "pinkMacaron";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-macaron-sun-406-moon-833";
        readonly themePath: readonly ["pinkMacaron", "sun406moon833", "default"];
        readonly color: {
            readonly light: "#8d533e";
            readonly dark: "#ffb7ae";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "pinkMacaron";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 406;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 833;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-pink-macaron-hover";
    readonly themePath: readonly ["background", "actionHigh", "pinkMacaron", "hover"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "pinkMacaron";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-macaron-sun-406-moon-833-hover";
        readonly themePath: readonly ["pinkMacaron", "sun406moon833", "hover"];
        readonly color: {
            readonly light: "#ca795c";
            readonly dark: "#ffe0dc";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "pinkMacaron";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 406;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 833;
                    readonly variant: "moon";
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-pink-macaron-active";
    readonly themePath: readonly ["background", "actionHigh", "pinkMacaron", "active"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "pinkMacaron";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-macaron-sun-406-moon-833-active";
        readonly themePath: readonly ["pinkMacaron", "sun406moon833", "active"];
        readonly color: {
            readonly light: "#e08e73";
            readonly dark: "#fff0ee";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "pinkMacaron";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 406;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 833;
                    readonly variant: "moon";
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-pink-tuile";
    readonly themePath: readonly ["background", "actionHigh", "pinkTuile", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly context: "background";
        readonly colorName: "pinkTuile";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-tuile-sun-425-moon-750";
        readonly themePath: readonly ["pinkTuile", "sun425moon750", "default"];
        readonly color: {
            readonly light: "#a94645";
            readonly dark: "#ff9575";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "pinkTuile";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 750;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-pink-tuile-hover";
    readonly themePath: readonly ["background", "actionHigh", "pinkTuile", "hover"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "pinkTuile";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-tuile-sun-425-moon-750-hover";
        readonly themePath: readonly ["pinkTuile", "sun425moon750", "hover"];
        readonly color: {
            readonly light: "#d5706f";
            readonly dark: "#ffc4b7";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "pinkTuile";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 750;
                    readonly variant: "moon";
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-pink-tuile-active";
    readonly themePath: readonly ["background", "actionHigh", "pinkTuile", "active"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "pinkTuile";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-tuile-sun-425-moon-750-active";
        readonly themePath: readonly ["pinkTuile", "sun425moon750", "active"];
        readonly color: {
            readonly light: "#da8a89";
            readonly dark: "#ffd8d0";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "pinkTuile";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 750;
                    readonly variant: "moon";
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-yellow-tournesol";
    readonly themePath: readonly ["background", "actionHigh", "yellowTournesol", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly context: "background";
        readonly colorName: "yellowTournesol";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-tournesol-sun-407-moon-922";
        readonly themePath: readonly ["yellowTournesol", "sun407moon922", "default"];
        readonly color: {
            readonly light: "#716043";
            readonly dark: "#ffe552";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "yellowTournesol";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 407;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 922;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-yellow-tournesol-hover";
    readonly themePath: readonly ["background", "actionHigh", "yellowTournesol", "hover"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "yellowTournesol";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-tournesol-sun-407-moon-922-hover";
        readonly themePath: readonly ["yellowTournesol", "sun407moon922", "hover"];
        readonly color: {
            readonly light: "#a28a62";
            readonly dark: "#e1c700";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "yellowTournesol";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 407;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 922;
                    readonly variant: "moon";
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-yellow-tournesol-active";
    readonly themePath: readonly ["background", "actionHigh", "yellowTournesol", "active"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "yellowTournesol";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-tournesol-sun-407-moon-922-active";
        readonly themePath: readonly ["yellowTournesol", "sun407moon922", "active"];
        readonly color: {
            readonly light: "#ba9f72";
            readonly dark: "#cab300";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "yellowTournesol";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 407;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 922;
                    readonly variant: "moon";
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-yellow-moutarde";
    readonly themePath: readonly ["background", "actionHigh", "yellowMoutarde", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly context: "background";
        readonly colorName: "yellowMoutarde";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-moutarde-sun-348-moon-860";
        readonly themePath: readonly ["yellowMoutarde", "sun348moon860", "default"];
        readonly color: {
            readonly light: "#695240";
            readonly dark: "#ffca00";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "yellowMoutarde";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 348;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 860;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-yellow-moutarde-hover";
    readonly themePath: readonly ["background", "actionHigh", "yellowMoutarde", "hover"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "yellowMoutarde";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-moutarde-sun-348-moon-860-hover";
        readonly themePath: readonly ["yellowMoutarde", "sun348moon860", "hover"];
        readonly color: {
            readonly light: "#9b7b61";
            readonly dark: "#cda200";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "yellowMoutarde";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 348;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 860;
                    readonly variant: "moon";
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-yellow-moutarde-active";
    readonly themePath: readonly ["background", "actionHigh", "yellowMoutarde", "active"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "yellowMoutarde";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-moutarde-sun-348-moon-860-active";
        readonly themePath: readonly ["yellowMoutarde", "sun348moon860", "active"];
        readonly color: {
            readonly light: "#b58f72";
            readonly dark: "#b28c00";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "yellowMoutarde";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 348;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 860;
                    readonly variant: "moon";
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-orange-terre-battue";
    readonly themePath: readonly ["background", "actionHigh", "orangeTerreBattue", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly context: "background";
        readonly colorName: "orangeTerreBattue";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--orange-terre-battue-sun-370-moon-672";
        readonly themePath: readonly ["orangeTerreBattue", "sun370moon672", "default"];
        readonly color: {
            readonly light: "#755348";
            readonly dark: "#ff732c";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "orangeTerreBattue";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 370;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 672;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-orange-terre-battue-hover";
    readonly themePath: readonly ["background", "actionHigh", "orangeTerreBattue", "hover"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "orangeTerreBattue";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--orange-terre-battue-sun-370-moon-672-hover";
        readonly themePath: readonly ["orangeTerreBattue", "sun370moon672", "hover"];
        readonly color: {
            readonly light: "#ab7b6b";
            readonly dark: "#ffa48b";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "orangeTerreBattue";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 370;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 672;
                    readonly variant: "moon";
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-orange-terre-battue-active";
    readonly themePath: readonly ["background", "actionHigh", "orangeTerreBattue", "active"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "orangeTerreBattue";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--orange-terre-battue-sun-370-moon-672-active";
        readonly themePath: readonly ["orangeTerreBattue", "sun370moon672", "active"];
        readonly color: {
            readonly light: "#c68f7d";
            readonly dark: "#ffbbab";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "orangeTerreBattue";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 370;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 672;
                    readonly variant: "moon";
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-brown-cafe-creme";
    readonly themePath: readonly ["background", "actionHigh", "brownCafeCreme", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly context: "background";
        readonly colorName: "brownCafeCreme";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-cafe-creme-sun-383-moon-885";
        readonly themePath: readonly ["brownCafeCreme", "sun383moon885", "default"];
        readonly color: {
            readonly light: "#685c48";
            readonly dark: "#ecd7a2";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownCafeCreme";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 383;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 885;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-brown-cafe-creme-hover";
    readonly themePath: readonly ["background", "actionHigh", "brownCafeCreme", "hover"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "brownCafeCreme";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-cafe-creme-sun-383-moon-885-hover";
        readonly themePath: readonly ["brownCafeCreme", "sun383moon885", "hover"];
        readonly color: {
            readonly light: "#97866a";
            readonly dark: "#c5b386";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownCafeCreme";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 383;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 885;
                    readonly variant: "moon";
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-brown-cafe-creme-active";
    readonly themePath: readonly ["background", "actionHigh", "brownCafeCreme", "active"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "brownCafeCreme";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-cafe-creme-sun-383-moon-885-active";
        readonly themePath: readonly ["brownCafeCreme", "sun383moon885", "active"];
        readonly color: {
            readonly light: "#ae9b7b";
            readonly dark: "#af9f77";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownCafeCreme";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 383;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 885;
                    readonly variant: "moon";
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-brown-caramel";
    readonly themePath: readonly ["background", "actionHigh", "brownCaramel", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly context: "background";
        readonly colorName: "brownCaramel";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-caramel-sun-425-moon-901";
        readonly themePath: readonly ["brownCaramel", "sun425moon901", "default"];
        readonly color: {
            readonly light: "#845d48";
            readonly dark: "#fbd8ab";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownCaramel";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 901;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-brown-caramel-hover";
    readonly themePath: readonly ["background", "actionHigh", "brownCaramel", "hover"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "brownCaramel";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-caramel-sun-425-moon-901-hover";
        readonly themePath: readonly ["brownCaramel", "sun425moon901", "hover"];
        readonly color: {
            readonly light: "#bb8568";
            readonly dark: "#efb547";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownCaramel";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 901;
                    readonly variant: "moon";
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-brown-caramel-active";
    readonly themePath: readonly ["background", "actionHigh", "brownCaramel", "active"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "brownCaramel";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-caramel-sun-425-moon-901-active";
        readonly themePath: readonly ["brownCaramel", "sun425moon901", "active"];
        readonly color: {
            readonly light: "#d69978";
            readonly dark: "#d6a23e";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownCaramel";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 901;
                    readonly variant: "moon";
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-brown-opera";
    readonly themePath: readonly ["background", "actionHigh", "brownOpera", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly context: "background";
        readonly colorName: "brownOpera";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-opera-sun-395-moon-820";
        readonly themePath: readonly ["brownOpera", "sun395moon820", "default"];
        readonly color: {
            readonly light: "#745b47";
            readonly dark: "#e6be92";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownOpera";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 395;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 820;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-brown-opera-hover";
    readonly themePath: readonly ["background", "actionHigh", "brownOpera", "hover"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "brownOpera";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-opera-sun-395-moon-820-hover";
        readonly themePath: readonly ["brownOpera", "sun395moon820", "hover"];
        readonly color: {
            readonly light: "#a78468";
            readonly dark: "#f2e2d3";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownOpera";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 395;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 820;
                    readonly variant: "moon";
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-brown-opera-active";
    readonly themePath: readonly ["background", "actionHigh", "brownOpera", "active"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "brownOpera";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-opera-sun-395-moon-820-active";
        readonly themePath: readonly ["brownOpera", "sun395moon820", "active"];
        readonly color: {
            readonly light: "#c09979";
            readonly dark: "#f8f0e9";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownOpera";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 395;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 820;
                    readonly variant: "moon";
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-beige-gris-galet";
    readonly themePath: readonly ["background", "actionHigh", "beigeGrisGalet", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly context: "background";
        readonly colorName: "beigeGrisGalet";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--beige-gris-galet-sun-407-moon-821";
        readonly themePath: readonly ["beigeGrisGalet", "sun407moon821", "default"];
        readonly color: {
            readonly light: "#6a6156";
            readonly dark: "#d0c3b7";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "beigeGrisGalet";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 407;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 821;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-beige-gris-galet-hover";
    readonly themePath: readonly ["background", "actionHigh", "beigeGrisGalet", "hover"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "beigeGrisGalet";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--beige-gris-galet-sun-407-moon-821-hover";
        readonly themePath: readonly ["beigeGrisGalet", "sun407moon821", "hover"];
        readonly color: {
            readonly light: "#988b7c";
            readonly dark: "#eae5e1";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "beigeGrisGalet";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 407;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 821;
                    readonly variant: "moon";
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-beige-gris-galet-active";
    readonly themePath: readonly ["background", "actionHigh", "beigeGrisGalet", "active"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "beigeGrisGalet";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--beige-gris-galet-sun-407-moon-821-active";
        readonly themePath: readonly ["beigeGrisGalet", "sun407moon821", "active"];
        readonly color: {
            readonly light: "#afa08f";
            readonly dark: "#f4f2f0";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "beigeGrisGalet";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 407;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 821;
                    readonly variant: "moon";
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-info";
    readonly themePath: readonly ["background", "actionHigh", "info", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly context: "background";
        readonly colorName: "info";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--info-425-625";
        readonly themePath: readonly ["info", "_425_625", "default"];
        readonly color: {
            readonly light: "#0063cb";
            readonly dark: "#518fff";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "info";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-info-hover";
    readonly themePath: readonly ["background", "actionHigh", "info", "hover"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "info";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--info-425-625-hover";
        readonly themePath: readonly ["info", "_425_625", "hover"];
        readonly color: {
            readonly light: "#3b87ff";
            readonly dark: "#98b4ff";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "info";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-info-active";
    readonly themePath: readonly ["background", "actionHigh", "info", "active"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "info";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--info-425-625-active";
        readonly themePath: readonly ["info", "_425_625", "active"];
        readonly color: {
            readonly light: "#6798ff";
            readonly dark: "#b4c7ff";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "info";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-success";
    readonly themePath: readonly ["background", "actionHigh", "success", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly context: "background";
        readonly colorName: "success";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--success-425-625";
        readonly themePath: readonly ["success", "_425_625", "default"];
        readonly color: {
            readonly light: "#18753c";
            readonly dark: "#27a658";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "success";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-success-hover";
    readonly themePath: readonly ["background", "actionHigh", "success", "hover"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "success";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--success-425-625-hover";
        readonly themePath: readonly ["success", "_425_625", "hover"];
        readonly color: {
            readonly light: "#27a959";
            readonly dark: "#36d975";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "success";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-success-active";
    readonly themePath: readonly ["background", "actionHigh", "success", "active"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "success";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--success-425-625-active";
        readonly themePath: readonly ["success", "_425_625", "active"];
        readonly color: {
            readonly light: "#2fc368";
            readonly dark: "#3df183";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "success";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-warning";
    readonly themePath: readonly ["background", "actionHigh", "warning", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly context: "background";
        readonly colorName: "warning";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--warning-425-625";
        readonly themePath: readonly ["warning", "_425_625", "default"];
        readonly color: {
            readonly light: "#b34000";
            readonly dark: "#fc5d00";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "warning";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-warning-hover";
    readonly themePath: readonly ["background", "actionHigh", "warning", "hover"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "warning";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--warning-425-625-hover";
        readonly themePath: readonly ["warning", "_425_625", "hover"];
        readonly color: {
            readonly light: "#ff6218";
            readonly dark: "#ff8c73";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "warning";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-warning-active";
    readonly themePath: readonly ["background", "actionHigh", "warning", "active"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "warning";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--warning-425-625-active";
        readonly themePath: readonly ["warning", "_425_625", "active"];
        readonly color: {
            readonly light: "#ff7a55";
            readonly dark: "#ffa595";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "warning";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-error";
    readonly themePath: readonly ["background", "actionHigh", "error", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly context: "background";
        readonly colorName: "error";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--error-425-625";
        readonly themePath: readonly ["error", "_425_625", "default"];
        readonly color: {
            readonly light: "#ce0500";
            readonly dark: "#ff5655";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "error";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-error-hover";
    readonly themePath: readonly ["background", "actionHigh", "error", "hover"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "error";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--error-425-625-hover";
        readonly themePath: readonly ["error", "_425_625", "hover"];
        readonly color: {
            readonly light: "#ff2725";
            readonly dark: "#ff8c8c";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "error";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-high-error-active";
    readonly themePath: readonly ["background", "actionHigh", "error", "active"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "error";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--error-425-625-active";
        readonly themePath: readonly ["error", "_425_625", "active"];
        readonly color: {
            readonly light: "#ff4140";
            readonly dark: "#ffa6a6";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "error";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-blue-france";
    readonly themePath: readonly ["background", "actionLow", "blueFrance", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly context: "background";
        readonly colorName: "blueFrance";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-france-925-125";
        readonly themePath: readonly ["blueFrance", "_925_125", "default"];
        readonly color: {
            readonly light: "#e3e3fd";
            readonly dark: "#272747";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueFrance";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-blue-france-hover";
    readonly themePath: readonly ["background", "actionLow", "blueFrance", "hover"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "blueFrance";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-france-925-125-hover";
        readonly themePath: readonly ["blueFrance", "_925_125", "hover"];
        readonly color: {
            readonly light: "#c1c1fb";
            readonly dark: "#4a4a7d";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueFrance";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-blue-france-active";
    readonly themePath: readonly ["background", "actionLow", "blueFrance", "active"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "blueFrance";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-france-925-125-active";
        readonly themePath: readonly ["blueFrance", "_925_125", "active"];
        readonly color: {
            readonly light: "#adadf9";
            readonly dark: "#5e5e90";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueFrance";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-red-marianne";
    readonly themePath: readonly ["background", "actionLow", "redMarianne", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly context: "background";
        readonly colorName: "redMarianne";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--red-marianne-925-125";
        readonly themePath: readonly ["redMarianne", "_925_125", "default"];
        readonly color: {
            readonly light: "#fddede";
            readonly dark: "#3b2424";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "redMarianne";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-red-marianne-hover";
    readonly themePath: readonly ["background", "actionLow", "redMarianne", "hover"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "redMarianne";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--red-marianne-925-125-hover";
        readonly themePath: readonly ["redMarianne", "_925_125", "hover"];
        readonly color: {
            readonly light: "#fbb6b6";
            readonly dark: "#6b4545";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "redMarianne";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-red-marianne-active";
    readonly themePath: readonly ["background", "actionLow", "redMarianne", "active"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "redMarianne";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--red-marianne-925-125-active";
        readonly themePath: readonly ["redMarianne", "_925_125", "active"];
        readonly color: {
            readonly light: "#fa9e9e";
            readonly dark: "#865757";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "redMarianne";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-green-tilleul-verveine";
    readonly themePath: readonly ["background", "actionLow", "greenTilleulVerveine", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly context: "background";
        readonly colorName: "greenTilleulVerveine";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-tilleul-verveine-925-125";
        readonly themePath: readonly ["greenTilleulVerveine", "_925_125", "default"];
        readonly color: {
            readonly light: "#fbe769";
            readonly dark: "#2d2a1d";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenTilleulVerveine";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-green-tilleul-verveine-hover";
    readonly themePath: readonly ["background", "actionLow", "greenTilleulVerveine", "hover"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "greenTilleulVerveine";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-tilleul-verveine-925-125-hover";
        readonly themePath: readonly ["greenTilleulVerveine", "_925_125", "hover"];
        readonly color: {
            readonly light: "#d7c655";
            readonly dark: "#534f39";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenTilleulVerveine";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-green-tilleul-verveine-active";
    readonly themePath: readonly ["background", "actionLow", "greenTilleulVerveine", "active"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "greenTilleulVerveine";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-tilleul-verveine-925-125-active";
        readonly themePath: readonly ["greenTilleulVerveine", "_925_125", "active"];
        readonly color: {
            readonly light: "#c2b24c";
            readonly dark: "#696349";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenTilleulVerveine";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-green-bourgeon";
    readonly themePath: readonly ["background", "actionLow", "greenBourgeon", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly context: "background";
        readonly colorName: "greenBourgeon";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-bourgeon-925-125";
        readonly themePath: readonly ["greenBourgeon", "_925_125", "default"];
        readonly color: {
            readonly light: "#a9fb68";
            readonly dark: "#232d1d";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenBourgeon";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-green-bourgeon-hover";
    readonly themePath: readonly ["background", "actionLow", "greenBourgeon", "hover"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "greenBourgeon";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-bourgeon-925-125-hover";
        readonly themePath: readonly ["greenBourgeon", "_925_125", "hover"];
        readonly color: {
            readonly light: "#8ed654";
            readonly dark: "#435339";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenBourgeon";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-green-bourgeon-active";
    readonly themePath: readonly ["background", "actionLow", "greenBourgeon", "active"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "greenBourgeon";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-bourgeon-925-125-active";
        readonly themePath: readonly ["greenBourgeon", "_925_125", "active"];
        readonly color: {
            readonly light: "#7fc04b";
            readonly dark: "#556949";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenBourgeon";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-green-emeraude";
    readonly themePath: readonly ["background", "actionLow", "greenEmeraude", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly context: "background";
        readonly colorName: "greenEmeraude";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-emeraude-925-125";
        readonly themePath: readonly ["greenEmeraude", "_925_125", "default"];
        readonly color: {
            readonly light: "#9ef9be";
            readonly dark: "#1e2e23";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenEmeraude";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-green-emeraude-hover";
    readonly themePath: readonly ["background", "actionLow", "greenEmeraude", "hover"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "greenEmeraude";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-emeraude-925-125-hover";
        readonly themePath: readonly ["greenEmeraude", "_925_125", "hover"];
        readonly color: {
            readonly light: "#69df97";
            readonly dark: "#3b5543";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenEmeraude";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-green-emeraude-active";
    readonly themePath: readonly ["background", "actionLow", "greenEmeraude", "active"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "greenEmeraude";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-emeraude-925-125-active";
        readonly themePath: readonly ["greenEmeraude", "_925_125", "active"];
        readonly color: {
            readonly light: "#5ec988";
            readonly dark: "#4b6b55";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenEmeraude";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-green-menthe";
    readonly themePath: readonly ["background", "actionLow", "greenMenthe", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly context: "background";
        readonly colorName: "greenMenthe";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-menthe-925-125";
        readonly themePath: readonly ["greenMenthe", "_925_125", "default"];
        readonly color: {
            readonly light: "#8bf8e7";
            readonly dark: "#1f2d2a";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenMenthe";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-green-menthe-hover";
    readonly themePath: readonly ["background", "actionLow", "greenMenthe", "hover"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "greenMenthe";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-menthe-925-125-hover";
        readonly themePath: readonly ["greenMenthe", "_925_125", "hover"];
        readonly color: {
            readonly light: "#6ed5c5";
            readonly dark: "#3c534e";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenMenthe";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-green-menthe-active";
    readonly themePath: readonly ["background", "actionLow", "greenMenthe", "active"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "greenMenthe";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-menthe-925-125-active";
        readonly themePath: readonly ["greenMenthe", "_925_125", "active"];
        readonly color: {
            readonly light: "#62bfb1";
            readonly dark: "#4d6963";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenMenthe";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-green-archipel";
    readonly themePath: readonly ["background", "actionLow", "greenArchipel", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly context: "background";
        readonly colorName: "greenArchipel";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-archipel-925-125";
        readonly themePath: readonly ["greenArchipel", "_925_125", "default"];
        readonly color: {
            readonly light: "#a6f2fa";
            readonly dark: "#1f2c2e";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenArchipel";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-green-archipel-hover";
    readonly themePath: readonly ["background", "actionLow", "greenArchipel", "hover"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "greenArchipel";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-archipel-925-125-hover";
        readonly themePath: readonly ["greenArchipel", "_925_125", "hover"];
        readonly color: {
            readonly light: "#62dbe5";
            readonly dark: "#3c5255";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenArchipel";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-green-archipel-active";
    readonly themePath: readonly ["background", "actionLow", "greenArchipel", "active"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "greenArchipel";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-archipel-925-125-active";
        readonly themePath: readonly ["greenArchipel", "_925_125", "active"];
        readonly color: {
            readonly light: "#58c5cf";
            readonly dark: "#4d676b";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenArchipel";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-blue-ecume";
    readonly themePath: readonly ["background", "actionLow", "blueEcume", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly context: "background";
        readonly colorName: "blueEcume";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-ecume-925-125";
        readonly themePath: readonly ["blueEcume", "_925_125", "default"];
        readonly color: {
            readonly light: "#dee5fd";
            readonly dark: "#222940";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueEcume";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-blue-ecume-hover";
    readonly themePath: readonly ["background", "actionLow", "blueEcume", "hover"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "blueEcume";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-ecume-925-125-hover";
        readonly themePath: readonly ["blueEcume", "_925_125", "hover"];
        readonly color: {
            readonly light: "#b4c5fb";
            readonly dark: "#424d73";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueEcume";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-blue-ecume-active";
    readonly themePath: readonly ["background", "actionLow", "blueEcume", "active"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "blueEcume";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-ecume-925-125-active";
        readonly themePath: readonly ["blueEcume", "_925_125", "active"];
        readonly color: {
            readonly light: "#99b3f9";
            readonly dark: "#536190";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueEcume";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-blue-cumulus";
    readonly themePath: readonly ["background", "actionLow", "blueCumulus", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly context: "background";
        readonly colorName: "blueCumulus";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-cumulus-925-125";
        readonly themePath: readonly ["blueCumulus", "_925_125", "default"];
        readonly color: {
            readonly light: "#dae6fd";
            readonly dark: "#212a3a";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueCumulus";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-blue-cumulus-hover";
    readonly themePath: readonly ["background", "actionLow", "blueCumulus", "hover"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "blueCumulus";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-cumulus-925-125-hover";
        readonly themePath: readonly ["blueCumulus", "_925_125", "hover"];
        readonly color: {
            readonly light: "#a9c8fb";
            readonly dark: "#404f69";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueCumulus";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-blue-cumulus-active";
    readonly themePath: readonly ["background", "actionLow", "blueCumulus", "active"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "blueCumulus";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-cumulus-925-125-active";
        readonly themePath: readonly ["blueCumulus", "_925_125", "active"];
        readonly color: {
            readonly light: "#8ab8f9";
            readonly dark: "#516384";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueCumulus";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-purple-glycine";
    readonly themePath: readonly ["background", "actionLow", "purpleGlycine", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly context: "background";
        readonly colorName: "purpleGlycine";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--purple-glycine-925-125";
        readonly themePath: readonly ["purpleGlycine", "_925_125", "default"];
        readonly color: {
            readonly light: "#fddbfa";
            readonly dark: "#332632";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "purpleGlycine";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-purple-glycine-hover";
    readonly themePath: readonly ["background", "actionLow", "purpleGlycine", "hover"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "purpleGlycine";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--purple-glycine-925-125-hover";
        readonly themePath: readonly ["purpleGlycine", "_925_125", "hover"];
        readonly color: {
            readonly light: "#fbaff5";
            readonly dark: "#5d485c";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "purpleGlycine";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-purple-glycine-active";
    readonly themePath: readonly ["background", "actionLow", "purpleGlycine", "active"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "purpleGlycine";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--purple-glycine-925-125-active";
        readonly themePath: readonly ["purpleGlycine", "_925_125", "active"];
        readonly color: {
            readonly light: "#fa96f2";
            readonly dark: "#755b73";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "purpleGlycine";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-pink-macaron";
    readonly themePath: readonly ["background", "actionLow", "pinkMacaron", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly context: "background";
        readonly colorName: "pinkMacaron";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-macaron-925-125";
        readonly themePath: readonly ["pinkMacaron", "_925_125", "default"];
        readonly color: {
            readonly light: "#fddfda";
            readonly dark: "#352724";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "pinkMacaron";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-pink-macaron-hover";
    readonly themePath: readonly ["background", "actionLow", "pinkMacaron", "hover"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "pinkMacaron";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-macaron-925-125-hover";
        readonly themePath: readonly ["pinkMacaron", "_925_125", "hover"];
        readonly color: {
            readonly light: "#fbb8ab";
            readonly dark: "#614a45";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "pinkMacaron";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-pink-macaron-active";
    readonly themePath: readonly ["background", "actionLow", "pinkMacaron", "active"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "pinkMacaron";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-macaron-925-125-active";
        readonly themePath: readonly ["pinkMacaron", "_925_125", "active"];
        readonly color: {
            readonly light: "#faa18d";
            readonly dark: "#795d57";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "pinkMacaron";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-pink-tuile";
    readonly themePath: readonly ["background", "actionLow", "pinkTuile", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly context: "background";
        readonly colorName: "pinkTuile";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-tuile-925-125";
        readonly themePath: readonly ["pinkTuile", "_925_125", "default"];
        readonly color: {
            readonly light: "#fddfdb";
            readonly dark: "#372624";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "pinkTuile";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-pink-tuile-hover";
    readonly themePath: readonly ["background", "actionLow", "pinkTuile", "hover"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "pinkTuile";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-tuile-925-125-hover";
        readonly themePath: readonly ["pinkTuile", "_925_125", "hover"];
        readonly color: {
            readonly light: "#fbb8ad";
            readonly dark: "#644845";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "pinkTuile";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-pink-tuile-active";
    readonly themePath: readonly ["background", "actionLow", "pinkTuile", "active"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "pinkTuile";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-tuile-925-125-active";
        readonly themePath: readonly ["pinkTuile", "_925_125", "active"];
        readonly color: {
            readonly light: "#faa191";
            readonly dark: "#7d5b57";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "pinkTuile";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-yellow-tournesol";
    readonly themePath: readonly ["background", "actionLow", "yellowTournesol", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly context: "background";
        readonly colorName: "yellowTournesol";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-tournesol-925-125";
        readonly themePath: readonly ["yellowTournesol", "_925_125", "default"];
        readonly color: {
            readonly light: "#fde39c";
            readonly dark: "#302a1a";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "yellowTournesol";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-yellow-tournesol-hover";
    readonly themePath: readonly ["background", "actionLow", "yellowTournesol", "hover"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "yellowTournesol";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-tournesol-925-125-hover";
        readonly themePath: readonly ["yellowTournesol", "_925_125", "hover"];
        readonly color: {
            readonly light: "#e9c53b";
            readonly dark: "#584e34";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "yellowTournesol";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-yellow-tournesol-active";
    readonly themePath: readonly ["background", "actionLow", "yellowTournesol", "active"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "yellowTournesol";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-tournesol-925-125-active";
        readonly themePath: readonly ["yellowTournesol", "_925_125", "active"];
        readonly color: {
            readonly light: "#d3b235";
            readonly dark: "#6f6342";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "yellowTournesol";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-yellow-moutarde";
    readonly themePath: readonly ["background", "actionLow", "yellowMoutarde", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly context: "background";
        readonly colorName: "yellowMoutarde";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-moutarde-925-125";
        readonly themePath: readonly ["yellowMoutarde", "_925_125", "default"];
        readonly color: {
            readonly light: "#fde2b5";
            readonly dark: "#30291d";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "yellowMoutarde";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-yellow-moutarde-hover";
    readonly themePath: readonly ["background", "actionLow", "yellowMoutarde", "hover"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "yellowMoutarde";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-moutarde-925-125-hover";
        readonly themePath: readonly ["yellowMoutarde", "_925_125", "hover"];
        readonly color: {
            readonly light: "#f6c43c";
            readonly dark: "#584d39";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "yellowMoutarde";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-yellow-moutarde-active";
    readonly themePath: readonly ["background", "actionLow", "yellowMoutarde", "active"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "yellowMoutarde";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-moutarde-925-125-active";
        readonly themePath: readonly ["yellowMoutarde", "_925_125", "active"];
        readonly color: {
            readonly light: "#dfb135";
            readonly dark: "#6f6149";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "yellowMoutarde";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-orange-terre-battue";
    readonly themePath: readonly ["background", "actionLow", "orangeTerreBattue", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly context: "background";
        readonly colorName: "orangeTerreBattue";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--orange-terre-battue-925-125";
        readonly themePath: readonly ["orangeTerreBattue", "_925_125", "default"];
        readonly color: {
            readonly light: "#fddfd8";
            readonly dark: "#382621";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "orangeTerreBattue";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-orange-terre-battue-hover";
    readonly themePath: readonly ["background", "actionLow", "orangeTerreBattue", "hover"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "orangeTerreBattue";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--orange-terre-battue-925-125-hover";
        readonly themePath: readonly ["orangeTerreBattue", "_925_125", "hover"];
        readonly color: {
            readonly light: "#fbb8a5";
            readonly dark: "#664840";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "orangeTerreBattue";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-orange-terre-battue-active";
    readonly themePath: readonly ["background", "actionLow", "orangeTerreBattue", "active"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "orangeTerreBattue";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--orange-terre-battue-925-125-active";
        readonly themePath: readonly ["orangeTerreBattue", "_925_125", "active"];
        readonly color: {
            readonly light: "#faa184";
            readonly dark: "#7f5b51";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "orangeTerreBattue";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-brown-cafe-creme";
    readonly themePath: readonly ["background", "actionLow", "brownCafeCreme", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly context: "background";
        readonly colorName: "brownCafeCreme";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-cafe-creme-925-125";
        readonly themePath: readonly ["brownCafeCreme", "_925_125", "default"];
        readonly color: {
            readonly light: "#f4e3c7";
            readonly dark: "#2e2a21";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownCafeCreme";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-brown-cafe-creme-hover";
    readonly themePath: readonly ["background", "actionLow", "brownCafeCreme", "hover"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "brownCafeCreme";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-cafe-creme-925-125-hover";
        readonly themePath: readonly ["brownCafeCreme", "_925_125", "hover"];
        readonly color: {
            readonly light: "#e1c386";
            readonly dark: "#554e3f";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownCafeCreme";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-brown-cafe-creme-active";
    readonly themePath: readonly ["background", "actionLow", "brownCafeCreme", "active"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "brownCafeCreme";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-cafe-creme-925-125-active";
        readonly themePath: readonly ["brownCafeCreme", "_925_125", "active"];
        readonly color: {
            readonly light: "#ccb078";
            readonly dark: "#6b6351";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownCafeCreme";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-brown-caramel";
    readonly themePath: readonly ["background", "actionLow", "brownCaramel", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly context: "background";
        readonly colorName: "brownCaramel";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-caramel-925-125";
        readonly themePath: readonly ["brownCaramel", "_925_125", "default"];
        readonly color: {
            readonly light: "#f3e2d9";
            readonly dark: "#332821";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownCaramel";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-brown-caramel-hover";
    readonly themePath: readonly ["background", "actionLow", "brownCaramel", "hover"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "brownCaramel";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-caramel-925-125-hover";
        readonly themePath: readonly ["brownCaramel", "_925_125", "hover"];
        readonly color: {
            readonly light: "#e7bea6";
            readonly dark: "#5d4b40";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownCaramel";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-brown-caramel-active";
    readonly themePath: readonly ["background", "actionLow", "brownCaramel", "active"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "brownCaramel";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-caramel-925-125-active";
        readonly themePath: readonly ["brownCaramel", "_925_125", "active"];
        readonly color: {
            readonly light: "#e1a982";
            readonly dark: "#755f51";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownCaramel";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-brown-opera";
    readonly themePath: readonly ["background", "actionLow", "brownOpera", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly context: "background";
        readonly colorName: "brownOpera";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-opera-925-125";
        readonly themePath: readonly ["brownOpera", "_925_125", "default"];
        readonly color: {
            readonly light: "#f3e2d7";
            readonly dark: "#322821";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownOpera";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-brown-opera-hover";
    readonly themePath: readonly ["background", "actionLow", "brownOpera", "hover"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "brownOpera";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-opera-925-125-hover";
        readonly themePath: readonly ["brownOpera", "_925_125", "hover"];
        readonly color: {
            readonly light: "#e7bfa0";
            readonly dark: "#5c4b40";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownOpera";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-brown-opera-active";
    readonly themePath: readonly ["background", "actionLow", "brownOpera", "active"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "brownOpera";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-opera-925-125-active";
        readonly themePath: readonly ["brownOpera", "_925_125", "active"];
        readonly color: {
            readonly light: "#deaa7e";
            readonly dark: "#735f51";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownOpera";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-beige-gris-galet";
    readonly themePath: readonly ["background", "actionLow", "beigeGrisGalet", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly context: "background";
        readonly colorName: "beigeGrisGalet";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--beige-gris-galet-925-125";
        readonly themePath: readonly ["beigeGrisGalet", "_925_125", "default"];
        readonly color: {
            readonly light: "#eee4d9";
            readonly dark: "#2e2924";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "beigeGrisGalet";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-beige-gris-galet-hover";
    readonly themePath: readonly ["background", "actionLow", "beigeGrisGalet", "hover"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "beigeGrisGalet";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--beige-gris-galet-925-125-hover";
        readonly themePath: readonly ["beigeGrisGalet", "_925_125", "hover"];
        readonly color: {
            readonly light: "#dbc3a4";
            readonly dark: "#554d45";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "beigeGrisGalet";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-action-low-beige-gris-galet-active";
    readonly themePath: readonly ["background", "actionLow", "beigeGrisGalet", "active"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "beigeGrisGalet";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--beige-gris-galet-925-125-active";
        readonly themePath: readonly ["beigeGrisGalet", "_925_125", "active"];
        readonly color: {
            readonly light: "#c6b094";
            readonly dark: "#6b6157";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "beigeGrisGalet";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-active-blue-france";
    readonly themePath: readonly ["background", "active", "blueFrance", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "blueFrance";
        readonly usage: "active";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-france-sun-113-625";
        readonly themePath: readonly ["blueFrance", "sun113_625", "default"];
        readonly color: {
            readonly light: "#000091";
            readonly dark: "#8585f6";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueFrance";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 113;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-active-blue-france-hover";
    readonly themePath: readonly ["background", "active", "blueFrance", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "blueFrance";
        readonly usage: "active";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-france-sun-113-625-hover";
        readonly themePath: readonly ["blueFrance", "sun113_625", "hover"];
        readonly color: {
            readonly light: "#1212ff";
            readonly dark: "#b1b1f9";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueFrance";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 113;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-active-blue-france-active";
    readonly themePath: readonly ["background", "active", "blueFrance", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "blueFrance";
        readonly usage: "active";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-france-sun-113-625-active";
        readonly themePath: readonly ["blueFrance", "sun113_625", "active"];
        readonly color: {
            readonly light: "#2323ff";
            readonly dark: "#c6c6fb";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueFrance";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 113;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-active-red-marianne";
    readonly themePath: readonly ["background", "active", "redMarianne", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "redMarianne";
        readonly usage: "active";
    };
    readonly colorOption: {
        readonly colorOptionName: "--red-marianne-425-625";
        readonly themePath: readonly ["redMarianne", "_425_625", "default"];
        readonly color: {
            readonly light: "#c9191e";
            readonly dark: "#f95c5e";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "redMarianne";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-active-red-marianne-hover";
    readonly themePath: readonly ["background", "active", "redMarianne", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "redMarianne";
        readonly usage: "active";
    };
    readonly colorOption: {
        readonly colorOptionName: "--red-marianne-425-625-hover";
        readonly themePath: readonly ["redMarianne", "_425_625", "hover"];
        readonly color: {
            readonly light: "#f93f42";
            readonly dark: "#fa9293";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "redMarianne";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-active-red-marianne-active";
    readonly themePath: readonly ["background", "active", "redMarianne", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "redMarianne";
        readonly usage: "active";
    };
    readonly colorOption: {
        readonly colorOptionName: "--red-marianne-425-625-active";
        readonly themePath: readonly ["redMarianne", "_425_625", "active"];
        readonly color: {
            readonly light: "#f95a5c";
            readonly dark: "#fbabac";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "redMarianne";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-open-blue-france";
    readonly themePath: readonly ["background", "open", "blueFrance", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "blueFrance";
        readonly usage: "open";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-france-925-125";
        readonly themePath: readonly ["blueFrance", "_925_125", "default"];
        readonly color: {
            readonly light: "#e3e3fd";
            readonly dark: "#272747";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueFrance";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-open-blue-france-hover";
    readonly themePath: readonly ["background", "open", "blueFrance", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "blueFrance";
        readonly usage: "open";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-france-925-125-hover";
        readonly themePath: readonly ["blueFrance", "_925_125", "hover"];
        readonly color: {
            readonly light: "#c1c1fb";
            readonly dark: "#4a4a7d";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueFrance";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-open-blue-france-active";
    readonly themePath: readonly ["background", "open", "blueFrance", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "blueFrance";
        readonly usage: "open";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-france-925-125-active";
        readonly themePath: readonly ["blueFrance", "_925_125", "active"];
        readonly color: {
            readonly light: "#adadf9";
            readonly dark: "#5e5e90";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueFrance";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-open-red-marianne";
    readonly themePath: readonly ["background", "open", "redMarianne", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "redMarianne";
        readonly usage: "open";
    };
    readonly colorOption: {
        readonly colorOptionName: "--red-marianne-925-125";
        readonly themePath: readonly ["redMarianne", "_925_125", "default"];
        readonly color: {
            readonly light: "#fddede";
            readonly dark: "#3b2424";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "redMarianne";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-open-red-marianne-hover";
    readonly themePath: readonly ["background", "open", "redMarianne", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "redMarianne";
        readonly usage: "open";
    };
    readonly colorOption: {
        readonly colorOptionName: "--red-marianne-925-125-hover";
        readonly themePath: readonly ["redMarianne", "_925_125", "hover"];
        readonly color: {
            readonly light: "#fbb6b6";
            readonly dark: "#6b4545";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "redMarianne";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-open-red-marianne-active";
    readonly themePath: readonly ["background", "open", "redMarianne", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "redMarianne";
        readonly usage: "open";
    };
    readonly colorOption: {
        readonly colorOptionName: "--red-marianne-925-125-active";
        readonly themePath: readonly ["redMarianne", "_925_125", "active"];
        readonly color: {
            readonly light: "#fa9e9e";
            readonly dark: "#865757";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "redMarianne";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-disabled-grey";
    readonly themePath: readonly ["background", "disabled", "grey", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "grey";
        readonly usage: "disabled";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-925-125";
        readonly themePath: readonly ["grey", "_925_125", "default"];
        readonly color: {
            readonly light: "#e5e5e5";
            readonly dark: "#2a2a2a";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-raised-grey";
    readonly themePath: readonly ["background", "raised", "grey", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "grey";
        readonly usage: "raised";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-1000-75";
        readonly themePath: readonly ["grey", "_1000_75", "default"];
        readonly color: {
            readonly light: "#ffffff";
            readonly dark: "#1e1e1e";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 1000;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-raised-grey-hover";
    readonly themePath: readonly ["background", "raised", "grey", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "grey";
        readonly usage: "raised";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-1000-75-hover";
        readonly themePath: readonly ["grey", "_1000_75", "hover"];
        readonly color: {
            readonly light: "#f6f6f6";
            readonly dark: "#3f3f3f";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 1000;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-raised-grey-active";
    readonly themePath: readonly ["background", "raised", "grey", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "grey";
        readonly usage: "raised";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-1000-75-active";
        readonly themePath: readonly ["grey", "_1000_75", "active"];
        readonly color: {
            readonly light: "#ededed";
            readonly dark: "#525252";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 1000;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-overlap-grey";
    readonly themePath: readonly ["background", "overlap", "grey", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "grey";
        readonly usage: "overlap";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-1000-100";
        readonly themePath: readonly ["grey", "_1000_100", "default"];
        readonly color: {
            readonly light: "#ffffff";
            readonly dark: "#242424";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 1000;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-overlap-grey-hover";
    readonly themePath: readonly ["background", "overlap", "grey", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "grey";
        readonly usage: "overlap";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-1000-100-hover";
        readonly themePath: readonly ["grey", "_1000_100", "hover"];
        readonly color: {
            readonly light: "#f6f6f6";
            readonly dark: "#474747";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 1000;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-overlap-grey-active";
    readonly themePath: readonly ["background", "overlap", "grey", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "grey";
        readonly usage: "overlap";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-1000-100-active";
        readonly themePath: readonly ["grey", "_1000_100", "active"];
        readonly color: {
            readonly light: "#ededed";
            readonly dark: "#5b5b5b";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 1000;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-lifted-grey";
    readonly themePath: readonly ["background", "lifted", "grey", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "grey";
        readonly usage: "lifted";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-1000-75";
        readonly themePath: readonly ["grey", "_1000_75", "default"];
        readonly color: {
            readonly light: "#ffffff";
            readonly dark: "#1e1e1e";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 1000;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-lifted-grey-hover";
    readonly themePath: readonly ["background", "lifted", "grey", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "grey";
        readonly usage: "lifted";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-1000-75-hover";
        readonly themePath: readonly ["grey", "_1000_75", "hover"];
        readonly color: {
            readonly light: "#f6f6f6";
            readonly dark: "#3f3f3f";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 1000;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-lifted-grey-active";
    readonly themePath: readonly ["background", "lifted", "grey", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "grey";
        readonly usage: "lifted";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-1000-75-active";
        readonly themePath: readonly ["grey", "_1000_75", "active"];
        readonly color: {
            readonly light: "#ededed";
            readonly dark: "#525252";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 1000;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-raised-grey";
    readonly themePath: readonly ["background", "altRaised", "grey", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "grey";
        readonly usage: "altRaised";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-975-100";
        readonly themePath: readonly ["grey", "_975_100", "default"];
        readonly color: {
            readonly light: "#f6f6f6";
            readonly dark: "#242424";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-raised-grey-hover";
    readonly themePath: readonly ["background", "altRaised", "grey", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "grey";
        readonly usage: "altRaised";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-975-100-hover";
        readonly themePath: readonly ["grey", "_975_100", "hover"];
        readonly color: {
            readonly light: "#dfdfdf";
            readonly dark: "#474747";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-raised-grey-active";
    readonly themePath: readonly ["background", "altRaised", "grey", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "grey";
        readonly usage: "altRaised";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-975-100-active";
        readonly themePath: readonly ["grey", "_975_100", "active"];
        readonly color: {
            readonly light: "#cfcfcf";
            readonly dark: "#5b5b5b";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-overlap-grey";
    readonly themePath: readonly ["background", "altOverlap", "grey", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "grey";
        readonly usage: "altOverlap";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-975-125";
        readonly themePath: readonly ["grey", "_975_125", "default"];
        readonly color: {
            readonly light: "#f6f6f6";
            readonly dark: "#2a2a2a";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-overlap-grey-hover";
    readonly themePath: readonly ["background", "altOverlap", "grey", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "grey";
        readonly usage: "altOverlap";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-975-125-hover";
        readonly themePath: readonly ["grey", "_975_125", "hover"];
        readonly color: {
            readonly light: "#dfdfdf";
            readonly dark: "#4e4e4e";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-alt-overlap-grey-active";
    readonly themePath: readonly ["background", "altOverlap", "grey", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "grey";
        readonly usage: "altOverlap";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-975-125-active";
        readonly themePath: readonly ["grey", "_975_125", "active"];
        readonly color: {
            readonly light: "#cfcfcf";
            readonly dark: "#636363";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-raised-grey";
    readonly themePath: readonly ["background", "contrastRaised", "grey", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "grey";
        readonly usage: "contrastRaised";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-950-125";
        readonly themePath: readonly ["grey", "_950_125", "default"];
        readonly color: {
            readonly light: "#eeeeee";
            readonly dark: "#2a2a2a";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-raised-grey-hover";
    readonly themePath: readonly ["background", "contrastRaised", "grey", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "grey";
        readonly usage: "contrastRaised";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-950-125-hover";
        readonly themePath: readonly ["grey", "_950_125", "hover"];
        readonly color: {
            readonly light: "#d2d2d2";
            readonly dark: "#4e4e4e";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-raised-grey-active";
    readonly themePath: readonly ["background", "contrastRaised", "grey", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "grey";
        readonly usage: "contrastRaised";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-950-125-active";
        readonly themePath: readonly ["grey", "_950_125", "active"];
        readonly color: {
            readonly light: "#c1c1c1";
            readonly dark: "#636363";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-overlap-grey";
    readonly themePath: readonly ["background", "contrastOverlap", "grey", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "background";
        readonly colorName: "grey";
        readonly usage: "contrastOverlap";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-950-150";
        readonly themePath: readonly ["grey", "_950_150", "default"];
        readonly color: {
            readonly light: "#eeeeee";
            readonly dark: "#2f2f2f";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 150;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-overlap-grey-hover";
    readonly themePath: readonly ["background", "contrastOverlap", "grey", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "background";
        readonly colorName: "grey";
        readonly usage: "contrastOverlap";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-950-150-hover";
        readonly themePath: readonly ["grey", "_950_150", "hover"];
        readonly color: {
            readonly light: "#d2d2d2";
            readonly dark: "#545454";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 150;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--background-contrast-overlap-grey-active";
    readonly themePath: readonly ["background", "contrastOverlap", "grey", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "background";
        readonly colorName: "grey";
        readonly usage: "contrastOverlap";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-950-150-active";
        readonly themePath: readonly ["grey", "_950_150", "active"];
        readonly color: {
            readonly light: "#c1c1c1";
            readonly dark: "#696969";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 150;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--text-default-grey";
    readonly themePath: readonly ["text", "default", "grey", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "grey";
        readonly usage: "default";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-200-850";
        readonly themePath: readonly ["grey", "_200_850", "default"];
        readonly color: {
            readonly light: "#3a3a3a";
            readonly dark: "#cecece";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 200;
                };
                readonly dark: {
                    readonly value: 850;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-default-info";
    readonly themePath: readonly ["text", "default", "info", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "info";
        readonly usage: "default";
    };
    readonly colorOption: {
        readonly colorOptionName: "--info-425-625";
        readonly themePath: readonly ["info", "_425_625", "default"];
        readonly color: {
            readonly light: "#0063cb";
            readonly dark: "#518fff";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "info";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-default-success";
    readonly themePath: readonly ["text", "default", "success", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "success";
        readonly usage: "default";
    };
    readonly colorOption: {
        readonly colorOptionName: "--success-425-625";
        readonly themePath: readonly ["success", "_425_625", "default"];
        readonly color: {
            readonly light: "#18753c";
            readonly dark: "#27a658";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "success";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-default-warning";
    readonly themePath: readonly ["text", "default", "warning", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "warning";
        readonly usage: "default";
    };
    readonly colorOption: {
        readonly colorOptionName: "--warning-425-625";
        readonly themePath: readonly ["warning", "_425_625", "default"];
        readonly color: {
            readonly light: "#b34000";
            readonly dark: "#fc5d00";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "warning";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-default-error";
    readonly themePath: readonly ["text", "default", "error", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "error";
        readonly usage: "default";
    };
    readonly colorOption: {
        readonly colorOptionName: "--error-425-625";
        readonly themePath: readonly ["error", "_425_625", "default"];
        readonly color: {
            readonly light: "#ce0500";
            readonly dark: "#ff5655";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "error";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-action-high-grey";
    readonly themePath: readonly ["text", "actionHigh", "grey", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly context: "text";
        readonly colorName: "grey";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-50-1000";
        readonly themePath: readonly ["grey", "_50_1000", "default"];
        readonly color: {
            readonly light: "#161616";
            readonly dark: "#ffffff";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 50;
                };
                readonly dark: {
                    readonly value: 1000;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-action-high-blue-france";
    readonly themePath: readonly ["text", "actionHigh", "blueFrance", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly context: "text";
        readonly colorName: "blueFrance";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-france-sun-113-625";
        readonly themePath: readonly ["blueFrance", "sun113_625", "default"];
        readonly color: {
            readonly light: "#000091";
            readonly dark: "#8585f6";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueFrance";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 113;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-action-high-red-marianne";
    readonly themePath: readonly ["text", "actionHigh", "redMarianne", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly context: "text";
        readonly colorName: "redMarianne";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--red-marianne-425-625";
        readonly themePath: readonly ["redMarianne", "_425_625", "default"];
        readonly color: {
            readonly light: "#c9191e";
            readonly dark: "#f95c5e";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "redMarianne";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-action-high-green-tilleul-verveine";
    readonly themePath: readonly ["text", "actionHigh", "greenTilleulVerveine", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly context: "text";
        readonly colorName: "greenTilleulVerveine";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-tilleul-verveine-sun-418-moon-817";
        readonly themePath: readonly ["greenTilleulVerveine", "sun418moon817", "default"];
        readonly color: {
            readonly light: "#66673d";
            readonly dark: "#d8c634";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenTilleulVerveine";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 418;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 817;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-action-high-green-bourgeon";
    readonly themePath: readonly ["text", "actionHigh", "greenBourgeon", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly context: "text";
        readonly colorName: "greenBourgeon";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-bourgeon-sun-425-moon-759";
        readonly themePath: readonly ["greenBourgeon", "sun425moon759", "default"];
        readonly color: {
            readonly light: "#447049";
            readonly dark: "#99c221";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenBourgeon";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 759;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-action-high-green-emeraude";
    readonly themePath: readonly ["text", "actionHigh", "greenEmeraude", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly context: "text";
        readonly colorName: "greenEmeraude";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-emeraude-sun-425-moon-753";
        readonly themePath: readonly ["greenEmeraude", "sun425moon753", "default"];
        readonly color: {
            readonly light: "#297254";
            readonly dark: "#34cb6a";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenEmeraude";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 753;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-action-high-green-menthe";
    readonly themePath: readonly ["text", "actionHigh", "greenMenthe", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly context: "text";
        readonly colorName: "greenMenthe";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-menthe-sun-373-moon-652";
        readonly themePath: readonly ["greenMenthe", "sun373moon652", "default"];
        readonly color: {
            readonly light: "#37635f";
            readonly dark: "#21ab8e";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenMenthe";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 373;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 652;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-action-high-green-archipel";
    readonly themePath: readonly ["text", "actionHigh", "greenArchipel", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly context: "text";
        readonly colorName: "greenArchipel";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-archipel-sun-391-moon-716";
        readonly themePath: readonly ["greenArchipel", "sun391moon716", "default"];
        readonly color: {
            readonly light: "#006a6f";
            readonly dark: "#34bab5";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenArchipel";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 391;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 716;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-action-high-blue-ecume";
    readonly themePath: readonly ["text", "actionHigh", "blueEcume", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly context: "text";
        readonly colorName: "blueEcume";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-ecume-sun-247-moon-675";
        readonly themePath: readonly ["blueEcume", "sun247moon675", "default"];
        readonly color: {
            readonly light: "#2f4077";
            readonly dark: "#869ece";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueEcume";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 247;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 675;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-action-high-blue-cumulus";
    readonly themePath: readonly ["text", "actionHigh", "blueCumulus", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly context: "text";
        readonly colorName: "blueCumulus";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-cumulus-sun-368-moon-732";
        readonly themePath: readonly ["blueCumulus", "sun368moon732", "default"];
        readonly color: {
            readonly light: "#3558a2";
            readonly dark: "#7ab1e8";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueCumulus";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 368;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 732;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-action-high-purple-glycine";
    readonly themePath: readonly ["text", "actionHigh", "purpleGlycine", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly context: "text";
        readonly colorName: "purpleGlycine";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--purple-glycine-sun-319-moon-630";
        readonly themePath: readonly ["purpleGlycine", "sun319moon630", "default"];
        readonly color: {
            readonly light: "#6e445a";
            readonly dark: "#ce70cc";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "purpleGlycine";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 319;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 630;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-action-high-pink-macaron";
    readonly themePath: readonly ["text", "actionHigh", "pinkMacaron", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly context: "text";
        readonly colorName: "pinkMacaron";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-macaron-sun-406-moon-833";
        readonly themePath: readonly ["pinkMacaron", "sun406moon833", "default"];
        readonly color: {
            readonly light: "#8d533e";
            readonly dark: "#ffb7ae";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "pinkMacaron";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 406;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 833;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-action-high-pink-tuile";
    readonly themePath: readonly ["text", "actionHigh", "pinkTuile", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly context: "text";
        readonly colorName: "pinkTuile";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-tuile-sun-425-moon-750";
        readonly themePath: readonly ["pinkTuile", "sun425moon750", "default"];
        readonly color: {
            readonly light: "#a94645";
            readonly dark: "#ff9575";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "pinkTuile";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 750;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-action-high-yellow-tournesol";
    readonly themePath: readonly ["text", "actionHigh", "yellowTournesol", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly context: "text";
        readonly colorName: "yellowTournesol";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-tournesol-sun-407-moon-922";
        readonly themePath: readonly ["yellowTournesol", "sun407moon922", "default"];
        readonly color: {
            readonly light: "#716043";
            readonly dark: "#ffe552";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "yellowTournesol";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 407;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 922;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-action-high-yellow-moutarde";
    readonly themePath: readonly ["text", "actionHigh", "yellowMoutarde", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly context: "text";
        readonly colorName: "yellowMoutarde";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-moutarde-sun-348-moon-860";
        readonly themePath: readonly ["yellowMoutarde", "sun348moon860", "default"];
        readonly color: {
            readonly light: "#695240";
            readonly dark: "#ffca00";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "yellowMoutarde";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 348;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 860;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-action-high-orange-terre-battue";
    readonly themePath: readonly ["text", "actionHigh", "orangeTerreBattue", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly context: "text";
        readonly colorName: "orangeTerreBattue";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--orange-terre-battue-sun-370-moon-672";
        readonly themePath: readonly ["orangeTerreBattue", "sun370moon672", "default"];
        readonly color: {
            readonly light: "#755348";
            readonly dark: "#ff732c";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "orangeTerreBattue";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 370;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 672;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-action-high-brown-cafe-creme";
    readonly themePath: readonly ["text", "actionHigh", "brownCafeCreme", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly context: "text";
        readonly colorName: "brownCafeCreme";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-cafe-creme-sun-383-moon-885";
        readonly themePath: readonly ["brownCafeCreme", "sun383moon885", "default"];
        readonly color: {
            readonly light: "#685c48";
            readonly dark: "#ecd7a2";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownCafeCreme";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 383;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 885;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-action-high-brown-caramel";
    readonly themePath: readonly ["text", "actionHigh", "brownCaramel", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly context: "text";
        readonly colorName: "brownCaramel";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-caramel-sun-425-moon-901";
        readonly themePath: readonly ["brownCaramel", "sun425moon901", "default"];
        readonly color: {
            readonly light: "#845d48";
            readonly dark: "#fbd8ab";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownCaramel";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 901;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-action-high-brown-opera";
    readonly themePath: readonly ["text", "actionHigh", "brownOpera", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly context: "text";
        readonly colorName: "brownOpera";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-opera-sun-395-moon-820";
        readonly themePath: readonly ["brownOpera", "sun395moon820", "default"];
        readonly color: {
            readonly light: "#745b47";
            readonly dark: "#e6be92";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownOpera";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 395;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 820;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-action-high-beige-gris-galet";
    readonly themePath: readonly ["text", "actionHigh", "beigeGrisGalet", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly context: "text";
        readonly colorName: "beigeGrisGalet";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--beige-gris-galet-sun-407-moon-821";
        readonly themePath: readonly ["beigeGrisGalet", "sun407moon821", "default"];
        readonly color: {
            readonly light: "#6a6156";
            readonly dark: "#d0c3b7";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "beigeGrisGalet";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 407;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 821;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-title-grey";
    readonly themePath: readonly ["text", "title", "grey", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "grey";
        readonly usage: "title";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-50-1000";
        readonly themePath: readonly ["grey", "_50_1000", "default"];
        readonly color: {
            readonly light: "#161616";
            readonly dark: "#ffffff";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 50;
                };
                readonly dark: {
                    readonly value: 1000;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-title-blue-france";
    readonly themePath: readonly ["text", "title", "blueFrance", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "blueFrance";
        readonly usage: "title";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-france-sun-113-625";
        readonly themePath: readonly ["blueFrance", "sun113_625", "default"];
        readonly color: {
            readonly light: "#000091";
            readonly dark: "#8585f6";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueFrance";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 113;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-title-red-marianne";
    readonly themePath: readonly ["text", "title", "redMarianne", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "redMarianne";
        readonly usage: "title";
    };
    readonly colorOption: {
        readonly colorOptionName: "--red-marianne-425-625";
        readonly themePath: readonly ["redMarianne", "_425_625", "default"];
        readonly color: {
            readonly light: "#c9191e";
            readonly dark: "#f95c5e";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "redMarianne";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-label-grey";
    readonly themePath: readonly ["text", "label", "grey", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "grey";
        readonly usage: "label";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-50-1000";
        readonly themePath: readonly ["grey", "_50_1000", "default"];
        readonly color: {
            readonly light: "#161616";
            readonly dark: "#ffffff";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 50;
                };
                readonly dark: {
                    readonly value: 1000;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-label-blue-france";
    readonly themePath: readonly ["text", "label", "blueFrance", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "blueFrance";
        readonly usage: "label";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-france-sun-113-625";
        readonly themePath: readonly ["blueFrance", "sun113_625", "default"];
        readonly color: {
            readonly light: "#000091";
            readonly dark: "#8585f6";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueFrance";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 113;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-label-red-marianne";
    readonly themePath: readonly ["text", "label", "redMarianne", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "redMarianne";
        readonly usage: "label";
    };
    readonly colorOption: {
        readonly colorOptionName: "--red-marianne-425-625";
        readonly themePath: readonly ["redMarianne", "_425_625", "default"];
        readonly color: {
            readonly light: "#c9191e";
            readonly dark: "#f95c5e";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "redMarianne";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-label-green-tilleul-verveine";
    readonly themePath: readonly ["text", "label", "greenTilleulVerveine", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "greenTilleulVerveine";
        readonly usage: "label";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-tilleul-verveine-sun-418-moon-817";
        readonly themePath: readonly ["greenTilleulVerveine", "sun418moon817", "default"];
        readonly color: {
            readonly light: "#66673d";
            readonly dark: "#d8c634";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenTilleulVerveine";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 418;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 817;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-label-green-bourgeon";
    readonly themePath: readonly ["text", "label", "greenBourgeon", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "greenBourgeon";
        readonly usage: "label";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-bourgeon-sun-425-moon-759";
        readonly themePath: readonly ["greenBourgeon", "sun425moon759", "default"];
        readonly color: {
            readonly light: "#447049";
            readonly dark: "#99c221";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenBourgeon";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 759;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-label-green-emeraude";
    readonly themePath: readonly ["text", "label", "greenEmeraude", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "greenEmeraude";
        readonly usage: "label";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-emeraude-sun-425-moon-753";
        readonly themePath: readonly ["greenEmeraude", "sun425moon753", "default"];
        readonly color: {
            readonly light: "#297254";
            readonly dark: "#34cb6a";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenEmeraude";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 753;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-label-green-menthe";
    readonly themePath: readonly ["text", "label", "greenMenthe", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "greenMenthe";
        readonly usage: "label";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-menthe-sun-373-moon-652";
        readonly themePath: readonly ["greenMenthe", "sun373moon652", "default"];
        readonly color: {
            readonly light: "#37635f";
            readonly dark: "#21ab8e";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenMenthe";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 373;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 652;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-label-green-archipel";
    readonly themePath: readonly ["text", "label", "greenArchipel", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "greenArchipel";
        readonly usage: "label";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-archipel-sun-391-moon-716";
        readonly themePath: readonly ["greenArchipel", "sun391moon716", "default"];
        readonly color: {
            readonly light: "#006a6f";
            readonly dark: "#34bab5";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenArchipel";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 391;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 716;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-label-blue-ecume";
    readonly themePath: readonly ["text", "label", "blueEcume", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "blueEcume";
        readonly usage: "label";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-ecume-sun-247-moon-675";
        readonly themePath: readonly ["blueEcume", "sun247moon675", "default"];
        readonly color: {
            readonly light: "#2f4077";
            readonly dark: "#869ece";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueEcume";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 247;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 675;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-label-blue-cumulus";
    readonly themePath: readonly ["text", "label", "blueCumulus", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "blueCumulus";
        readonly usage: "label";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-cumulus-sun-368-moon-732";
        readonly themePath: readonly ["blueCumulus", "sun368moon732", "default"];
        readonly color: {
            readonly light: "#3558a2";
            readonly dark: "#7ab1e8";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueCumulus";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 368;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 732;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-label-purple-glycine";
    readonly themePath: readonly ["text", "label", "purpleGlycine", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "purpleGlycine";
        readonly usage: "label";
    };
    readonly colorOption: {
        readonly colorOptionName: "--purple-glycine-sun-319-moon-630";
        readonly themePath: readonly ["purpleGlycine", "sun319moon630", "default"];
        readonly color: {
            readonly light: "#6e445a";
            readonly dark: "#ce70cc";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "purpleGlycine";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 319;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 630;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-label-pink-macaron";
    readonly themePath: readonly ["text", "label", "pinkMacaron", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "pinkMacaron";
        readonly usage: "label";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-macaron-sun-406-moon-833";
        readonly themePath: readonly ["pinkMacaron", "sun406moon833", "default"];
        readonly color: {
            readonly light: "#8d533e";
            readonly dark: "#ffb7ae";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "pinkMacaron";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 406;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 833;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-label-pink-tuile";
    readonly themePath: readonly ["text", "label", "pinkTuile", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "pinkTuile";
        readonly usage: "label";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-tuile-sun-425-moon-750";
        readonly themePath: readonly ["pinkTuile", "sun425moon750", "default"];
        readonly color: {
            readonly light: "#a94645";
            readonly dark: "#ff9575";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "pinkTuile";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 750;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-label-yellow-tournesol";
    readonly themePath: readonly ["text", "label", "yellowTournesol", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "yellowTournesol";
        readonly usage: "label";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-tournesol-sun-407-moon-922";
        readonly themePath: readonly ["yellowTournesol", "sun407moon922", "default"];
        readonly color: {
            readonly light: "#716043";
            readonly dark: "#ffe552";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "yellowTournesol";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 407;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 922;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-label-yellow-moutarde";
    readonly themePath: readonly ["text", "label", "yellowMoutarde", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "yellowMoutarde";
        readonly usage: "label";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-moutarde-sun-348-moon-860";
        readonly themePath: readonly ["yellowMoutarde", "sun348moon860", "default"];
        readonly color: {
            readonly light: "#695240";
            readonly dark: "#ffca00";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "yellowMoutarde";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 348;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 860;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-label-orange-terre-battue";
    readonly themePath: readonly ["text", "label", "orangeTerreBattue", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "orangeTerreBattue";
        readonly usage: "label";
    };
    readonly colorOption: {
        readonly colorOptionName: "--orange-terre-battue-sun-370-moon-672";
        readonly themePath: readonly ["orangeTerreBattue", "sun370moon672", "default"];
        readonly color: {
            readonly light: "#755348";
            readonly dark: "#ff732c";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "orangeTerreBattue";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 370;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 672;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-label-brown-cafe-creme";
    readonly themePath: readonly ["text", "label", "brownCafeCreme", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "brownCafeCreme";
        readonly usage: "label";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-cafe-creme-sun-383-moon-885";
        readonly themePath: readonly ["brownCafeCreme", "sun383moon885", "default"];
        readonly color: {
            readonly light: "#685c48";
            readonly dark: "#ecd7a2";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownCafeCreme";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 383;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 885;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-label-brown-caramel";
    readonly themePath: readonly ["text", "label", "brownCaramel", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "brownCaramel";
        readonly usage: "label";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-caramel-sun-425-moon-901";
        readonly themePath: readonly ["brownCaramel", "sun425moon901", "default"];
        readonly color: {
            readonly light: "#845d48";
            readonly dark: "#fbd8ab";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownCaramel";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 901;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-label-brown-opera";
    readonly themePath: readonly ["text", "label", "brownOpera", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "brownOpera";
        readonly usage: "label";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-opera-sun-395-moon-820";
        readonly themePath: readonly ["brownOpera", "sun395moon820", "default"];
        readonly color: {
            readonly light: "#745b47";
            readonly dark: "#e6be92";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownOpera";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 395;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 820;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-label-beige-gris-galet";
    readonly themePath: readonly ["text", "label", "beigeGrisGalet", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "beigeGrisGalet";
        readonly usage: "label";
    };
    readonly colorOption: {
        readonly colorOptionName: "--beige-gris-galet-sun-407-moon-821";
        readonly themePath: readonly ["beigeGrisGalet", "sun407moon821", "default"];
        readonly color: {
            readonly light: "#6a6156";
            readonly dark: "#d0c3b7";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "beigeGrisGalet";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 407;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 821;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-active-grey";
    readonly themePath: readonly ["text", "active", "grey", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "grey";
        readonly usage: "active";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-50-1000";
        readonly themePath: readonly ["grey", "_50_1000", "default"];
        readonly color: {
            readonly light: "#161616";
            readonly dark: "#ffffff";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 50;
                };
                readonly dark: {
                    readonly value: 1000;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-active-blue-france";
    readonly themePath: readonly ["text", "active", "blueFrance", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "blueFrance";
        readonly usage: "active";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-france-sun-113-625";
        readonly themePath: readonly ["blueFrance", "sun113_625", "default"];
        readonly color: {
            readonly light: "#000091";
            readonly dark: "#8585f6";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueFrance";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 113;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-active-red-marianne";
    readonly themePath: readonly ["text", "active", "redMarianne", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "redMarianne";
        readonly usage: "active";
    };
    readonly colorOption: {
        readonly colorOptionName: "--red-marianne-425-625";
        readonly themePath: readonly ["redMarianne", "_425_625", "default"];
        readonly color: {
            readonly light: "#c9191e";
            readonly dark: "#f95c5e";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "redMarianne";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-mention-grey";
    readonly themePath: readonly ["text", "mention", "grey", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "grey";
        readonly usage: "mention";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-425-625";
        readonly themePath: readonly ["grey", "_425_625", "default"];
        readonly color: {
            readonly light: "#666666";
            readonly dark: "#929292";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-inverted-grey";
    readonly themePath: readonly ["text", "inverted", "grey", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "grey";
        readonly usage: "inverted";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-1000-50";
        readonly themePath: readonly ["grey", "_1000_50", "default"];
        readonly color: {
            readonly light: "#ffffff";
            readonly dark: "#161616";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 1000;
                };
                readonly dark: {
                    readonly value: 50;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-inverted-blue-france";
    readonly themePath: readonly ["text", "inverted", "blueFrance", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "blueFrance";
        readonly usage: "inverted";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-france-975-sun-113";
        readonly themePath: readonly ["blueFrance", "_975sun113", "default"];
        readonly color: {
            readonly light: "#f5f5fe";
            readonly dark: "#000091";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueFrance";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 113;
                    readonly variant: "sun";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-inverted-red-marianne";
    readonly themePath: readonly ["text", "inverted", "redMarianne", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "redMarianne";
        readonly usage: "inverted";
    };
    readonly colorOption: {
        readonly colorOptionName: "--red-marianne-975-75";
        readonly themePath: readonly ["redMarianne", "_975_75", "default"];
        readonly color: {
            readonly light: "#fef4f4";
            readonly dark: "#2b1919";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "redMarianne";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-inverted-info";
    readonly themePath: readonly ["text", "inverted", "info", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "info";
        readonly usage: "inverted";
    };
    readonly colorOption: {
        readonly colorOptionName: "--info-975-75";
        readonly themePath: readonly ["info", "_975_75", "default"];
        readonly color: {
            readonly light: "#f4f6ff";
            readonly dark: "#171d2e";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "info";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-inverted-success";
    readonly themePath: readonly ["text", "inverted", "success", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "success";
        readonly usage: "inverted";
    };
    readonly colorOption: {
        readonly colorOptionName: "--success-975-75";
        readonly themePath: readonly ["success", "_975_75", "default"];
        readonly color: {
            readonly light: "#dffee6";
            readonly dark: "#142117";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "success";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-inverted-warning";
    readonly themePath: readonly ["text", "inverted", "warning", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "warning";
        readonly usage: "inverted";
    };
    readonly colorOption: {
        readonly colorOptionName: "--warning-975-75";
        readonly themePath: readonly ["warning", "_975_75", "default"];
        readonly color: {
            readonly light: "#fff4f3";
            readonly dark: "#2d1814";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "warning";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-inverted-error";
    readonly themePath: readonly ["text", "inverted", "error", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "error";
        readonly usage: "inverted";
    };
    readonly colorOption: {
        readonly colorOptionName: "--error-975-75";
        readonly themePath: readonly ["error", "_975_75", "default"];
        readonly color: {
            readonly light: "#fff4f4";
            readonly dark: "#301717";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "error";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-inverted-green-tilleul-verveine";
    readonly themePath: readonly ["text", "inverted", "greenTilleulVerveine", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "greenTilleulVerveine";
        readonly usage: "inverted";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-tilleul-verveine-975-75";
        readonly themePath: readonly ["greenTilleulVerveine", "_975_75", "default"];
        readonly color: {
            readonly light: "#fef7da";
            readonly dark: "#201e14";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenTilleulVerveine";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-inverted-green-bourgeon";
    readonly themePath: readonly ["text", "inverted", "greenBourgeon", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "greenBourgeon";
        readonly usage: "inverted";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-bourgeon-975-75";
        readonly themePath: readonly ["greenBourgeon", "_975_75", "default"];
        readonly color: {
            readonly light: "#e6feda";
            readonly dark: "#182014";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenBourgeon";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-inverted-green-emeraude";
    readonly themePath: readonly ["text", "inverted", "greenEmeraude", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "greenEmeraude";
        readonly usage: "inverted";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-emeraude-975-75";
        readonly themePath: readonly ["greenEmeraude", "_975_75", "default"];
        readonly color: {
            readonly light: "#e3fdeb";
            readonly dark: "#142018";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenEmeraude";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-inverted-green-menthe";
    readonly themePath: readonly ["text", "inverted", "greenMenthe", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "greenMenthe";
        readonly usage: "inverted";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-menthe-975-75";
        readonly themePath: readonly ["greenMenthe", "_975_75", "default"];
        readonly color: {
            readonly light: "#dffdf7";
            readonly dark: "#15201e";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenMenthe";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-inverted-green-archipel";
    readonly themePath: readonly ["text", "inverted", "greenArchipel", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "greenArchipel";
        readonly usage: "inverted";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-archipel-975-75";
        readonly themePath: readonly ["greenArchipel", "_975_75", "default"];
        readonly color: {
            readonly light: "#e5fbfd";
            readonly dark: "#152021";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenArchipel";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-inverted-blue-ecume";
    readonly themePath: readonly ["text", "inverted", "blueEcume", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "blueEcume";
        readonly usage: "inverted";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-ecume-975-75";
        readonly themePath: readonly ["blueEcume", "_975_75", "default"];
        readonly color: {
            readonly light: "#f4f6fe";
            readonly dark: "#171d2f";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueEcume";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-inverted-blue-cumulus";
    readonly themePath: readonly ["text", "inverted", "blueCumulus", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "blueCumulus";
        readonly usage: "inverted";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-cumulus-975-75";
        readonly themePath: readonly ["blueCumulus", "_975_75", "default"];
        readonly color: {
            readonly light: "#f3f6fe";
            readonly dark: "#171e2b";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueCumulus";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-inverted-purple-glycine";
    readonly themePath: readonly ["text", "inverted", "purpleGlycine", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "purpleGlycine";
        readonly usage: "inverted";
    };
    readonly colorOption: {
        readonly colorOptionName: "--purple-glycine-975-75";
        readonly themePath: readonly ["purpleGlycine", "_975_75", "default"];
        readonly color: {
            readonly light: "#fef3fd";
            readonly dark: "#251a24";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "purpleGlycine";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-inverted-pink-macaron";
    readonly themePath: readonly ["text", "inverted", "pinkMacaron", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "pinkMacaron";
        readonly usage: "inverted";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-macaron-975-75";
        readonly themePath: readonly ["pinkMacaron", "_975_75", "default"];
        readonly color: {
            readonly light: "#fef4f2";
            readonly dark: "#261b19";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "pinkMacaron";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-inverted-pink-tuile";
    readonly themePath: readonly ["text", "inverted", "pinkTuile", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "pinkTuile";
        readonly usage: "inverted";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-tuile-975-75";
        readonly themePath: readonly ["pinkTuile", "_975_75", "default"];
        readonly color: {
            readonly light: "#fef4f3";
            readonly dark: "#281b19";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "pinkTuile";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-inverted-yellow-tournesol";
    readonly themePath: readonly ["text", "inverted", "yellowTournesol", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "yellowTournesol";
        readonly usage: "inverted";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-tournesol-975-75";
        readonly themePath: readonly ["yellowTournesol", "_975_75", "default"];
        readonly color: {
            readonly light: "#fef6e3";
            readonly dark: "#221d11";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "yellowTournesol";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-inverted-yellow-moutarde";
    readonly themePath: readonly ["text", "inverted", "yellowMoutarde", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "yellowMoutarde";
        readonly usage: "inverted";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-moutarde-975-75";
        readonly themePath: readonly ["yellowMoutarde", "_975_75", "default"];
        readonly color: {
            readonly light: "#fef5e8";
            readonly dark: "#231d14";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "yellowMoutarde";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-inverted-orange-terre-battue";
    readonly themePath: readonly ["text", "inverted", "orangeTerreBattue", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "orangeTerreBattue";
        readonly usage: "inverted";
    };
    readonly colorOption: {
        readonly colorOptionName: "--orange-terre-battue-975-75";
        readonly themePath: readonly ["orangeTerreBattue", "_975_75", "default"];
        readonly color: {
            readonly light: "#fef4f2";
            readonly dark: "#281a16";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "orangeTerreBattue";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-inverted-brown-cafe-creme";
    readonly themePath: readonly ["text", "inverted", "brownCafeCreme", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "brownCafeCreme";
        readonly usage: "inverted";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-cafe-creme-975-75";
        readonly themePath: readonly ["brownCafeCreme", "_975_75", "default"];
        readonly color: {
            readonly light: "#fbf6ed";
            readonly dark: "#211d16";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownCafeCreme";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-inverted-brown-caramel";
    readonly themePath: readonly ["text", "inverted", "brownCaramel", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "brownCaramel";
        readonly usage: "inverted";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-caramel-975-75";
        readonly themePath: readonly ["brownCaramel", "_975_75", "default"];
        readonly color: {
            readonly light: "#fbf5f2";
            readonly dark: "#251c16";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownCaramel";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-inverted-brown-opera";
    readonly themePath: readonly ["text", "inverted", "brownOpera", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "brownOpera";
        readonly usage: "inverted";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-opera-975-75";
        readonly themePath: readonly ["brownOpera", "_975_75", "default"];
        readonly color: {
            readonly light: "#fbf5f2";
            readonly dark: "#241c17";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownOpera";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-inverted-beige-gris-galet";
    readonly themePath: readonly ["text", "inverted", "beigeGrisGalet", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "beigeGrisGalet";
        readonly usage: "inverted";
    };
    readonly colorOption: {
        readonly colorOptionName: "--beige-gris-galet-975-75";
        readonly themePath: readonly ["beigeGrisGalet", "_975_75", "default"];
        readonly color: {
            readonly light: "#f9f6f2";
            readonly dark: "#211d19";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "beigeGrisGalet";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-disabled-grey";
    readonly themePath: readonly ["text", "disabled", "grey", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "grey";
        readonly usage: "disabled";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-625-425";
        readonly themePath: readonly ["grey", "_625_425", "default"];
        readonly color: {
            readonly light: "#929292";
            readonly dark: "#666666";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 625;
                };
                readonly dark: {
                    readonly value: 425;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--text-black-white-grey";
    readonly themePath: readonly ["text", "blackWhite", "grey", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "text";
        readonly colorName: "grey";
        readonly usage: "blackWhite";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-0-1000";
        readonly themePath: readonly ["grey", "_0_1000", "default"];
        readonly color: {
            readonly light: "#0";
            readonly dark: "#ffffff";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 0;
                };
                readonly dark: {
                    readonly value: 1000;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-default-grey";
    readonly themePath: readonly ["border", "default", "grey", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "border";
        readonly colorName: "grey";
        readonly usage: "default";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-900-175";
        readonly themePath: readonly ["grey", "_900_175", "default"];
        readonly color: {
            readonly light: "#dddddd";
            readonly dark: "#353535";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 900;
                };
                readonly dark: {
                    readonly value: 175;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-default-blue-france";
    readonly themePath: readonly ["border", "default", "blueFrance", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "border";
        readonly colorName: "blueFrance";
        readonly usage: "default";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-france-main-525";
        readonly themePath: readonly ["blueFrance", "main525", "default"];
        readonly color: "#6a6af4";
        readonly parsedColorOptionName: {
            readonly colorName: "blueFrance";
            readonly brightness: {
                readonly isInvariant: true;
                readonly value: 525;
                readonly variant: "main";
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-default-red-marianne";
    readonly themePath: readonly ["border", "default", "redMarianne", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "border";
        readonly colorName: "redMarianne";
        readonly usage: "default";
    };
    readonly colorOption: {
        readonly colorOptionName: "--red-marianne-main-472";
        readonly themePath: readonly ["redMarianne", "main472", "default"];
        readonly color: "#e1000f";
        readonly parsedColorOptionName: {
            readonly colorName: "redMarianne";
            readonly brightness: {
                readonly isInvariant: true;
                readonly value: 472;
                readonly variant: "main";
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-default-green-tilleul-verveine";
    readonly themePath: readonly ["border", "default", "greenTilleulVerveine", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "border";
        readonly colorName: "greenTilleulVerveine";
        readonly usage: "default";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-tilleul-verveine-main-707";
        readonly themePath: readonly ["greenTilleulVerveine", "main707", "default"];
        readonly color: "#b7a73f";
        readonly parsedColorOptionName: {
            readonly colorName: "greenTilleulVerveine";
            readonly brightness: {
                readonly isInvariant: true;
                readonly value: 707;
                readonly variant: "main";
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-default-green-bourgeon";
    readonly themePath: readonly ["border", "default", "greenBourgeon", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "border";
        readonly colorName: "greenBourgeon";
        readonly usage: "default";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-bourgeon-main-640";
        readonly themePath: readonly ["greenBourgeon", "main640", "default"];
        readonly color: "#68a532";
        readonly parsedColorOptionName: {
            readonly colorName: "greenBourgeon";
            readonly brightness: {
                readonly isInvariant: true;
                readonly value: 640;
                readonly variant: "main";
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-default-green-emeraude";
    readonly themePath: readonly ["border", "default", "greenEmeraude", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "border";
        readonly colorName: "greenEmeraude";
        readonly usage: "default";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-emeraude-main-632";
        readonly themePath: readonly ["greenEmeraude", "main632", "default"];
        readonly color: "#00a95f";
        readonly parsedColorOptionName: {
            readonly colorName: "greenEmeraude";
            readonly brightness: {
                readonly isInvariant: true;
                readonly value: 632;
                readonly variant: "main";
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-default-green-menthe";
    readonly themePath: readonly ["border", "default", "greenMenthe", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "border";
        readonly colorName: "greenMenthe";
        readonly usage: "default";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-menthe-main-548";
        readonly themePath: readonly ["greenMenthe", "main548", "default"];
        readonly color: "#009081";
        readonly parsedColorOptionName: {
            readonly colorName: "greenMenthe";
            readonly brightness: {
                readonly isInvariant: true;
                readonly value: 548;
                readonly variant: "main";
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-default-green-archipel";
    readonly themePath: readonly ["border", "default", "greenArchipel", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "border";
        readonly colorName: "greenArchipel";
        readonly usage: "default";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-archipel-main-557";
        readonly themePath: readonly ["greenArchipel", "main557", "default"];
        readonly color: "#009099";
        readonly parsedColorOptionName: {
            readonly colorName: "greenArchipel";
            readonly brightness: {
                readonly isInvariant: true;
                readonly value: 557;
                readonly variant: "main";
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-default-blue-ecume";
    readonly themePath: readonly ["border", "default", "blueEcume", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "border";
        readonly colorName: "blueEcume";
        readonly usage: "default";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-ecume-main-400";
        readonly themePath: readonly ["blueEcume", "main400", "default"];
        readonly color: "#465f9d";
        readonly parsedColorOptionName: {
            readonly colorName: "blueEcume";
            readonly brightness: {
                readonly isInvariant: true;
                readonly value: 400;
                readonly variant: "main";
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-default-blue-cumulus";
    readonly themePath: readonly ["border", "default", "blueCumulus", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "border";
        readonly colorName: "blueCumulus";
        readonly usage: "default";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-cumulus-main-526";
        readonly themePath: readonly ["blueCumulus", "main526", "default"];
        readonly color: "#417dc4";
        readonly parsedColorOptionName: {
            readonly colorName: "blueCumulus";
            readonly brightness: {
                readonly isInvariant: true;
                readonly value: 526;
                readonly variant: "main";
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-default-purple-glycine";
    readonly themePath: readonly ["border", "default", "purpleGlycine", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "border";
        readonly colorName: "purpleGlycine";
        readonly usage: "default";
    };
    readonly colorOption: {
        readonly colorOptionName: "--purple-glycine-main-494";
        readonly themePath: readonly ["purpleGlycine", "main494", "default"];
        readonly color: "#a558a0";
        readonly parsedColorOptionName: {
            readonly colorName: "purpleGlycine";
            readonly brightness: {
                readonly isInvariant: true;
                readonly value: 494;
                readonly variant: "main";
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-default-pink-macaron";
    readonly themePath: readonly ["border", "default", "pinkMacaron", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "border";
        readonly colorName: "pinkMacaron";
        readonly usage: "default";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-macaron-main-689";
        readonly themePath: readonly ["pinkMacaron", "main689", "default"];
        readonly color: "#e18b76";
        readonly parsedColorOptionName: {
            readonly colorName: "pinkMacaron";
            readonly brightness: {
                readonly isInvariant: true;
                readonly value: 689;
                readonly variant: "main";
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-default-pink-tuile";
    readonly themePath: readonly ["border", "default", "pinkTuile", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "border";
        readonly colorName: "pinkTuile";
        readonly usage: "default";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-tuile-main-556";
        readonly themePath: readonly ["pinkTuile", "main556", "default"];
        readonly color: "#ce614a";
        readonly parsedColorOptionName: {
            readonly colorName: "pinkTuile";
            readonly brightness: {
                readonly isInvariant: true;
                readonly value: 556;
                readonly variant: "main";
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-default-yellow-tournesol";
    readonly themePath: readonly ["border", "default", "yellowTournesol", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "border";
        readonly colorName: "yellowTournesol";
        readonly usage: "default";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-tournesol-main-731";
        readonly themePath: readonly ["yellowTournesol", "main731", "default"];
        readonly color: "#c8aa39";
        readonly parsedColorOptionName: {
            readonly colorName: "yellowTournesol";
            readonly brightness: {
                readonly isInvariant: true;
                readonly value: 731;
                readonly variant: "main";
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-default-yellow-moutarde";
    readonly themePath: readonly ["border", "default", "yellowMoutarde", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "border";
        readonly colorName: "yellowMoutarde";
        readonly usage: "default";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-moutarde-main-679";
        readonly themePath: readonly ["yellowMoutarde", "main679", "default"];
        readonly color: "#c3992a";
        readonly parsedColorOptionName: {
            readonly colorName: "yellowMoutarde";
            readonly brightness: {
                readonly isInvariant: true;
                readonly value: 679;
                readonly variant: "main";
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-default-orange-terre-battue";
    readonly themePath: readonly ["border", "default", "orangeTerreBattue", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "border";
        readonly colorName: "orangeTerreBattue";
        readonly usage: "default";
    };
    readonly colorOption: {
        readonly colorOptionName: "--orange-terre-battue-main-645";
        readonly themePath: readonly ["orangeTerreBattue", "main645", "default"];
        readonly color: "#e4794a";
        readonly parsedColorOptionName: {
            readonly colorName: "orangeTerreBattue";
            readonly brightness: {
                readonly isInvariant: true;
                readonly value: 645;
                readonly variant: "main";
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-default-brown-cafe-creme";
    readonly themePath: readonly ["border", "default", "brownCafeCreme", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "border";
        readonly colorName: "brownCafeCreme";
        readonly usage: "default";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-cafe-creme-main-782";
        readonly themePath: readonly ["brownCafeCreme", "main782", "default"];
        readonly color: "#d1b781";
        readonly parsedColorOptionName: {
            readonly colorName: "brownCafeCreme";
            readonly brightness: {
                readonly isInvariant: true;
                readonly value: 782;
                readonly variant: "main";
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-default-brown-caramel";
    readonly themePath: readonly ["border", "default", "brownCaramel", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "border";
        readonly colorName: "brownCaramel";
        readonly usage: "default";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-caramel-main-648";
        readonly themePath: readonly ["brownCaramel", "main648", "default"];
        readonly color: "#c08c65";
        readonly parsedColorOptionName: {
            readonly colorName: "brownCaramel";
            readonly brightness: {
                readonly isInvariant: true;
                readonly value: 648;
                readonly variant: "main";
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-default-brown-opera";
    readonly themePath: readonly ["border", "default", "brownOpera", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "border";
        readonly colorName: "brownOpera";
        readonly usage: "default";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-opera-main-680";
        readonly themePath: readonly ["brownOpera", "main680", "default"];
        readonly color: "#bd987a";
        readonly parsedColorOptionName: {
            readonly colorName: "brownOpera";
            readonly brightness: {
                readonly isInvariant: true;
                readonly value: 680;
                readonly variant: "main";
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-default-beige-gris-galet";
    readonly themePath: readonly ["border", "default", "beigeGrisGalet", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "border";
        readonly colorName: "beigeGrisGalet";
        readonly usage: "default";
    };
    readonly colorOption: {
        readonly colorOptionName: "--beige-gris-galet-main-702";
        readonly themePath: readonly ["beigeGrisGalet", "main702", "default"];
        readonly color: "#aea397";
        readonly parsedColorOptionName: {
            readonly colorName: "beigeGrisGalet";
            readonly brightness: {
                readonly isInvariant: true;
                readonly value: 702;
                readonly variant: "main";
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-contrast-grey";
    readonly themePath: readonly ["border", "contrast", "grey", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "border";
        readonly colorName: "grey";
        readonly usage: "contrast";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-625-425";
        readonly themePath: readonly ["grey", "_625_425", "default"];
        readonly color: {
            readonly light: "#929292";
            readonly dark: "#666666";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 625;
                };
                readonly dark: {
                    readonly value: 425;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-active-blue-france";
    readonly themePath: readonly ["border", "active", "blueFrance", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "border";
        readonly colorName: "blueFrance";
        readonly usage: "active";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-france-sun-113-625";
        readonly themePath: readonly ["blueFrance", "sun113_625", "default"];
        readonly color: {
            readonly light: "#000091";
            readonly dark: "#8585f6";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueFrance";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 113;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-active-red-marianne";
    readonly themePath: readonly ["border", "active", "redMarianne", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "border";
        readonly colorName: "redMarianne";
        readonly usage: "active";
    };
    readonly colorOption: {
        readonly colorOptionName: "--red-marianne-425-625";
        readonly themePath: readonly ["redMarianne", "_425_625", "default"];
        readonly color: {
            readonly light: "#c9191e";
            readonly dark: "#f95c5e";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "redMarianne";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-action-high-grey";
    readonly themePath: readonly ["border", "actionHigh", "grey", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly context: "border";
        readonly colorName: "grey";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-50-1000";
        readonly themePath: readonly ["grey", "_50_1000", "default"];
        readonly color: {
            readonly light: "#161616";
            readonly dark: "#ffffff";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 50;
                };
                readonly dark: {
                    readonly value: 1000;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-action-high-blue-france";
    readonly themePath: readonly ["border", "actionHigh", "blueFrance", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly context: "border";
        readonly colorName: "blueFrance";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-france-sun-113-625";
        readonly themePath: readonly ["blueFrance", "sun113_625", "default"];
        readonly color: {
            readonly light: "#000091";
            readonly dark: "#8585f6";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueFrance";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 113;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-action-high-red-marianne";
    readonly themePath: readonly ["border", "actionHigh", "redMarianne", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly context: "border";
        readonly colorName: "redMarianne";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--red-marianne-425-625";
        readonly themePath: readonly ["redMarianne", "_425_625", "default"];
        readonly color: {
            readonly light: "#c9191e";
            readonly dark: "#f95c5e";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "redMarianne";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-action-high-info";
    readonly themePath: readonly ["border", "actionHigh", "info", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly context: "border";
        readonly colorName: "info";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--info-425-625";
        readonly themePath: readonly ["info", "_425_625", "default"];
        readonly color: {
            readonly light: "#0063cb";
            readonly dark: "#518fff";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "info";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-action-high-success";
    readonly themePath: readonly ["border", "actionHigh", "success", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly context: "border";
        readonly colorName: "success";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--success-425-625";
        readonly themePath: readonly ["success", "_425_625", "default"];
        readonly color: {
            readonly light: "#18753c";
            readonly dark: "#27a658";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "success";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-action-high-warning";
    readonly themePath: readonly ["border", "actionHigh", "warning", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly context: "border";
        readonly colorName: "warning";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--warning-425-625";
        readonly themePath: readonly ["warning", "_425_625", "default"];
        readonly color: {
            readonly light: "#b34000";
            readonly dark: "#fc5d00";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "warning";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-action-high-error";
    readonly themePath: readonly ["border", "actionHigh", "error", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "high";
        readonly context: "border";
        readonly colorName: "error";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--error-425-625";
        readonly themePath: readonly ["error", "_425_625", "default"];
        readonly color: {
            readonly light: "#ce0500";
            readonly dark: "#ff5655";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "error";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-action-low-blue-france";
    readonly themePath: readonly ["border", "actionLow", "blueFrance", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly context: "border";
        readonly colorName: "blueFrance";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-france-850-200";
        readonly themePath: readonly ["blueFrance", "_850_200", "default"];
        readonly color: {
            readonly light: "#cacafb";
            readonly dark: "#313178";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueFrance";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 850;
                };
                readonly dark: {
                    readonly value: 200;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-action-low-red-marianne";
    readonly themePath: readonly ["border", "actionLow", "redMarianne", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly context: "border";
        readonly colorName: "redMarianne";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--red-marianne-850-200";
        readonly themePath: readonly ["redMarianne", "_850_200", "default"];
        readonly color: {
            readonly light: "#fcbfbf";
            readonly dark: "#5e2a2b";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "redMarianne";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 850;
                };
                readonly dark: {
                    readonly value: 200;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-action-low-green-tilleul-verveine";
    readonly themePath: readonly ["border", "actionLow", "greenTilleulVerveine", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly context: "border";
        readonly colorName: "greenTilleulVerveine";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-tilleul-verveine-850-200";
        readonly themePath: readonly ["greenTilleulVerveine", "_850_200", "default"];
        readonly color: {
            readonly light: "#e2cf58";
            readonly dark: "#3f3a20";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenTilleulVerveine";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 850;
                };
                readonly dark: {
                    readonly value: 200;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-action-low-green-bourgeon";
    readonly themePath: readonly ["border", "actionLow", "greenBourgeon", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly context: "border";
        readonly colorName: "greenBourgeon";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-bourgeon-850-200";
        readonly themePath: readonly ["greenBourgeon", "_850_200", "default"];
        readonly color: {
            readonly light: "#95e257";
            readonly dark: "#2a401a";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenBourgeon";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 850;
                };
                readonly dark: {
                    readonly value: 200;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-action-low-green-emeraude";
    readonly themePath: readonly ["border", "actionLow", "greenEmeraude", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly context: "border";
        readonly colorName: "greenEmeraude";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-emeraude-850-200";
        readonly themePath: readonly ["greenEmeraude", "_850_200", "default"];
        readonly color: {
            readonly light: "#6fe49d";
            readonly dark: "#21402c";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenEmeraude";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 850;
                };
                readonly dark: {
                    readonly value: 200;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-action-low-green-menthe";
    readonly themePath: readonly ["border", "actionLow", "greenMenthe", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly context: "border";
        readonly colorName: "greenMenthe";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-menthe-850-200";
        readonly themePath: readonly ["greenMenthe", "_850_200", "default"];
        readonly color: {
            readonly light: "#73e0cf";
            readonly dark: "#223f3a";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenMenthe";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 850;
                };
                readonly dark: {
                    readonly value: 200;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-action-low-green-archipel";
    readonly themePath: readonly ["border", "actionLow", "greenArchipel", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly context: "border";
        readonly colorName: "greenArchipel";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-archipel-850-200";
        readonly themePath: readonly ["greenArchipel", "_850_200", "default"];
        readonly color: {
            readonly light: "#60e0eb";
            readonly dark: "#233e41";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenArchipel";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 850;
                };
                readonly dark: {
                    readonly value: 200;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-action-low-blue-ecume";
    readonly themePath: readonly ["border", "actionLow", "blueEcume", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly context: "border";
        readonly colorName: "blueEcume";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-ecume-850-200";
        readonly themePath: readonly ["blueEcume", "_850_200", "default"];
        readonly color: {
            readonly light: "#bfccfb";
            readonly dark: "#273962";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueEcume";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 850;
                };
                readonly dark: {
                    readonly value: 200;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-action-low-blue-cumulus";
    readonly themePath: readonly ["border", "actionLow", "blueCumulus", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly context: "border";
        readonly colorName: "blueCumulus";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-cumulus-850-200";
        readonly themePath: readonly ["blueCumulus", "_850_200", "default"];
        readonly color: {
            readonly light: "#b6cffb";
            readonly dark: "#263b58";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueCumulus";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 850;
                };
                readonly dark: {
                    readonly value: 200;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-action-low-purple-glycine";
    readonly themePath: readonly ["border", "actionLow", "purpleGlycine", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly context: "border";
        readonly colorName: "purpleGlycine";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--purple-glycine-850-200";
        readonly themePath: readonly ["purpleGlycine", "_850_200", "default"];
        readonly color: {
            readonly light: "#fbb8f6";
            readonly dark: "#502e4d";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "purpleGlycine";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 850;
                };
                readonly dark: {
                    readonly value: 200;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-action-low-pink-macaron";
    readonly themePath: readonly ["border", "actionLow", "pinkMacaron", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly context: "border";
        readonly colorName: "pinkMacaron";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-macaron-850-200";
        readonly themePath: readonly ["pinkMacaron", "_850_200", "default"];
        readonly color: {
            readonly light: "#fcc0b4";
            readonly dark: "#52312a";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "pinkMacaron";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 850;
                };
                readonly dark: {
                    readonly value: 200;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-action-low-pink-tuile";
    readonly themePath: readonly ["border", "actionLow", "pinkTuile", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly context: "border";
        readonly colorName: "pinkTuile";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-tuile-850-200";
        readonly themePath: readonly ["pinkTuile", "_850_200", "default"];
        readonly color: {
            readonly light: "#fcbfb7";
            readonly dark: "#55302a";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "pinkTuile";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 850;
                };
                readonly dark: {
                    readonly value: 200;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-action-low-yellow-tournesol";
    readonly themePath: readonly ["border", "actionLow", "yellowTournesol", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly context: "border";
        readonly colorName: "yellowTournesol";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-tournesol-850-200";
        readonly themePath: readonly ["yellowTournesol", "_850_200", "default"];
        readonly color: {
            readonly light: "#efcb3a";
            readonly dark: "#43391a";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "yellowTournesol";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 850;
                };
                readonly dark: {
                    readonly value: 200;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-action-low-yellow-moutarde";
    readonly themePath: readonly ["border", "actionLow", "yellowMoutarde", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly context: "border";
        readonly colorName: "yellowMoutarde";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-moutarde-850-200";
        readonly themePath: readonly ["yellowMoutarde", "_850_200", "default"];
        readonly color: {
            readonly light: "#fcc63a";
            readonly dark: "#453820";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "yellowMoutarde";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 850;
                };
                readonly dark: {
                    readonly value: 200;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-action-low-orange-terre-battue";
    readonly themePath: readonly ["border", "actionLow", "orangeTerreBattue", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly context: "border";
        readonly colorName: "orangeTerreBattue";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--orange-terre-battue-850-200";
        readonly themePath: readonly ["orangeTerreBattue", "_850_200", "default"];
        readonly color: {
            readonly light: "#fcc0b0";
            readonly dark: "#543125";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "orangeTerreBattue";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 850;
                };
                readonly dark: {
                    readonly value: 200;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-action-low-brown-cafe-creme";
    readonly themePath: readonly ["border", "actionLow", "brownCafeCreme", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly context: "border";
        readonly colorName: "brownCafeCreme";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-cafe-creme-850-200";
        readonly themePath: readonly ["brownCafeCreme", "_850_200", "default"];
        readonly color: {
            readonly light: "#e7ca8e";
            readonly dark: "#423925";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownCafeCreme";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 850;
                };
                readonly dark: {
                    readonly value: 200;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-action-low-brown-caramel";
    readonly themePath: readonly ["border", "actionLow", "brownCaramel", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly context: "border";
        readonly colorName: "brownCaramel";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-caramel-850-200";
        readonly themePath: readonly ["brownCaramel", "_850_200", "default"];
        readonly color: {
            readonly light: "#eac7b2";
            readonly dark: "#4b3525";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownCaramel";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 850;
                };
                readonly dark: {
                    readonly value: 200;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-action-low-brown-opera";
    readonly themePath: readonly ["border", "actionLow", "brownOpera", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly context: "border";
        readonly colorName: "brownOpera";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-opera-850-200";
        readonly themePath: readonly ["brownOpera", "_850_200", "default"];
        readonly color: {
            readonly light: "#eac7ad";
            readonly dark: "#493625";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownOpera";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 850;
                };
                readonly dark: {
                    readonly value: 200;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-action-low-beige-gris-galet";
    readonly themePath: readonly ["border", "actionLow", "beigeGrisGalet", "default"];
    readonly parsedColorDecisionName: {
        readonly variant: "low";
        readonly context: "border";
        readonly colorName: "beigeGrisGalet";
        readonly usage: "action";
    };
    readonly colorOption: {
        readonly colorOptionName: "--beige-gris-galet-850-200";
        readonly themePath: readonly ["beigeGrisGalet", "_850_200", "default"];
        readonly color: {
            readonly light: "#e0cab0";
            readonly dark: "#433829";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "beigeGrisGalet";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 850;
                };
                readonly dark: {
                    readonly value: 200;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-open-blue-france";
    readonly themePath: readonly ["border", "open", "blueFrance", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "border";
        readonly colorName: "blueFrance";
        readonly usage: "open";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-france-925-125";
        readonly themePath: readonly ["blueFrance", "_925_125", "default"];
        readonly color: {
            readonly light: "#e3e3fd";
            readonly dark: "#272747";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueFrance";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-open-red-marianne";
    readonly themePath: readonly ["border", "open", "redMarianne", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "border";
        readonly colorName: "redMarianne";
        readonly usage: "open";
    };
    readonly colorOption: {
        readonly colorOptionName: "--red-marianne-925-125";
        readonly themePath: readonly ["redMarianne", "_925_125", "default"];
        readonly color: {
            readonly light: "#fddede";
            readonly dark: "#3b2424";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "redMarianne";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-plain-grey";
    readonly themePath: readonly ["border", "plain", "grey", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "border";
        readonly colorName: "grey";
        readonly usage: "plain";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-200-850";
        readonly themePath: readonly ["grey", "_200_850", "default"];
        readonly color: {
            readonly light: "#3a3a3a";
            readonly dark: "#cecece";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 200;
                };
                readonly dark: {
                    readonly value: 850;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-plain-blue-france";
    readonly themePath: readonly ["border", "plain", "blueFrance", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "border";
        readonly colorName: "blueFrance";
        readonly usage: "plain";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-france-sun-113-625";
        readonly themePath: readonly ["blueFrance", "sun113_625", "default"];
        readonly color: {
            readonly light: "#000091";
            readonly dark: "#8585f6";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueFrance";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 113;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-plain-red-marianne";
    readonly themePath: readonly ["border", "plain", "redMarianne", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "border";
        readonly colorName: "redMarianne";
        readonly usage: "plain";
    };
    readonly colorOption: {
        readonly colorOptionName: "--red-marianne-425-625";
        readonly themePath: readonly ["redMarianne", "_425_625", "default"];
        readonly color: {
            readonly light: "#c9191e";
            readonly dark: "#f95c5e";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "redMarianne";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-plain-info";
    readonly themePath: readonly ["border", "plain", "info", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "border";
        readonly colorName: "info";
        readonly usage: "plain";
    };
    readonly colorOption: {
        readonly colorOptionName: "--info-425-625";
        readonly themePath: readonly ["info", "_425_625", "default"];
        readonly color: {
            readonly light: "#0063cb";
            readonly dark: "#518fff";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "info";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-plain-success";
    readonly themePath: readonly ["border", "plain", "success", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "border";
        readonly colorName: "success";
        readonly usage: "plain";
    };
    readonly colorOption: {
        readonly colorOptionName: "--success-425-625";
        readonly themePath: readonly ["success", "_425_625", "default"];
        readonly color: {
            readonly light: "#18753c";
            readonly dark: "#27a658";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "success";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-plain-warning";
    readonly themePath: readonly ["border", "plain", "warning", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "border";
        readonly colorName: "warning";
        readonly usage: "plain";
    };
    readonly colorOption: {
        readonly colorOptionName: "--warning-425-625";
        readonly themePath: readonly ["warning", "_425_625", "default"];
        readonly color: {
            readonly light: "#b34000";
            readonly dark: "#fc5d00";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "warning";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-plain-error";
    readonly themePath: readonly ["border", "plain", "error", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "border";
        readonly colorName: "error";
        readonly usage: "plain";
    };
    readonly colorOption: {
        readonly colorOptionName: "--error-425-625";
        readonly themePath: readonly ["error", "_425_625", "default"];
        readonly color: {
            readonly light: "#ce0500";
            readonly dark: "#ff5655";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "error";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-plain-green-tilleul-verveine";
    readonly themePath: readonly ["border", "plain", "greenTilleulVerveine", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "border";
        readonly colorName: "greenTilleulVerveine";
        readonly usage: "plain";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-tilleul-verveine-sun-418-moon-817";
        readonly themePath: readonly ["greenTilleulVerveine", "sun418moon817", "default"];
        readonly color: {
            readonly light: "#66673d";
            readonly dark: "#d8c634";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenTilleulVerveine";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 418;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 817;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-plain-green-bourgeon";
    readonly themePath: readonly ["border", "plain", "greenBourgeon", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "border";
        readonly colorName: "greenBourgeon";
        readonly usage: "plain";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-bourgeon-sun-425-moon-759";
        readonly themePath: readonly ["greenBourgeon", "sun425moon759", "default"];
        readonly color: {
            readonly light: "#447049";
            readonly dark: "#99c221";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenBourgeon";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 759;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-plain-green-emeraude";
    readonly themePath: readonly ["border", "plain", "greenEmeraude", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "border";
        readonly colorName: "greenEmeraude";
        readonly usage: "plain";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-emeraude-sun-425-moon-753";
        readonly themePath: readonly ["greenEmeraude", "sun425moon753", "default"];
        readonly color: {
            readonly light: "#297254";
            readonly dark: "#34cb6a";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenEmeraude";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 753;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-plain-green-menthe";
    readonly themePath: readonly ["border", "plain", "greenMenthe", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "border";
        readonly colorName: "greenMenthe";
        readonly usage: "plain";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-menthe-sun-373-moon-652";
        readonly themePath: readonly ["greenMenthe", "sun373moon652", "default"];
        readonly color: {
            readonly light: "#37635f";
            readonly dark: "#21ab8e";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenMenthe";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 373;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 652;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-plain-green-archipel";
    readonly themePath: readonly ["border", "plain", "greenArchipel", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "border";
        readonly colorName: "greenArchipel";
        readonly usage: "plain";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-archipel-sun-391-moon-716";
        readonly themePath: readonly ["greenArchipel", "sun391moon716", "default"];
        readonly color: {
            readonly light: "#006a6f";
            readonly dark: "#34bab5";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenArchipel";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 391;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 716;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-plain-blue-ecume";
    readonly themePath: readonly ["border", "plain", "blueEcume", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "border";
        readonly colorName: "blueEcume";
        readonly usage: "plain";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-ecume-sun-247-moon-675";
        readonly themePath: readonly ["blueEcume", "sun247moon675", "default"];
        readonly color: {
            readonly light: "#2f4077";
            readonly dark: "#869ece";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueEcume";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 247;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 675;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-plain-blue-cumulus";
    readonly themePath: readonly ["border", "plain", "blueCumulus", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "border";
        readonly colorName: "blueCumulus";
        readonly usage: "plain";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-cumulus-sun-368-moon-732";
        readonly themePath: readonly ["blueCumulus", "sun368moon732", "default"];
        readonly color: {
            readonly light: "#3558a2";
            readonly dark: "#7ab1e8";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueCumulus";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 368;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 732;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-plain-purple-glycine";
    readonly themePath: readonly ["border", "plain", "purpleGlycine", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "border";
        readonly colorName: "purpleGlycine";
        readonly usage: "plain";
    };
    readonly colorOption: {
        readonly colorOptionName: "--purple-glycine-sun-319-moon-630";
        readonly themePath: readonly ["purpleGlycine", "sun319moon630", "default"];
        readonly color: {
            readonly light: "#6e445a";
            readonly dark: "#ce70cc";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "purpleGlycine";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 319;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 630;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-plain-pink-macaron";
    readonly themePath: readonly ["border", "plain", "pinkMacaron", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "border";
        readonly colorName: "pinkMacaron";
        readonly usage: "plain";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-macaron-sun-406-moon-833";
        readonly themePath: readonly ["pinkMacaron", "sun406moon833", "default"];
        readonly color: {
            readonly light: "#8d533e";
            readonly dark: "#ffb7ae";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "pinkMacaron";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 406;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 833;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-plain-pink-tuile";
    readonly themePath: readonly ["border", "plain", "pinkTuile", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "border";
        readonly colorName: "pinkTuile";
        readonly usage: "plain";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-tuile-sun-425-moon-750";
        readonly themePath: readonly ["pinkTuile", "sun425moon750", "default"];
        readonly color: {
            readonly light: "#a94645";
            readonly dark: "#ff9575";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "pinkTuile";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 750;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-plain-yellow-tournesol";
    readonly themePath: readonly ["border", "plain", "yellowTournesol", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "border";
        readonly colorName: "yellowTournesol";
        readonly usage: "plain";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-tournesol-sun-407-moon-922";
        readonly themePath: readonly ["yellowTournesol", "sun407moon922", "default"];
        readonly color: {
            readonly light: "#716043";
            readonly dark: "#ffe552";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "yellowTournesol";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 407;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 922;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-plain-yellow-moutarde";
    readonly themePath: readonly ["border", "plain", "yellowMoutarde", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "border";
        readonly colorName: "yellowMoutarde";
        readonly usage: "plain";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-moutarde-sun-348-moon-860";
        readonly themePath: readonly ["yellowMoutarde", "sun348moon860", "default"];
        readonly color: {
            readonly light: "#695240";
            readonly dark: "#ffca00";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "yellowMoutarde";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 348;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 860;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-plain-orange-terre-battue";
    readonly themePath: readonly ["border", "plain", "orangeTerreBattue", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "border";
        readonly colorName: "orangeTerreBattue";
        readonly usage: "plain";
    };
    readonly colorOption: {
        readonly colorOptionName: "--orange-terre-battue-sun-370-moon-672";
        readonly themePath: readonly ["orangeTerreBattue", "sun370moon672", "default"];
        readonly color: {
            readonly light: "#755348";
            readonly dark: "#ff732c";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "orangeTerreBattue";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 370;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 672;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-plain-brown-cafe-creme";
    readonly themePath: readonly ["border", "plain", "brownCafeCreme", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "border";
        readonly colorName: "brownCafeCreme";
        readonly usage: "plain";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-cafe-creme-sun-383-moon-885";
        readonly themePath: readonly ["brownCafeCreme", "sun383moon885", "default"];
        readonly color: {
            readonly light: "#685c48";
            readonly dark: "#ecd7a2";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownCafeCreme";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 383;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 885;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-plain-brown-caramel";
    readonly themePath: readonly ["border", "plain", "brownCaramel", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "border";
        readonly colorName: "brownCaramel";
        readonly usage: "plain";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-caramel-sun-425-moon-901";
        readonly themePath: readonly ["brownCaramel", "sun425moon901", "default"];
        readonly color: {
            readonly light: "#845d48";
            readonly dark: "#fbd8ab";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownCaramel";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 901;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-plain-brown-opera";
    readonly themePath: readonly ["border", "plain", "brownOpera", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "border";
        readonly colorName: "brownOpera";
        readonly usage: "plain";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-opera-sun-395-moon-820";
        readonly themePath: readonly ["brownOpera", "sun395moon820", "default"];
        readonly color: {
            readonly light: "#745b47";
            readonly dark: "#e6be92";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownOpera";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 395;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 820;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-plain-beige-gris-galet";
    readonly themePath: readonly ["border", "plain", "beigeGrisGalet", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "border";
        readonly colorName: "beigeGrisGalet";
        readonly usage: "plain";
    };
    readonly colorOption: {
        readonly colorOptionName: "--beige-gris-galet-sun-407-moon-821";
        readonly themePath: readonly ["beigeGrisGalet", "sun407moon821", "default"];
        readonly color: {
            readonly light: "#6a6156";
            readonly dark: "#d0c3b7";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "beigeGrisGalet";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 407;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 821;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--border-disabled-grey";
    readonly themePath: readonly ["border", "disabled", "grey", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "border";
        readonly colorName: "grey";
        readonly usage: "disabled";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-925-125";
        readonly themePath: readonly ["grey", "_925_125", "default"];
        readonly color: {
            readonly light: "#e5e5e5";
            readonly dark: "#2a2a2a";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-blue-france";
    readonly themePath: readonly ["artwork", "major", "blueFrance", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "blueFrance";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-france-sun-113-625";
        readonly themePath: readonly ["blueFrance", "sun113_625", "default"];
        readonly color: {
            readonly light: "#000091";
            readonly dark: "#8585f6";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueFrance";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 113;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-blue-france-hover";
    readonly themePath: readonly ["artwork", "major", "blueFrance", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "artwork";
        readonly colorName: "blueFrance";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-france-sun-113-625-hover";
        readonly themePath: readonly ["blueFrance", "sun113_625", "hover"];
        readonly color: {
            readonly light: "#1212ff";
            readonly dark: "#b1b1f9";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueFrance";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 113;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-blue-france-active";
    readonly themePath: readonly ["artwork", "major", "blueFrance", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "artwork";
        readonly colorName: "blueFrance";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-france-sun-113-625-active";
        readonly themePath: readonly ["blueFrance", "sun113_625", "active"];
        readonly color: {
            readonly light: "#2323ff";
            readonly dark: "#c6c6fb";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueFrance";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 113;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-red-marianne";
    readonly themePath: readonly ["artwork", "major", "redMarianne", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "redMarianne";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--red-marianne-425-625";
        readonly themePath: readonly ["redMarianne", "_425_625", "default"];
        readonly color: {
            readonly light: "#c9191e";
            readonly dark: "#f95c5e";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "redMarianne";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-red-marianne-hover";
    readonly themePath: readonly ["artwork", "major", "redMarianne", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "artwork";
        readonly colorName: "redMarianne";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--red-marianne-425-625-hover";
        readonly themePath: readonly ["redMarianne", "_425_625", "hover"];
        readonly color: {
            readonly light: "#f93f42";
            readonly dark: "#fa9293";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "redMarianne";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-red-marianne-active";
    readonly themePath: readonly ["artwork", "major", "redMarianne", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "artwork";
        readonly colorName: "redMarianne";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--red-marianne-425-625-active";
        readonly themePath: readonly ["redMarianne", "_425_625", "active"];
        readonly color: {
            readonly light: "#f95a5c";
            readonly dark: "#fbabac";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "redMarianne";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                };
                readonly dark: {
                    readonly value: 625;
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-green-tilleul-verveine";
    readonly themePath: readonly ["artwork", "major", "greenTilleulVerveine", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "greenTilleulVerveine";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-tilleul-verveine-sun-418-moon-817";
        readonly themePath: readonly ["greenTilleulVerveine", "sun418moon817", "default"];
        readonly color: {
            readonly light: "#66673d";
            readonly dark: "#d8c634";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenTilleulVerveine";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 418;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 817;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-green-tilleul-verveine-hover";
    readonly themePath: readonly ["artwork", "major", "greenTilleulVerveine", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "artwork";
        readonly colorName: "greenTilleulVerveine";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-tilleul-verveine-sun-418-moon-817-hover";
        readonly themePath: readonly ["greenTilleulVerveine", "sun418moon817", "hover"];
        readonly color: {
            readonly light: "#929359";
            readonly dark: "#fee943";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenTilleulVerveine";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 418;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 817;
                    readonly variant: "moon";
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-green-tilleul-verveine-active";
    readonly themePath: readonly ["artwork", "major", "greenTilleulVerveine", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "artwork";
        readonly colorName: "greenTilleulVerveine";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-tilleul-verveine-sun-418-moon-817-active";
        readonly themePath: readonly ["greenTilleulVerveine", "sun418moon817", "active"];
        readonly color: {
            readonly light: "#a7a967";
            readonly dark: "#fef1ab";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenTilleulVerveine";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 418;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 817;
                    readonly variant: "moon";
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-green-bourgeon";
    readonly themePath: readonly ["artwork", "major", "greenBourgeon", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "greenBourgeon";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-bourgeon-sun-425-moon-759";
        readonly themePath: readonly ["greenBourgeon", "sun425moon759", "default"];
        readonly color: {
            readonly light: "#447049";
            readonly dark: "#99c221";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenBourgeon";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 759;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-green-bourgeon-hover";
    readonly themePath: readonly ["artwork", "major", "greenBourgeon", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "artwork";
        readonly colorName: "greenBourgeon";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-bourgeon-sun-425-moon-759-hover";
        readonly themePath: readonly ["greenBourgeon", "sun425moon759", "hover"];
        readonly color: {
            readonly light: "#639f6a";
            readonly dark: "#baec2a";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenBourgeon";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 759;
                    readonly variant: "moon";
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-green-bourgeon-active";
    readonly themePath: readonly ["artwork", "major", "greenBourgeon", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "artwork";
        readonly colorName: "greenBourgeon";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-bourgeon-sun-425-moon-759-active";
        readonly themePath: readonly ["greenBourgeon", "sun425moon759", "active"];
        readonly color: {
            readonly light: "#72b77a";
            readonly dark: "#c9fd2e";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenBourgeon";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 759;
                    readonly variant: "moon";
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-green-emeraude";
    readonly themePath: readonly ["artwork", "major", "greenEmeraude", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "greenEmeraude";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-emeraude-sun-425-moon-753";
        readonly themePath: readonly ["greenEmeraude", "sun425moon753", "default"];
        readonly color: {
            readonly light: "#297254";
            readonly dark: "#34cb6a";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenEmeraude";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 753;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-green-emeraude-hover";
    readonly themePath: readonly ["artwork", "major", "greenEmeraude", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "artwork";
        readonly colorName: "greenEmeraude";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-emeraude-sun-425-moon-753-hover";
        readonly themePath: readonly ["greenEmeraude", "sun425moon753", "hover"];
        readonly color: {
            readonly light: "#3ea47a";
            readonly dark: "#42fb84";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenEmeraude";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 753;
                    readonly variant: "moon";
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-green-emeraude-active";
    readonly themePath: readonly ["artwork", "major", "greenEmeraude", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "artwork";
        readonly colorName: "greenEmeraude";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-emeraude-sun-425-moon-753-active";
        readonly themePath: readonly ["greenEmeraude", "sun425moon753", "active"];
        readonly color: {
            readonly light: "#49bc8d";
            readonly dark: "#80fda3";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenEmeraude";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 753;
                    readonly variant: "moon";
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-green-menthe";
    readonly themePath: readonly ["artwork", "major", "greenMenthe", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "greenMenthe";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-menthe-sun-373-moon-652";
        readonly themePath: readonly ["greenMenthe", "sun373moon652", "default"];
        readonly color: {
            readonly light: "#37635f";
            readonly dark: "#21ab8e";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenMenthe";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 373;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 652;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-green-menthe-hover";
    readonly themePath: readonly ["artwork", "major", "greenMenthe", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "artwork";
        readonly colorName: "greenMenthe";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-menthe-sun-373-moon-652-hover";
        readonly themePath: readonly ["greenMenthe", "sun373moon652", "hover"];
        readonly color: {
            readonly light: "#53918c";
            readonly dark: "#2eddb8";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenMenthe";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 373;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 652;
                    readonly variant: "moon";
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-green-menthe-active";
    readonly themePath: readonly ["artwork", "major", "greenMenthe", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "artwork";
        readonly colorName: "greenMenthe";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-menthe-sun-373-moon-652-active";
        readonly themePath: readonly ["greenMenthe", "sun373moon652", "active"];
        readonly color: {
            readonly light: "#62a9a2";
            readonly dark: "#34f4cc";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenMenthe";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 373;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 652;
                    readonly variant: "moon";
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-green-archipel";
    readonly themePath: readonly ["artwork", "major", "greenArchipel", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "greenArchipel";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-archipel-sun-391-moon-716";
        readonly themePath: readonly ["greenArchipel", "sun391moon716", "default"];
        readonly color: {
            readonly light: "#006a6f";
            readonly dark: "#34bab5";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenArchipel";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 391;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 716;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-green-archipel-hover";
    readonly themePath: readonly ["artwork", "major", "greenArchipel", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "artwork";
        readonly colorName: "greenArchipel";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-archipel-sun-391-moon-716-hover";
        readonly themePath: readonly ["greenArchipel", "sun391moon716", "hover"];
        readonly color: {
            readonly light: "#009fa7";
            readonly dark: "#43e9e2";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenArchipel";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 391;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 716;
                    readonly variant: "moon";
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-green-archipel-active";
    readonly themePath: readonly ["artwork", "major", "greenArchipel", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "artwork";
        readonly colorName: "greenArchipel";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-archipel-sun-391-moon-716-active";
        readonly themePath: readonly ["greenArchipel", "sun391moon716", "active"];
        readonly color: {
            readonly light: "#00bbc3";
            readonly dark: "#4cfdf6";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenArchipel";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 391;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 716;
                    readonly variant: "moon";
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-blue-ecume";
    readonly themePath: readonly ["artwork", "major", "blueEcume", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "blueEcume";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-ecume-sun-247-moon-675";
        readonly themePath: readonly ["blueEcume", "sun247moon675", "default"];
        readonly color: {
            readonly light: "#2f4077";
            readonly dark: "#869ece";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueEcume";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 247;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 675;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-blue-ecume-hover";
    readonly themePath: readonly ["artwork", "major", "blueEcume", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "artwork";
        readonly colorName: "blueEcume";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-ecume-sun-247-moon-675-hover";
        readonly themePath: readonly ["blueEcume", "sun247moon675", "hover"];
        readonly color: {
            readonly light: "#4e68bb";
            readonly dark: "#b8c5e2";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueEcume";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 247;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 675;
                    readonly variant: "moon";
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-blue-ecume-active";
    readonly themePath: readonly ["artwork", "major", "blueEcume", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "artwork";
        readonly colorName: "blueEcume";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-ecume-sun-247-moon-675-active";
        readonly themePath: readonly ["blueEcume", "sun247moon675", "active"];
        readonly color: {
            readonly light: "#667dcf";
            readonly dark: "#ced6ea";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueEcume";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 247;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 675;
                    readonly variant: "moon";
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-blue-cumulus";
    readonly themePath: readonly ["artwork", "major", "blueCumulus", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "blueCumulus";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-cumulus-sun-368-moon-732";
        readonly themePath: readonly ["blueCumulus", "sun368moon732", "default"];
        readonly color: {
            readonly light: "#3558a2";
            readonly dark: "#7ab1e8";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueCumulus";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 368;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 732;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-blue-cumulus-hover";
    readonly themePath: readonly ["artwork", "major", "blueCumulus", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "artwork";
        readonly colorName: "blueCumulus";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-cumulus-sun-368-moon-732-hover";
        readonly themePath: readonly ["blueCumulus", "sun368moon732", "hover"];
        readonly color: {
            readonly light: "#5982e0";
            readonly dark: "#bad2f2";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueCumulus";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 368;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 732;
                    readonly variant: "moon";
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-blue-cumulus-active";
    readonly themePath: readonly ["artwork", "major", "blueCumulus", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "artwork";
        readonly colorName: "blueCumulus";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-cumulus-sun-368-moon-732-active";
        readonly themePath: readonly ["blueCumulus", "sun368moon732", "active"];
        readonly color: {
            readonly light: "#7996e6";
            readonly dark: "#d2e2f6";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueCumulus";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 368;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 732;
                    readonly variant: "moon";
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-purple-glycine";
    readonly themePath: readonly ["artwork", "major", "purpleGlycine", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "purpleGlycine";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--purple-glycine-sun-319-moon-630";
        readonly themePath: readonly ["purpleGlycine", "sun319moon630", "default"];
        readonly color: {
            readonly light: "#6e445a";
            readonly dark: "#ce70cc";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "purpleGlycine";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 319;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 630;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-purple-glycine-hover";
    readonly themePath: readonly ["artwork", "major", "purpleGlycine", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "artwork";
        readonly colorName: "purpleGlycine";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--purple-glycine-sun-319-moon-630-hover";
        readonly themePath: readonly ["purpleGlycine", "sun319moon630", "hover"];
        readonly color: {
            readonly light: "#a66989";
            readonly dark: "#dfa4dd";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "purpleGlycine";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 319;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 630;
                    readonly variant: "moon";
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-purple-glycine-active";
    readonly themePath: readonly ["artwork", "major", "purpleGlycine", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "artwork";
        readonly colorName: "purpleGlycine";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--purple-glycine-sun-319-moon-630-active";
        readonly themePath: readonly ["purpleGlycine", "sun319moon630", "active"];
        readonly color: {
            readonly light: "#bb7f9e";
            readonly dark: "#e7bbe6";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "purpleGlycine";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 319;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 630;
                    readonly variant: "moon";
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-pink-macaron";
    readonly themePath: readonly ["artwork", "major", "pinkMacaron", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "pinkMacaron";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-macaron-sun-406-moon-833";
        readonly themePath: readonly ["pinkMacaron", "sun406moon833", "default"];
        readonly color: {
            readonly light: "#8d533e";
            readonly dark: "#ffb7ae";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "pinkMacaron";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 406;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 833;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-pink-macaron-hover";
    readonly themePath: readonly ["artwork", "major", "pinkMacaron", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "artwork";
        readonly colorName: "pinkMacaron";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-macaron-sun-406-moon-833-hover";
        readonly themePath: readonly ["pinkMacaron", "sun406moon833", "hover"];
        readonly color: {
            readonly light: "#ca795c";
            readonly dark: "#ffe0dc";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "pinkMacaron";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 406;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 833;
                    readonly variant: "moon";
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-pink-macaron-active";
    readonly themePath: readonly ["artwork", "major", "pinkMacaron", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "artwork";
        readonly colorName: "pinkMacaron";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-macaron-sun-406-moon-833-active";
        readonly themePath: readonly ["pinkMacaron", "sun406moon833", "active"];
        readonly color: {
            readonly light: "#e08e73";
            readonly dark: "#fff0ee";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "pinkMacaron";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 406;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 833;
                    readonly variant: "moon";
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-pink-tuile";
    readonly themePath: readonly ["artwork", "major", "pinkTuile", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "pinkTuile";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-tuile-sun-425-moon-750";
        readonly themePath: readonly ["pinkTuile", "sun425moon750", "default"];
        readonly color: {
            readonly light: "#a94645";
            readonly dark: "#ff9575";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "pinkTuile";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 750;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-pink-tuile-hover";
    readonly themePath: readonly ["artwork", "major", "pinkTuile", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "artwork";
        readonly colorName: "pinkTuile";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-tuile-sun-425-moon-750-hover";
        readonly themePath: readonly ["pinkTuile", "sun425moon750", "hover"];
        readonly color: {
            readonly light: "#d5706f";
            readonly dark: "#ffc4b7";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "pinkTuile";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 750;
                    readonly variant: "moon";
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-pink-tuile-active";
    readonly themePath: readonly ["artwork", "major", "pinkTuile", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "artwork";
        readonly colorName: "pinkTuile";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-tuile-sun-425-moon-750-active";
        readonly themePath: readonly ["pinkTuile", "sun425moon750", "active"];
        readonly color: {
            readonly light: "#da8a89";
            readonly dark: "#ffd8d0";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "pinkTuile";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 750;
                    readonly variant: "moon";
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-yellow-tournesol";
    readonly themePath: readonly ["artwork", "major", "yellowTournesol", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "yellowTournesol";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-tournesol-sun-407-moon-922";
        readonly themePath: readonly ["yellowTournesol", "sun407moon922", "default"];
        readonly color: {
            readonly light: "#716043";
            readonly dark: "#ffe552";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "yellowTournesol";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 407;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 922;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-yellow-tournesol-hover";
    readonly themePath: readonly ["artwork", "major", "yellowTournesol", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "artwork";
        readonly colorName: "yellowTournesol";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-tournesol-sun-407-moon-922-hover";
        readonly themePath: readonly ["yellowTournesol", "sun407moon922", "hover"];
        readonly color: {
            readonly light: "#a28a62";
            readonly dark: "#e1c700";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "yellowTournesol";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 407;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 922;
                    readonly variant: "moon";
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-yellow-tournesol-active";
    readonly themePath: readonly ["artwork", "major", "yellowTournesol", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "artwork";
        readonly colorName: "yellowTournesol";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-tournesol-sun-407-moon-922-active";
        readonly themePath: readonly ["yellowTournesol", "sun407moon922", "active"];
        readonly color: {
            readonly light: "#ba9f72";
            readonly dark: "#cab300";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "yellowTournesol";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 407;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 922;
                    readonly variant: "moon";
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-yellow-moutarde";
    readonly themePath: readonly ["artwork", "major", "yellowMoutarde", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "yellowMoutarde";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-moutarde-sun-348-moon-860";
        readonly themePath: readonly ["yellowMoutarde", "sun348moon860", "default"];
        readonly color: {
            readonly light: "#695240";
            readonly dark: "#ffca00";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "yellowMoutarde";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 348;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 860;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-yellow-moutarde-hover";
    readonly themePath: readonly ["artwork", "major", "yellowMoutarde", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "artwork";
        readonly colorName: "yellowMoutarde";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-moutarde-sun-348-moon-860-hover";
        readonly themePath: readonly ["yellowMoutarde", "sun348moon860", "hover"];
        readonly color: {
            readonly light: "#9b7b61";
            readonly dark: "#cda200";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "yellowMoutarde";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 348;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 860;
                    readonly variant: "moon";
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-yellow-moutarde-active";
    readonly themePath: readonly ["artwork", "major", "yellowMoutarde", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "artwork";
        readonly colorName: "yellowMoutarde";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-moutarde-sun-348-moon-860-active";
        readonly themePath: readonly ["yellowMoutarde", "sun348moon860", "active"];
        readonly color: {
            readonly light: "#b58f72";
            readonly dark: "#b28c00";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "yellowMoutarde";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 348;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 860;
                    readonly variant: "moon";
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-orange-terre-battue";
    readonly themePath: readonly ["artwork", "major", "orangeTerreBattue", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "orangeTerreBattue";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--orange-terre-battue-sun-370-moon-672";
        readonly themePath: readonly ["orangeTerreBattue", "sun370moon672", "default"];
        readonly color: {
            readonly light: "#755348";
            readonly dark: "#ff732c";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "orangeTerreBattue";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 370;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 672;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-orange-terre-battue-hover";
    readonly themePath: readonly ["artwork", "major", "orangeTerreBattue", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "artwork";
        readonly colorName: "orangeTerreBattue";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--orange-terre-battue-sun-370-moon-672-hover";
        readonly themePath: readonly ["orangeTerreBattue", "sun370moon672", "hover"];
        readonly color: {
            readonly light: "#ab7b6b";
            readonly dark: "#ffa48b";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "orangeTerreBattue";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 370;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 672;
                    readonly variant: "moon";
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-orange-terre-battue-active";
    readonly themePath: readonly ["artwork", "major", "orangeTerreBattue", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "artwork";
        readonly colorName: "orangeTerreBattue";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--orange-terre-battue-sun-370-moon-672-active";
        readonly themePath: readonly ["orangeTerreBattue", "sun370moon672", "active"];
        readonly color: {
            readonly light: "#c68f7d";
            readonly dark: "#ffbbab";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "orangeTerreBattue";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 370;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 672;
                    readonly variant: "moon";
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-brown-cafe-creme";
    readonly themePath: readonly ["artwork", "major", "brownCafeCreme", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "brownCafeCreme";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-cafe-creme-sun-383-moon-885";
        readonly themePath: readonly ["brownCafeCreme", "sun383moon885", "default"];
        readonly color: {
            readonly light: "#685c48";
            readonly dark: "#ecd7a2";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownCafeCreme";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 383;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 885;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-brown-cafe-creme-hover";
    readonly themePath: readonly ["artwork", "major", "brownCafeCreme", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "artwork";
        readonly colorName: "brownCafeCreme";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-cafe-creme-sun-383-moon-885-hover";
        readonly themePath: readonly ["brownCafeCreme", "sun383moon885", "hover"];
        readonly color: {
            readonly light: "#97866a";
            readonly dark: "#c5b386";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownCafeCreme";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 383;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 885;
                    readonly variant: "moon";
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-brown-cafe-creme-active";
    readonly themePath: readonly ["artwork", "major", "brownCafeCreme", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "artwork";
        readonly colorName: "brownCafeCreme";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-cafe-creme-sun-383-moon-885-active";
        readonly themePath: readonly ["brownCafeCreme", "sun383moon885", "active"];
        readonly color: {
            readonly light: "#ae9b7b";
            readonly dark: "#af9f77";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownCafeCreme";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 383;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 885;
                    readonly variant: "moon";
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-brown-caramel";
    readonly themePath: readonly ["artwork", "major", "brownCaramel", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "brownCaramel";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-caramel-sun-425-moon-901";
        readonly themePath: readonly ["brownCaramel", "sun425moon901", "default"];
        readonly color: {
            readonly light: "#845d48";
            readonly dark: "#fbd8ab";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownCaramel";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 901;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-brown-caramel-hover";
    readonly themePath: readonly ["artwork", "major", "brownCaramel", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "artwork";
        readonly colorName: "brownCaramel";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-caramel-sun-425-moon-901-hover";
        readonly themePath: readonly ["brownCaramel", "sun425moon901", "hover"];
        readonly color: {
            readonly light: "#bb8568";
            readonly dark: "#efb547";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownCaramel";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 901;
                    readonly variant: "moon";
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-brown-caramel-active";
    readonly themePath: readonly ["artwork", "major", "brownCaramel", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "artwork";
        readonly colorName: "brownCaramel";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-caramel-sun-425-moon-901-active";
        readonly themePath: readonly ["brownCaramel", "sun425moon901", "active"];
        readonly color: {
            readonly light: "#d69978";
            readonly dark: "#d6a23e";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownCaramel";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 425;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 901;
                    readonly variant: "moon";
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-brown-opera";
    readonly themePath: readonly ["artwork", "major", "brownOpera", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "brownOpera";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-opera-sun-395-moon-820";
        readonly themePath: readonly ["brownOpera", "sun395moon820", "default"];
        readonly color: {
            readonly light: "#745b47";
            readonly dark: "#e6be92";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownOpera";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 395;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 820;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-brown-opera-hover";
    readonly themePath: readonly ["artwork", "major", "brownOpera", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "artwork";
        readonly colorName: "brownOpera";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-opera-sun-395-moon-820-hover";
        readonly themePath: readonly ["brownOpera", "sun395moon820", "hover"];
        readonly color: {
            readonly light: "#a78468";
            readonly dark: "#f2e2d3";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownOpera";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 395;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 820;
                    readonly variant: "moon";
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-brown-opera-active";
    readonly themePath: readonly ["artwork", "major", "brownOpera", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "artwork";
        readonly colorName: "brownOpera";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-opera-sun-395-moon-820-active";
        readonly themePath: readonly ["brownOpera", "sun395moon820", "active"];
        readonly color: {
            readonly light: "#c09979";
            readonly dark: "#f8f0e9";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownOpera";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 395;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 820;
                    readonly variant: "moon";
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-beige-gris-galet";
    readonly themePath: readonly ["artwork", "major", "beigeGrisGalet", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "beigeGrisGalet";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--beige-gris-galet-sun-407-moon-821";
        readonly themePath: readonly ["beigeGrisGalet", "sun407moon821", "default"];
        readonly color: {
            readonly light: "#6a6156";
            readonly dark: "#d0c3b7";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "beigeGrisGalet";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 407;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 821;
                    readonly variant: "moon";
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-beige-gris-galet-hover";
    readonly themePath: readonly ["artwork", "major", "beigeGrisGalet", "hover"];
    readonly parsedColorDecisionName: {
        readonly state: "hover";
        readonly context: "artwork";
        readonly colorName: "beigeGrisGalet";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--beige-gris-galet-sun-407-moon-821-hover";
        readonly themePath: readonly ["beigeGrisGalet", "sun407moon821", "hover"];
        readonly color: {
            readonly light: "#988b7c";
            readonly dark: "#eae5e1";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "beigeGrisGalet";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 407;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 821;
                    readonly variant: "moon";
                };
            };
            readonly state: "hover";
        };
    };
}, {
    readonly colorDecisionName: "--artwork-major-beige-gris-galet-active";
    readonly themePath: readonly ["artwork", "major", "beigeGrisGalet", "active"];
    readonly parsedColorDecisionName: {
        readonly state: "active";
        readonly context: "artwork";
        readonly colorName: "beigeGrisGalet";
        readonly usage: "major";
    };
    readonly colorOption: {
        readonly colorOptionName: "--beige-gris-galet-sun-407-moon-821-active";
        readonly themePath: readonly ["beigeGrisGalet", "sun407moon821", "active"];
        readonly color: {
            readonly light: "#afa08f";
            readonly dark: "#f4f2f0";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "beigeGrisGalet";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 407;
                    readonly variant: "sun";
                };
                readonly dark: {
                    readonly value: 821;
                    readonly variant: "moon";
                };
            };
            readonly state: "active";
        };
    };
}, {
    readonly colorDecisionName: "--artwork-minor-blue-france";
    readonly themePath: readonly ["artwork", "minor", "blueFrance", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "blueFrance";
        readonly usage: "minor";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-france-main-525";
        readonly themePath: readonly ["blueFrance", "main525", "default"];
        readonly color: "#6a6af4";
        readonly parsedColorOptionName: {
            readonly colorName: "blueFrance";
            readonly brightness: {
                readonly isInvariant: true;
                readonly value: 525;
                readonly variant: "main";
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-minor-red-marianne";
    readonly themePath: readonly ["artwork", "minor", "redMarianne", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "redMarianne";
        readonly usage: "minor";
    };
    readonly colorOption: {
        readonly colorOptionName: "--red-marianne-main-472";
        readonly themePath: readonly ["redMarianne", "main472", "default"];
        readonly color: "#e1000f";
        readonly parsedColorOptionName: {
            readonly colorName: "redMarianne";
            readonly brightness: {
                readonly isInvariant: true;
                readonly value: 472;
                readonly variant: "main";
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-minor-green-tilleul-verveine";
    readonly themePath: readonly ["artwork", "minor", "greenTilleulVerveine", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "greenTilleulVerveine";
        readonly usage: "minor";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-tilleul-verveine-main-707";
        readonly themePath: readonly ["greenTilleulVerveine", "main707", "default"];
        readonly color: "#b7a73f";
        readonly parsedColorOptionName: {
            readonly colorName: "greenTilleulVerveine";
            readonly brightness: {
                readonly isInvariant: true;
                readonly value: 707;
                readonly variant: "main";
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-minor-green-bourgeon";
    readonly themePath: readonly ["artwork", "minor", "greenBourgeon", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "greenBourgeon";
        readonly usage: "minor";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-bourgeon-main-640";
        readonly themePath: readonly ["greenBourgeon", "main640", "default"];
        readonly color: "#68a532";
        readonly parsedColorOptionName: {
            readonly colorName: "greenBourgeon";
            readonly brightness: {
                readonly isInvariant: true;
                readonly value: 640;
                readonly variant: "main";
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-minor-green-emeraude";
    readonly themePath: readonly ["artwork", "minor", "greenEmeraude", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "greenEmeraude";
        readonly usage: "minor";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-emeraude-main-632";
        readonly themePath: readonly ["greenEmeraude", "main632", "default"];
        readonly color: "#00a95f";
        readonly parsedColorOptionName: {
            readonly colorName: "greenEmeraude";
            readonly brightness: {
                readonly isInvariant: true;
                readonly value: 632;
                readonly variant: "main";
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-minor-green-menthe";
    readonly themePath: readonly ["artwork", "minor", "greenMenthe", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "greenMenthe";
        readonly usage: "minor";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-menthe-main-548";
        readonly themePath: readonly ["greenMenthe", "main548", "default"];
        readonly color: "#009081";
        readonly parsedColorOptionName: {
            readonly colorName: "greenMenthe";
            readonly brightness: {
                readonly isInvariant: true;
                readonly value: 548;
                readonly variant: "main";
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-minor-green-archipel";
    readonly themePath: readonly ["artwork", "minor", "greenArchipel", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "greenArchipel";
        readonly usage: "minor";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-archipel-main-557";
        readonly themePath: readonly ["greenArchipel", "main557", "default"];
        readonly color: "#009099";
        readonly parsedColorOptionName: {
            readonly colorName: "greenArchipel";
            readonly brightness: {
                readonly isInvariant: true;
                readonly value: 557;
                readonly variant: "main";
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-minor-blue-ecume";
    readonly themePath: readonly ["artwork", "minor", "blueEcume", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "blueEcume";
        readonly usage: "minor";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-ecume-main-400";
        readonly themePath: readonly ["blueEcume", "main400", "default"];
        readonly color: "#465f9d";
        readonly parsedColorOptionName: {
            readonly colorName: "blueEcume";
            readonly brightness: {
                readonly isInvariant: true;
                readonly value: 400;
                readonly variant: "main";
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-minor-blue-cumulus";
    readonly themePath: readonly ["artwork", "minor", "blueCumulus", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "blueCumulus";
        readonly usage: "minor";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-cumulus-main-526";
        readonly themePath: readonly ["blueCumulus", "main526", "default"];
        readonly color: "#417dc4";
        readonly parsedColorOptionName: {
            readonly colorName: "blueCumulus";
            readonly brightness: {
                readonly isInvariant: true;
                readonly value: 526;
                readonly variant: "main";
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-minor-purple-glycine";
    readonly themePath: readonly ["artwork", "minor", "purpleGlycine", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "purpleGlycine";
        readonly usage: "minor";
    };
    readonly colorOption: {
        readonly colorOptionName: "--purple-glycine-main-494";
        readonly themePath: readonly ["purpleGlycine", "main494", "default"];
        readonly color: "#a558a0";
        readonly parsedColorOptionName: {
            readonly colorName: "purpleGlycine";
            readonly brightness: {
                readonly isInvariant: true;
                readonly value: 494;
                readonly variant: "main";
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-minor-pink-macaron";
    readonly themePath: readonly ["artwork", "minor", "pinkMacaron", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "pinkMacaron";
        readonly usage: "minor";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-macaron-main-689";
        readonly themePath: readonly ["pinkMacaron", "main689", "default"];
        readonly color: "#e18b76";
        readonly parsedColorOptionName: {
            readonly colorName: "pinkMacaron";
            readonly brightness: {
                readonly isInvariant: true;
                readonly value: 689;
                readonly variant: "main";
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-minor-pink-tuile";
    readonly themePath: readonly ["artwork", "minor", "pinkTuile", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "pinkTuile";
        readonly usage: "minor";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-tuile-main-556";
        readonly themePath: readonly ["pinkTuile", "main556", "default"];
        readonly color: "#ce614a";
        readonly parsedColorOptionName: {
            readonly colorName: "pinkTuile";
            readonly brightness: {
                readonly isInvariant: true;
                readonly value: 556;
                readonly variant: "main";
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-minor-yellow-tournesol";
    readonly themePath: readonly ["artwork", "minor", "yellowTournesol", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "yellowTournesol";
        readonly usage: "minor";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-tournesol-main-731";
        readonly themePath: readonly ["yellowTournesol", "main731", "default"];
        readonly color: "#c8aa39";
        readonly parsedColorOptionName: {
            readonly colorName: "yellowTournesol";
            readonly brightness: {
                readonly isInvariant: true;
                readonly value: 731;
                readonly variant: "main";
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-minor-yellow-moutarde";
    readonly themePath: readonly ["artwork", "minor", "yellowMoutarde", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "yellowMoutarde";
        readonly usage: "minor";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-moutarde-main-679";
        readonly themePath: readonly ["yellowMoutarde", "main679", "default"];
        readonly color: "#c3992a";
        readonly parsedColorOptionName: {
            readonly colorName: "yellowMoutarde";
            readonly brightness: {
                readonly isInvariant: true;
                readonly value: 679;
                readonly variant: "main";
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-minor-orange-terre-battue";
    readonly themePath: readonly ["artwork", "minor", "orangeTerreBattue", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "orangeTerreBattue";
        readonly usage: "minor";
    };
    readonly colorOption: {
        readonly colorOptionName: "--orange-terre-battue-main-645";
        readonly themePath: readonly ["orangeTerreBattue", "main645", "default"];
        readonly color: "#e4794a";
        readonly parsedColorOptionName: {
            readonly colorName: "orangeTerreBattue";
            readonly brightness: {
                readonly isInvariant: true;
                readonly value: 645;
                readonly variant: "main";
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-minor-brown-cafe-creme";
    readonly themePath: readonly ["artwork", "minor", "brownCafeCreme", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "brownCafeCreme";
        readonly usage: "minor";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-cafe-creme-main-782";
        readonly themePath: readonly ["brownCafeCreme", "main782", "default"];
        readonly color: "#d1b781";
        readonly parsedColorOptionName: {
            readonly colorName: "brownCafeCreme";
            readonly brightness: {
                readonly isInvariant: true;
                readonly value: 782;
                readonly variant: "main";
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-minor-brown-caramel";
    readonly themePath: readonly ["artwork", "minor", "brownCaramel", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "brownCaramel";
        readonly usage: "minor";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-caramel-main-648";
        readonly themePath: readonly ["brownCaramel", "main648", "default"];
        readonly color: "#c08c65";
        readonly parsedColorOptionName: {
            readonly colorName: "brownCaramel";
            readonly brightness: {
                readonly isInvariant: true;
                readonly value: 648;
                readonly variant: "main";
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-minor-brown-opera";
    readonly themePath: readonly ["artwork", "minor", "brownOpera", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "brownOpera";
        readonly usage: "minor";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-opera-main-680";
        readonly themePath: readonly ["brownOpera", "main680", "default"];
        readonly color: "#bd987a";
        readonly parsedColorOptionName: {
            readonly colorName: "brownOpera";
            readonly brightness: {
                readonly isInvariant: true;
                readonly value: 680;
                readonly variant: "main";
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-minor-beige-gris-galet";
    readonly themePath: readonly ["artwork", "minor", "beigeGrisGalet", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "beigeGrisGalet";
        readonly usage: "minor";
    };
    readonly colorOption: {
        readonly colorOptionName: "--beige-gris-galet-main-702";
        readonly themePath: readonly ["beigeGrisGalet", "main702", "default"];
        readonly color: "#aea397";
        readonly parsedColorOptionName: {
            readonly colorName: "beigeGrisGalet";
            readonly brightness: {
                readonly isInvariant: true;
                readonly value: 702;
                readonly variant: "main";
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-decorative-grey";
    readonly themePath: readonly ["artwork", "decorative", "grey", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "grey";
        readonly usage: "decorative";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-950-100";
        readonly themePath: readonly ["grey", "_950_100", "default"];
        readonly color: {
            readonly light: "#eeeeee";
            readonly dark: "#242424";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-decorative-blue-france";
    readonly themePath: readonly ["artwork", "decorative", "blueFrance", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "blueFrance";
        readonly usage: "decorative";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-france-950-100";
        readonly themePath: readonly ["blueFrance", "_950_100", "default"];
        readonly color: {
            readonly light: "#ececfe";
            readonly dark: "#21213f";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueFrance";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-decorative-red-marianne";
    readonly themePath: readonly ["artwork", "decorative", "redMarianne", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "redMarianne";
        readonly usage: "decorative";
    };
    readonly colorOption: {
        readonly colorOptionName: "--red-marianne-950-100";
        readonly themePath: readonly ["redMarianne", "_950_100", "default"];
        readonly color: {
            readonly light: "#fee9e9";
            readonly dark: "#331f1f";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "redMarianne";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-decorative-green-tilleul-verveine";
    readonly themePath: readonly ["artwork", "decorative", "greenTilleulVerveine", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "greenTilleulVerveine";
        readonly usage: "decorative";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-tilleul-verveine-950-100";
        readonly themePath: readonly ["greenTilleulVerveine", "_950_100", "default"];
        readonly color: {
            readonly light: "#fceeac";
            readonly dark: "#272419";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenTilleulVerveine";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-decorative-green-bourgeon";
    readonly themePath: readonly ["artwork", "decorative", "greenBourgeon", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "greenBourgeon";
        readonly usage: "decorative";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-bourgeon-950-100";
        readonly themePath: readonly ["greenBourgeon", "_950_100", "default"];
        readonly color: {
            readonly light: "#c9fcac";
            readonly dark: "#1e2719";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenBourgeon";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-decorative-green-emeraude";
    readonly themePath: readonly ["artwork", "decorative", "greenEmeraude", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "greenEmeraude";
        readonly usage: "decorative";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-emeraude-950-100";
        readonly themePath: readonly ["greenEmeraude", "_950_100", "default"];
        readonly color: {
            readonly light: "#c3fad5";
            readonly dark: "#19271e";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenEmeraude";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-decorative-green-menthe";
    readonly themePath: readonly ["artwork", "decorative", "greenMenthe", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "greenMenthe";
        readonly usage: "decorative";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-menthe-950-100";
        readonly themePath: readonly ["greenMenthe", "_950_100", "default"];
        readonly color: {
            readonly light: "#bafaee";
            readonly dark: "#1a2624";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenMenthe";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-decorative-green-archipel";
    readonly themePath: readonly ["artwork", "decorative", "greenArchipel", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "greenArchipel";
        readonly usage: "decorative";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-archipel-950-100";
        readonly themePath: readonly ["greenArchipel", "_950_100", "default"];
        readonly color: {
            readonly light: "#c7f6fc";
            readonly dark: "#1a2628";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenArchipel";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-decorative-blue-ecume";
    readonly themePath: readonly ["artwork", "decorative", "blueEcume", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "blueEcume";
        readonly usage: "decorative";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-ecume-950-100";
        readonly themePath: readonly ["blueEcume", "_950_100", "default"];
        readonly color: {
            readonly light: "#e9edfe";
            readonly dark: "#1d2437";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueEcume";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-decorative-blue-cumulus";
    readonly themePath: readonly ["artwork", "decorative", "blueCumulus", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "blueCumulus";
        readonly usage: "decorative";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-cumulus-950-100";
        readonly themePath: readonly ["blueCumulus", "_950_100", "default"];
        readonly color: {
            readonly light: "#e6eefe";
            readonly dark: "#1c2433";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueCumulus";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-decorative-purple-glycine";
    readonly themePath: readonly ["artwork", "decorative", "purpleGlycine", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "purpleGlycine";
        readonly usage: "decorative";
    };
    readonly colorOption: {
        readonly colorOptionName: "--purple-glycine-950-100";
        readonly themePath: readonly ["purpleGlycine", "_950_100", "default"];
        readonly color: {
            readonly light: "#fee7fc";
            readonly dark: "#2c202b";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "purpleGlycine";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-decorative-pink-macaron";
    readonly themePath: readonly ["artwork", "decorative", "pinkMacaron", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "pinkMacaron";
        readonly usage: "decorative";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-macaron-950-100";
        readonly themePath: readonly ["pinkMacaron", "_950_100", "default"];
        readonly color: {
            readonly light: "#fee9e6";
            readonly dark: "#2e211f";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "pinkMacaron";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-decorative-pink-tuile";
    readonly themePath: readonly ["artwork", "decorative", "pinkTuile", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "pinkTuile";
        readonly usage: "decorative";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-tuile-950-100";
        readonly themePath: readonly ["pinkTuile", "_950_100", "default"];
        readonly color: {
            readonly light: "#fee9e7";
            readonly dark: "#2f211f";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "pinkTuile";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-decorative-yellow-tournesol";
    readonly themePath: readonly ["artwork", "decorative", "yellowTournesol", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "yellowTournesol";
        readonly usage: "decorative";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-tournesol-950-100";
        readonly themePath: readonly ["yellowTournesol", "_950_100", "default"];
        readonly color: {
            readonly light: "#feecc2";
            readonly dark: "#292416";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "yellowTournesol";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-decorative-yellow-moutarde";
    readonly themePath: readonly ["artwork", "decorative", "yellowMoutarde", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "yellowMoutarde";
        readonly usage: "decorative";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-moutarde-950-100";
        readonly themePath: readonly ["yellowMoutarde", "_950_100", "default"];
        readonly color: {
            readonly light: "#feebd0";
            readonly dark: "#2a2319";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "yellowMoutarde";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-decorative-orange-terre-battue";
    readonly themePath: readonly ["artwork", "decorative", "orangeTerreBattue", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "orangeTerreBattue";
        readonly usage: "decorative";
    };
    readonly colorOption: {
        readonly colorOptionName: "--orange-terre-battue-950-100";
        readonly themePath: readonly ["orangeTerreBattue", "_950_100", "default"];
        readonly color: {
            readonly light: "#fee9e5";
            readonly dark: "#31201c";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "orangeTerreBattue";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-decorative-brown-cafe-creme";
    readonly themePath: readonly ["artwork", "decorative", "brownCafeCreme", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "brownCafeCreme";
        readonly usage: "decorative";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-cafe-creme-950-100";
        readonly themePath: readonly ["brownCafeCreme", "_950_100", "default"];
        readonly color: {
            readonly light: "#f7ecdb";
            readonly dark: "#28241c";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownCafeCreme";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-decorative-brown-caramel";
    readonly themePath: readonly ["artwork", "decorative", "brownCaramel", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "brownCaramel";
        readonly usage: "decorative";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-caramel-950-100";
        readonly themePath: readonly ["brownCaramel", "_950_100", "default"];
        readonly color: {
            readonly light: "#f7ebe5";
            readonly dark: "#2c221c";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownCaramel";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-decorative-brown-opera";
    readonly themePath: readonly ["artwork", "decorative", "brownOpera", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "brownOpera";
        readonly usage: "decorative";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-opera-950-100";
        readonly themePath: readonly ["brownOpera", "_950_100", "default"];
        readonly color: {
            readonly light: "#f7ece4";
            readonly dark: "#2b221c";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownOpera";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-decorative-beige-gris-galet";
    readonly themePath: readonly ["artwork", "decorative", "beigeGrisGalet", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "beigeGrisGalet";
        readonly usage: "decorative";
    };
    readonly colorOption: {
        readonly colorOptionName: "--beige-gris-galet-950-100";
        readonly themePath: readonly ["beigeGrisGalet", "_950_100", "default"];
        readonly color: {
            readonly light: "#f3ede5";
            readonly dark: "#28231f";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "beigeGrisGalet";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 950;
                };
                readonly dark: {
                    readonly value: 100;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-background-grey";
    readonly themePath: readonly ["artwork", "background", "grey", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "grey";
        readonly usage: "background";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-975-75";
        readonly themePath: readonly ["grey", "_975_75", "default"];
        readonly color: {
            readonly light: "#f6f6f6";
            readonly dark: "#1e1e1e";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-background-blue-france";
    readonly themePath: readonly ["artwork", "background", "blueFrance", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "blueFrance";
        readonly usage: "background";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-france-975-75";
        readonly themePath: readonly ["blueFrance", "_975_75", "default"];
        readonly color: {
            readonly light: "#f5f5fe";
            readonly dark: "#1b1b35";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueFrance";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-background-red-marianne";
    readonly themePath: readonly ["artwork", "background", "redMarianne", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "redMarianne";
        readonly usage: "background";
    };
    readonly colorOption: {
        readonly colorOptionName: "--red-marianne-975-75";
        readonly themePath: readonly ["redMarianne", "_975_75", "default"];
        readonly color: {
            readonly light: "#fef4f4";
            readonly dark: "#2b1919";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "redMarianne";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-background-green-tilleul-verveine";
    readonly themePath: readonly ["artwork", "background", "greenTilleulVerveine", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "greenTilleulVerveine";
        readonly usage: "background";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-tilleul-verveine-975-75";
        readonly themePath: readonly ["greenTilleulVerveine", "_975_75", "default"];
        readonly color: {
            readonly light: "#fef7da";
            readonly dark: "#201e14";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenTilleulVerveine";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-background-green-bourgeon";
    readonly themePath: readonly ["artwork", "background", "greenBourgeon", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "greenBourgeon";
        readonly usage: "background";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-bourgeon-975-75";
        readonly themePath: readonly ["greenBourgeon", "_975_75", "default"];
        readonly color: {
            readonly light: "#e6feda";
            readonly dark: "#182014";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenBourgeon";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-background-green-emeraude";
    readonly themePath: readonly ["artwork", "background", "greenEmeraude", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "greenEmeraude";
        readonly usage: "background";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-emeraude-975-75";
        readonly themePath: readonly ["greenEmeraude", "_975_75", "default"];
        readonly color: {
            readonly light: "#e3fdeb";
            readonly dark: "#142018";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenEmeraude";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-background-green-menthe";
    readonly themePath: readonly ["artwork", "background", "greenMenthe", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "greenMenthe";
        readonly usage: "background";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-menthe-975-75";
        readonly themePath: readonly ["greenMenthe", "_975_75", "default"];
        readonly color: {
            readonly light: "#dffdf7";
            readonly dark: "#15201e";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenMenthe";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-background-green-archipel";
    readonly themePath: readonly ["artwork", "background", "greenArchipel", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "greenArchipel";
        readonly usage: "background";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-archipel-975-75";
        readonly themePath: readonly ["greenArchipel", "_975_75", "default"];
        readonly color: {
            readonly light: "#e5fbfd";
            readonly dark: "#152021";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenArchipel";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-background-blue-ecume";
    readonly themePath: readonly ["artwork", "background", "blueEcume", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "blueEcume";
        readonly usage: "background";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-ecume-975-75";
        readonly themePath: readonly ["blueEcume", "_975_75", "default"];
        readonly color: {
            readonly light: "#f4f6fe";
            readonly dark: "#171d2f";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueEcume";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-background-blue-cumulus";
    readonly themePath: readonly ["artwork", "background", "blueCumulus", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "blueCumulus";
        readonly usage: "background";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-cumulus-975-75";
        readonly themePath: readonly ["blueCumulus", "_975_75", "default"];
        readonly color: {
            readonly light: "#f3f6fe";
            readonly dark: "#171e2b";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueCumulus";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-background-purple-glycine";
    readonly themePath: readonly ["artwork", "background", "purpleGlycine", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "purpleGlycine";
        readonly usage: "background";
    };
    readonly colorOption: {
        readonly colorOptionName: "--purple-glycine-975-75";
        readonly themePath: readonly ["purpleGlycine", "_975_75", "default"];
        readonly color: {
            readonly light: "#fef3fd";
            readonly dark: "#251a24";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "purpleGlycine";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-background-pink-macaron";
    readonly themePath: readonly ["artwork", "background", "pinkMacaron", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "pinkMacaron";
        readonly usage: "background";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-macaron-975-75";
        readonly themePath: readonly ["pinkMacaron", "_975_75", "default"];
        readonly color: {
            readonly light: "#fef4f2";
            readonly dark: "#261b19";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "pinkMacaron";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-background-pink-tuile";
    readonly themePath: readonly ["artwork", "background", "pinkTuile", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "pinkTuile";
        readonly usage: "background";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-tuile-975-75";
        readonly themePath: readonly ["pinkTuile", "_975_75", "default"];
        readonly color: {
            readonly light: "#fef4f3";
            readonly dark: "#281b19";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "pinkTuile";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-background-yellow-tournesol";
    readonly themePath: readonly ["artwork", "background", "yellowTournesol", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "yellowTournesol";
        readonly usage: "background";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-tournesol-975-75";
        readonly themePath: readonly ["yellowTournesol", "_975_75", "default"];
        readonly color: {
            readonly light: "#fef6e3";
            readonly dark: "#221d11";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "yellowTournesol";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-background-yellow-moutarde";
    readonly themePath: readonly ["artwork", "background", "yellowMoutarde", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "yellowMoutarde";
        readonly usage: "background";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-moutarde-975-75";
        readonly themePath: readonly ["yellowMoutarde", "_975_75", "default"];
        readonly color: {
            readonly light: "#fef5e8";
            readonly dark: "#231d14";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "yellowMoutarde";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-background-orange-terre-battue";
    readonly themePath: readonly ["artwork", "background", "orangeTerreBattue", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "orangeTerreBattue";
        readonly usage: "background";
    };
    readonly colorOption: {
        readonly colorOptionName: "--orange-terre-battue-975-75";
        readonly themePath: readonly ["orangeTerreBattue", "_975_75", "default"];
        readonly color: {
            readonly light: "#fef4f2";
            readonly dark: "#281a16";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "orangeTerreBattue";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-background-brown-cafe-creme";
    readonly themePath: readonly ["artwork", "background", "brownCafeCreme", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "brownCafeCreme";
        readonly usage: "background";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-cafe-creme-975-75";
        readonly themePath: readonly ["brownCafeCreme", "_975_75", "default"];
        readonly color: {
            readonly light: "#fbf6ed";
            readonly dark: "#211d16";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownCafeCreme";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-background-brown-caramel";
    readonly themePath: readonly ["artwork", "background", "brownCaramel", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "brownCaramel";
        readonly usage: "background";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-caramel-975-75";
        readonly themePath: readonly ["brownCaramel", "_975_75", "default"];
        readonly color: {
            readonly light: "#fbf5f2";
            readonly dark: "#251c16";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownCaramel";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-background-brown-opera";
    readonly themePath: readonly ["artwork", "background", "brownOpera", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "brownOpera";
        readonly usage: "background";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-opera-975-75";
        readonly themePath: readonly ["brownOpera", "_975_75", "default"];
        readonly color: {
            readonly light: "#fbf5f2";
            readonly dark: "#241c17";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownOpera";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-background-beige-gris-galet";
    readonly themePath: readonly ["artwork", "background", "beigeGrisGalet", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "beigeGrisGalet";
        readonly usage: "background";
    };
    readonly colorOption: {
        readonly colorOptionName: "--beige-gris-galet-975-75";
        readonly themePath: readonly ["beigeGrisGalet", "_975_75", "default"];
        readonly color: {
            readonly light: "#f9f6f2";
            readonly dark: "#211d19";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "beigeGrisGalet";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 975;
                };
                readonly dark: {
                    readonly value: 75;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-motif-grey";
    readonly themePath: readonly ["artwork", "motif", "grey", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "grey";
        readonly usage: "motif";
    };
    readonly colorOption: {
        readonly colorOptionName: "--grey-925-125";
        readonly themePath: readonly ["grey", "_925_125", "default"];
        readonly color: {
            readonly light: "#e5e5e5";
            readonly dark: "#2a2a2a";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "grey";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-motif-blue-france";
    readonly themePath: readonly ["artwork", "motif", "blueFrance", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "blueFrance";
        readonly usage: "motif";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-france-925-125";
        readonly themePath: readonly ["blueFrance", "_925_125", "default"];
        readonly color: {
            readonly light: "#e3e3fd";
            readonly dark: "#272747";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueFrance";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-motif-red-marianne";
    readonly themePath: readonly ["artwork", "motif", "redMarianne", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "redMarianne";
        readonly usage: "motif";
    };
    readonly colorOption: {
        readonly colorOptionName: "--red-marianne-925-125";
        readonly themePath: readonly ["redMarianne", "_925_125", "default"];
        readonly color: {
            readonly light: "#fddede";
            readonly dark: "#3b2424";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "redMarianne";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-motif-green-tilleul-verveine";
    readonly themePath: readonly ["artwork", "motif", "greenTilleulVerveine", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "greenTilleulVerveine";
        readonly usage: "motif";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-tilleul-verveine-925-125";
        readonly themePath: readonly ["greenTilleulVerveine", "_925_125", "default"];
        readonly color: {
            readonly light: "#fbe769";
            readonly dark: "#2d2a1d";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenTilleulVerveine";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-motif-green-bourgeon";
    readonly themePath: readonly ["artwork", "motif", "greenBourgeon", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "greenBourgeon";
        readonly usage: "motif";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-bourgeon-925-125";
        readonly themePath: readonly ["greenBourgeon", "_925_125", "default"];
        readonly color: {
            readonly light: "#a9fb68";
            readonly dark: "#232d1d";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenBourgeon";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-motif-green-emeraude";
    readonly themePath: readonly ["artwork", "motif", "greenEmeraude", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "greenEmeraude";
        readonly usage: "motif";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-emeraude-925-125";
        readonly themePath: readonly ["greenEmeraude", "_925_125", "default"];
        readonly color: {
            readonly light: "#9ef9be";
            readonly dark: "#1e2e23";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenEmeraude";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-motif-green-menthe";
    readonly themePath: readonly ["artwork", "motif", "greenMenthe", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "greenMenthe";
        readonly usage: "motif";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-menthe-925-125";
        readonly themePath: readonly ["greenMenthe", "_925_125", "default"];
        readonly color: {
            readonly light: "#8bf8e7";
            readonly dark: "#1f2d2a";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenMenthe";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-motif-green-archipel";
    readonly themePath: readonly ["artwork", "motif", "greenArchipel", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "greenArchipel";
        readonly usage: "motif";
    };
    readonly colorOption: {
        readonly colorOptionName: "--green-archipel-925-125";
        readonly themePath: readonly ["greenArchipel", "_925_125", "default"];
        readonly color: {
            readonly light: "#a6f2fa";
            readonly dark: "#1f2c2e";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "greenArchipel";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-motif-blue-ecume";
    readonly themePath: readonly ["artwork", "motif", "blueEcume", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "blueEcume";
        readonly usage: "motif";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-ecume-925-125";
        readonly themePath: readonly ["blueEcume", "_925_125", "default"];
        readonly color: {
            readonly light: "#dee5fd";
            readonly dark: "#222940";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueEcume";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-motif-blue-cumulus";
    readonly themePath: readonly ["artwork", "motif", "blueCumulus", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "blueCumulus";
        readonly usage: "motif";
    };
    readonly colorOption: {
        readonly colorOptionName: "--blue-cumulus-925-125";
        readonly themePath: readonly ["blueCumulus", "_925_125", "default"];
        readonly color: {
            readonly light: "#dae6fd";
            readonly dark: "#212a3a";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "blueCumulus";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-motif-purple-glycine";
    readonly themePath: readonly ["artwork", "motif", "purpleGlycine", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "purpleGlycine";
        readonly usage: "motif";
    };
    readonly colorOption: {
        readonly colorOptionName: "--purple-glycine-925-125";
        readonly themePath: readonly ["purpleGlycine", "_925_125", "default"];
        readonly color: {
            readonly light: "#fddbfa";
            readonly dark: "#332632";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "purpleGlycine";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-motif-pink-macaron";
    readonly themePath: readonly ["artwork", "motif", "pinkMacaron", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "pinkMacaron";
        readonly usage: "motif";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-macaron-925-125";
        readonly themePath: readonly ["pinkMacaron", "_925_125", "default"];
        readonly color: {
            readonly light: "#fddfda";
            readonly dark: "#352724";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "pinkMacaron";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-motif-pink-tuile";
    readonly themePath: readonly ["artwork", "motif", "pinkTuile", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "pinkTuile";
        readonly usage: "motif";
    };
    readonly colorOption: {
        readonly colorOptionName: "--pink-tuile-925-125";
        readonly themePath: readonly ["pinkTuile", "_925_125", "default"];
        readonly color: {
            readonly light: "#fddfdb";
            readonly dark: "#372624";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "pinkTuile";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-motif-yellow-tournesol";
    readonly themePath: readonly ["artwork", "motif", "yellowTournesol", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "yellowTournesol";
        readonly usage: "motif";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-tournesol-925-125";
        readonly themePath: readonly ["yellowTournesol", "_925_125", "default"];
        readonly color: {
            readonly light: "#fde39c";
            readonly dark: "#302a1a";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "yellowTournesol";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-motif-yellow-moutarde";
    readonly themePath: readonly ["artwork", "motif", "yellowMoutarde", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "yellowMoutarde";
        readonly usage: "motif";
    };
    readonly colorOption: {
        readonly colorOptionName: "--yellow-moutarde-925-125";
        readonly themePath: readonly ["yellowMoutarde", "_925_125", "default"];
        readonly color: {
            readonly light: "#fde2b5";
            readonly dark: "#30291d";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "yellowMoutarde";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-motif-orange-terre-battue";
    readonly themePath: readonly ["artwork", "motif", "orangeTerreBattue", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "orangeTerreBattue";
        readonly usage: "motif";
    };
    readonly colorOption: {
        readonly colorOptionName: "--orange-terre-battue-925-125";
        readonly themePath: readonly ["orangeTerreBattue", "_925_125", "default"];
        readonly color: {
            readonly light: "#fddfd8";
            readonly dark: "#382621";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "orangeTerreBattue";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-motif-brown-cafe-creme";
    readonly themePath: readonly ["artwork", "motif", "brownCafeCreme", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "brownCafeCreme";
        readonly usage: "motif";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-cafe-creme-925-125";
        readonly themePath: readonly ["brownCafeCreme", "_925_125", "default"];
        readonly color: {
            readonly light: "#f4e3c7";
            readonly dark: "#2e2a21";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownCafeCreme";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-motif-brown-caramel";
    readonly themePath: readonly ["artwork", "motif", "brownCaramel", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "brownCaramel";
        readonly usage: "motif";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-caramel-925-125";
        readonly themePath: readonly ["brownCaramel", "_925_125", "default"];
        readonly color: {
            readonly light: "#f3e2d9";
            readonly dark: "#332821";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownCaramel";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-motif-brown-opera";
    readonly themePath: readonly ["artwork", "motif", "brownOpera", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "brownOpera";
        readonly usage: "motif";
    };
    readonly colorOption: {
        readonly colorOptionName: "--brown-opera-925-125";
        readonly themePath: readonly ["brownOpera", "_925_125", "default"];
        readonly color: {
            readonly light: "#f3e2d7";
            readonly dark: "#322821";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "brownOpera";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
        };
    };
}, {
    readonly colorDecisionName: "--artwork-motif-beige-gris-galet";
    readonly themePath: readonly ["artwork", "motif", "beigeGrisGalet", "default"];
    readonly parsedColorDecisionName: {
        readonly context: "artwork";
        readonly colorName: "beigeGrisGalet";
        readonly usage: "motif";
    };
    readonly colorOption: {
        readonly colorOptionName: "--beige-gris-galet-925-125";
        readonly themePath: readonly ["beigeGrisGalet", "_925_125", "default"];
        readonly color: {
            readonly light: "#eee4d9";
            readonly dark: "#2e2924";
        };
        readonly parsedColorOptionName: {
            readonly colorName: "beigeGrisGalet";
            readonly brightness: {
                readonly isInvariant: false;
                readonly light: {
                    readonly value: 925;
                };
                readonly dark: {
                    readonly value: 125;
                };
            };
        };
    };
}];
